c MPPL  = /usr/local/basis/vbasis/bin/mppl
c mppl  -r8 -i4
c     -DNO_INCLUDES=1
c     -I.
c     -I.
c     -I..
c     -I/mfe/workspace/meyer8/cvsstuff/pyUedge/uedge/dev/lnx-2.17-o/include
c     -I/usr/local/basis/vbasis/include
c     -I/usr/local/pact/pact04_05_11/include
c     /usr/local/basis/vbasis/include/basis-m-defs.d
c     /mfe/workspace/meyer8/cvsstuff/pyUedge/uedge/dev/lnx-2.17-o/include/xuedge-m-defs.d
c     ../../sptodp
c     /mfe/workspace/meyer8/cvsstuff/pyUedge/uedge/dev/lnx-2.17-o/include/svr.d
c     ./../daspk.m
c
c BASIS-M-DEFS.D - configured MPPL language defines
c                - This file is generated - do not edit
c



c
c XUEDGE-M-DEFS.D - configured MPPL language defines
c                - This file is generated - do not edit
c












































c!include "../mppl.h"
c!include "../sptodp.h"
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SDASPK (RES, NEQ, T, Y, YPRIME, TOUT, INFO, RTOL, ATOL, 
     &   IDID, RWORK, LRW, IWORK, LIW, RPAR, IPAR, JAC, PSOL, scalpk)
c
c***BEGIN PROLOGUE  SDASPK
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  910624
c***REVISION DATE  920929   (CJ in RES call, RES counter fix.)
c***REVISION DATE  921215   (Warnings on poor iteration performance)
c***REVISION DATE  921216   (NRMAX as optional input)
c***REVISION DATE  930315   (Name change: DDINI to DDINIT)
c***REVISION DATE  940822   (Replaced initial condition calculation)
c***REVISION DATE  941101   (Added linesearch in I.C. calculations)
c***REVISION DATE  941220   (Misc. corrections throughout)
c***REVISION DATE  950125   (Added SINVWT routine)
c***REVISION DATE  950714   (Misc. corrections throughout)
c***REVISION DATE  950802   (Default NRMAX = 5, based on tests.)
c***REVISION DATE  950808   (Optional error test added.)
c***REVISION DATE  950814   (Added I.C. constraints and INFO(14))
c***REVISION DATE  950824   (Converted from double to single precision.)
c***REVISION DATE  950828   (Various minor corrections.)
c***REVISION DATE  951006   (Corrected WT scaling in SFNRMK.)
c***REVISION DATE  960401   (Corrected RL undefined in SLINSK and SLINSD.)
c***REVISION DATE  960418   (Added optional input EPNL when INFO(13)=1.)
c***CATEGORY NO.  I1A2
c***KEYWORDS  DIFFERENTIAL/ALGEBRAIC, BACKWARD DIFFERENTIATION FORMULAS,
c             IMPLICIT DIFFERENTIAL SYSTEMS, KRYLOV ITERATION
c***AUTHORS   Linda R. Petzold, Peter N. Brown, Alan C. Hindmarsh, and
c                  Clement W. Ulrich
c             Center for Computational Sciences & Engineering, L-316
c             Lawrence Livermore National Laboratory
c             P.O. Box 808,
c             Livermore, CA 94551
c***PURPOSE  This code solves a system of differential/algebraic
c            equations of the form
c               G(t,y,y') = 0 ,
c            using a combination of Backward Differentiation Formula
c            (BDF) methods and a choice of two linear system solution
c            methods: direct (dense or band) or Krylov (iterative).
c            This version is in single precision.
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c *Usage:
c
c      IMPLICIT real(A-H,O-Z)
c      INTEGER NEQ, INFO(N), IDID, LRW, LIW, IWORK(LIW), IPAR(*)
c      real T, Y(*), YPRIME(*), TOUT, RTOL(*), ATOL(*),
c         RWORK(LRW), RPAR(*)
c      EXTERNAL  RES, JAC, PSOL
c
c      CALL SDASPK (RES, NEQ, T, Y, YPRIME, TOUT, INFO, RTOL, ATOL,
c     *   IDID, RWORK, LRW, IWORK, LIW, RPAR, IPAR, JAC, PSOL)
c
c  Quantities which may be altered by the code are:
c     T, Y(*), YPRIME(*), INFO(1), RTOL, ATOL, IDID, RWORK(*), IWORK(*)
c
c
c *Arguments:
c
c  RES:EXT          This is the name of a subroutine which you
c                   provide to define the residual function G(t,y,y')
c                   of the differential/algebraic system.
c
c  NEQ:IN           This is the number of equations in the system.
c
c  T:INOUT          This is the current value of the independent
c                   variable.
c
c  Y(*):INOUT       This array contains the solution components at T.
c
c  YPRIME(*):INOUT  This array contains the derivatives of the solution
c                   components at T.
c
c  TOUT:IN          This is a point at which a solution is desired.
c
c  INFO(N):IN       This is an integer array used to communicate details
c                   of how the solution is to be carried out, such as
c                   tolerance type, matrix structure, step size and
c                   order limits, and choice of nonlinear system method.
c                   N must be at least 20.
c
c  RTOL,ATOL:INOUT  These quantities represent absolute and relative
c                   error tolerances (on local error) which you provide
c                   to indicate how accurately you wish the solution to
c                   be computed.  You may choose them to be both scalars
c                   or else both arrays of length NEQ.
c
c  IDID:OUT         This integer scalar is an indicator reporting what
c                   the code did.  You must monitor this variable to
c                   decide what action to take next.
c
c  RWORK:WORK       A real work array of length LRW which provides the
c                   code with needed storage space.
c
c  LRW:IN           The length of RWORK.
c
c  IWORK:WORK       An integer work array of length LIW which provides
c                   the code with needed storage space.
c
c  LIW:IN           The length of IWORK.
c
c  RPAR,IPAR:IN     These are real and integer parameter arrays which
c                   you can use for communication between your calling
c                   program and the RES, JAC, and PSOL subroutines.
c
c  scalpk:in        This parameter is introduced (by Tom Rognlien and
c                   Jose Milovich) to compensate for large rtol in the
c                   calculation of the preconditioner in the routine SATV
c
c  JAC:EXT          This is the name of a subroutine which you may
c                   provide (optionally) for calculating Jacobian
c                   (partial derivative) data involved in solving linear
c                   systems within SDASPK.
c
c  PSOL:EXT         This is the name of a subroutine which you must
c                   provide for solving linear systems if you selected
c                   a Krylov method.  The purpose of PSOL is to solve
c                   linear systems involving a left preconditioner P.
c
c *Overview
c
c  The SDASPK solver uses the backward differentiation formulas of
c  orders one through five to solve a system of the form G(t,y,y') = 0
c  for y = Y and y' = YPRIME.  Values for Y and YPRIME at the initial
c  time must be given as input.  These values should be consistent,
c  that is, if T, Y, YPRIME are the given initial values, they should
c  satisfy G(T,Y,YPRIME) = 0.  However, if consistent values are not
c  known, in many cases you can have SDASPK solve for them -- see INFO(11).
c  (This and other options are described in more detail below.)
c
c  Normally, SDASPK solves the system from T to TOUT.  It is easy to
c  continue the solution to get results at additional TOUT.  This is
c  the interval mode of operation.  Intermediate results can also be
c  obtained easily by specifying INFO(3).
c
c  On each step taken by SDASPK, a sequence of nonlinear algebraic
c  systems arises.  These are solved by one of two types of
c  methods:
c    * a Newton iteration with a direct method for the linear
c      systems involved (INFO(12) = 0), or
c    * a Newton iteration with a preconditioned Krylov iterative
c      method for the linear systems involved (INFO(12) = 1).
c
c  The direct method choices are dense and band matrix solvers,
c  with either a user-supplied or an internal difference quotient
c  Jacobian matrix, as specified by INFO(5) and INFO(6).
c  In the band case, INFO(6) = 1, you must supply half-bandwidths
c  in IWORK(1) and IWORK(2).
c
c  The Krylov method is the Generalized Minimum Residual (GMRES)
c  method, in either complete or incomplete form, and with
c  scaling and preconditioning.  The method is implemented
c  in an algorithm called SPIGMR.  Certain options in the Krylov
c  method case are specified by INFO(13) and INFO(15).
c
c  If the Krylov method is chosen, you may supply a pair of routines,
c  JAC and PSOL, to apply preconditioning to the linear system.
c  If the system is A*x = b, the matrix is A = dG/dY + CJ*dG/dYPRIME
c  (of order NEQ).  This system can then be preconditioned in the form
c  (P-inverse)*A*x = (P-inverse)*b, with left preconditioner P.
c  (SDASPK does not allow right preconditioning.)
c  Then the Krylov method is applied to this altered, but equivalent,
c  linear system, hopefully with much better performance than without
c  preconditioning.  (In addition, a diagonal scaling matrix based on
c  the tolerances is also introduced into the altered system.)
c
c  The JAC routine evaluates any data needed for solving systems
c  with coefficient matrix P, and PSOL carries out that solution.
c  In any case, in order to improve convergence, you should try to
c  make P approximate the matrix A as much as possible, while keeping
c  the system P*x = b reasonably easy and inexpensive to solve for x,
c  given a vector b.
c
c
c *Description
c
c------INPUT - WHAT TO DO ON THE FIRST CALL TO SDASPK-------------------
c
c
c  The first call of the code is defined to be the start of each new
c  problem.  Read through the descriptions of all the following items,
c  provide sufficient storage space for designated arrays, set
c  appropriate variables for the initialization of the problem, and
c  give information about how you want the problem to be solved.
c
c
c  RES -- Provide a subroutine of the form
c
c             SUBROUTINE RES (T, Y, YPRIME, CJ, DELTA, IRES, RPAR, IPAR)
c
c         to define the system of differential/algebraic
c         equations which is to be solved. For the given values
c         of T, Y and YPRIME, the subroutine should return
c         the residual of the differential/algebraic system
c             DELTA = G(T,Y,YPRIME)
c         DELTA is a vector of length NEQ which is output from RES.
c
c         Subroutine RES must not alter T, Y, YPRIME, or CJ.
c         You must declare the name RES in an EXTERNAL
c         statement in your program that calls SDASPK.
c         You must dimension Y, YPRIME, and DELTA in RES.
c
c         The input argument CJ can be ignored, or used to rescale
c         constraint equations in the system (see Ref. 2, p. 145).
c         Note: In this respect, SDASPK is not downward-compatible
c         with SDASSL, which does not have the RES argument CJ.
c
c         IRES is an integer flag which is always equal to zero
c         on input.  Subroutine RES should alter IRES only if it
c         encounters an illegal value of Y or a stop condition.
c         Set IRES = -1 if an input value is illegal, and SDASPK
c         will try to solve the problem without getting IRES = -1.
c         If IRES = -2, SDASPK will return control to the calling
c         program with IDID = -11.
c
c         RPAR and IPAR are real and integer parameter arrays which
c         you can use for communication between your calling program
c         and subroutine RES. They are not altered by SDASPK. If you
c         do not need RPAR or IPAR, ignore these parameters by treat-
c         ing them as dummy arguments. If you do choose to use them,
c         dimension them in your calling program and in RES as arrays
c         of appropriate length.
c
c  NEQ -- Set it to the number of equations in the system (NEQ .GE. 1).
c
c  T -- Set it to the initial point of the integration. (T must be
c       a variable.)
c
c  Y(*) -- Set this array to the initial values of the NEQ solution
c          components at the initial point.  You must dimension Y of
c          length at least NEQ in your calling program.
c
c  YPRIME(*) -- Set this array to the initial values of the NEQ first
c               derivatives of the solution components at the initial
c               point.  You must dimension YPRIME at least NEQ in your
c               calling program.
c
c  TOUT - Set it to the first point at which a solution is desired.
c         You cannot take TOUT = T.  Integration either forward in T
c         (TOUT .GT. T) or backward in T (TOUT .LT. T) is permitted.
c
c         The code advances the solution from T to TOUT using step
c         sizes which are automatically selected so as to achieve the
c         desired accuracy.  If you wish, the code will return with the
c         solution and its derivative at intermediate steps (the
c         intermediate-output mode) so that you can monitor them,
c         but you still must provide TOUT in accord with the basic
c         aim of the code.
c
c         The first step taken by the code is a critical one because
c         it must reflect how fast the solution changes near the
c         initial point.  The code automatically selects an initial
c         step size which is practically always suitable for the
c         problem.  By using the fact that the code will not step past
c         TOUT in the first step, you could, if necessary, restrict the
c         length of the initial step.
c
c         For some problems it may not be permissible to integrate
c         past a point TSTOP, because a discontinuity occurs there
c         or the solution or its derivative is not defined beyond
c         TSTOP.  When you have declared a TSTOP point (see INFO(4)
c         and RWORK(1)), you have told the code not to integrate past
c         TSTOP.  In this case any tout beyond TSTOP is invalid input.
c
c  INFO(*) - Use the INFO array to give the code more details about
c            how you want your problem solved.  This array should be
c            dimensioned of length 20, though SDASPK uses only the
c            first 15 entries.  You must respond to all of the following
c            items, which are arranged as questions.  The simplest use
c            of SDASPK corresponds to setting all entries of INFO to 0.
c
c       INFO(1) - This parameter enables the code to initialize itself.
c              You must set it to indicate the start of every new
c              problem.
c
c          **** Is this the first call for this problem ...
c                yes - set INFO(1) = 0
c                 no - not applicable here.
c                      See below for continuation calls.  ****
c
c       INFO(2) - How much accuracy you want of your solution
c              is specified by the error tolerances RTOL and ATOL.
c              The simplest use is to take them both to be scalars.
c              To obtain more flexibility, they can both be arrays.
c              The code must be told your choice.
c
c          **** Are both error tolerances RTOL, ATOL scalars ...
c                yes - set INFO(2) = 0
c                      and input scalars for both RTOL and ATOL
c                 no - set INFO(2) = 1
c                      and input arrays for both RTOL and ATOL ****
c
c       INFO(3) - The code integrates from T in the direction of TOUT
c              by steps.  If you wish, it will return the computed
c              solution and derivative at the next intermediate step
c              (the intermediate-output mode) or TOUT, whichever comes
c              first.  This is a good way to proceed if you want to
c              see the behavior of the solution.  If you must have
c              solutions at a great many specific TOUT points, this
c              code will compute them efficiently.
c
c          **** Do you want the solution only at
c               TOUT (and not at the next intermediate step) ...
c                yes - set INFO(3) = 0
c                 no - set INFO(3) = 1 ****
c
c       INFO(4) - To handle solutions at a great many specific
c              values TOUT efficiently, this code may integrate past
c              TOUT and interpolate to obtain the result at TOUT.
c              Sometimes it is not possible to integrate beyond some
c              point TSTOP because the equation changes there or it is
c              not defined past TSTOP.  Then you must tell the code
c              this stop condition.
c
c           **** Can the integration be carried out without any
c                restrictions on the independent variable T ...
c                 yes - set INFO(4) = 0
c                  no - set INFO(4) = 1
c                       and define the stopping point TSTOP by
c                       setting RWORK(1) = TSTOP ****
c
c       INFO(5) - used only when INFO(12) = 0 (direct methods).
c              To solve differential/algebraic systems you may wish
c              to use a matrix of partial derivatives of the
c              system of differential equations.  If you do not
c              provide a subroutine to evaluate it analytically (see
c              description of the item JAC in the call list), it will
c              be approximated by numerical differencing in this code.
c              Although it is less trouble for you to have the code
c              compute partial derivatives by numerical differencing,
c              the solution will be more reliable if you provide the
c              derivatives via JAC.  Usually numerical differencing is
c              more costly than evaluating derivatives in JAC, but
c              sometimes it is not - this depends on your problem.
c
c           **** Do you want the code to evaluate the partial deriv-
c                atives automatically by numerical differences ...
c                 yes - set INFO(5) = 0
c                  no - set INFO(5) = 1
c                       and provide subroutine JAC for evaluating the
c                       matrix of partial derivatives ****
c
c       INFO(6) - used only when INFO(12) = 0 (direct methods).
c              SDASPK will perform much better if the matrix of
c              partial derivatives, dG/dY + CJ*dG/dYPRIME (here CJ is
c              a scalar determined by SDASPK), is banded and the code
c              is told this.  In this case, the storage needed will be
c              greatly reduced, numerical differencing will be performed
c              much cheaper, and a number of important algorithms will
c              execute much faster.  The differential equation is said
c              to have half-bandwidths ML (lower) and MU (upper) if
c              equation i involves only unknowns Y(j) with
c                             i-ML .le. j .le. i+MU .
c              For all i=1,2,...,NEQ.  Thus, ML and MU are the widths
c              of the lower and upper parts of the band, respectively,
c              with the main diagonal being excluded.  If you do not
c              indicate that the equation has a banded matrix of partial
c              derivatives the code works with a full matrix of NEQ**2
c              elements (stored in the conventional way).  Computations
c              with banded matrices cost less time and storage than with
c              full matrices if  2*ML+MU .lt. NEQ.  If you tell the
c              code that the matrix of partial derivatives has a banded
c              structure and you want to provide subroutine JAC to
c              compute the partial derivatives, then you must be careful
c              to store the elements of the matrix in the special form
c              indicated in the description of JAC.
c
c          **** Do you want to solve the problem using a full (dense)
c               matrix (and not a special banded structure) ...
c                yes - set INFO(6) = 0
c                 no - set INFO(6) = 1
c                       and provide the lower (ML) and upper (MU)
c                       bandwidths by setting
c                       IWORK(1)=ML
c                       IWORK(2)=MU ****
c
c       INFO(7) - You can specify a maximum (absolute value of)
c              stepsize, so that the code will avoid passing over very
c              large regions.
c
c          ****  Do you want the code to decide on its own the maximum
c                stepsize ...
c                 yes - set INFO(7) = 0
c                  no - set INFO(7) = 1
c                       and define HMAX by setting
c                       RWORK(2) = HMAX ****
c
c       INFO(8) -  Differential/algebraic problems may occasionally
c              suffer from severe scaling difficulties on the first
c              step.  If you know a great deal about the scaling of
c              your problem, you can help to alleviate this problem
c              by specifying an initial stepsize H0.
c
c          ****  Do you want the code to define its own initial
c                stepsize ...
c                 yes - set INFO(8) = 0
c                  no - set INFO(8) = 1
c                       and define H0 by setting
c                       RWORK(3) = H0 ****
c
c       INFO(9) -  If storage is a severe problem, you can save some
c              storage by restricting the maximum method order MAXORD.
c              The default value is 5.  For each order decrease below 5,
c              the code requires NEQ fewer locations, but it is likely
c              to be slower.  In any case, you must have
c              1 .le. MAXORD .le. 5.
c          ****  Do you want the maximum order to default to 5 ...
c                 yes - set INFO(9) = 0
c                  no - set INFO(9) = 1
c                       and define MAXORD by setting
c                       IWORK(3) = MAXORD ****
c
c       INFO(10) - If you know that certain components of the
c              solutions to your equations are always nonnegative
c              (or nonpositive), it may help to set this
c              parameter.  There are three options that are
c              available:
c              1.  To have constraint checking only in the initial
c                  condition calculation.
c              2.  To enforce nonnegativity in Y during the integration.
c              3.  To enforce both options 1 and 2.
c
c              When selecting option 2 or 3, it is probably best to try the
c              code without using this option first, and only use
c              this option if that does not work very well.
c
c          ****  Do you want the code to solve the problem without
c                invoking any special inequality constraints ...
c                 yes - set INFO(10) = 0
c                  no - set INFO(10) = 1 to have option 1 enforced
c                  no - set INFO(10) = 2 to have option 2 enforced
c                  no - set INFO(10) = 3 to have option 3 enforced ****
c
c                  If you have specified INFO(10) = 1 or 3, then you
c                  will also need to identify how each component of Y
c                  in the initial condition calculation is constrained.
c                  You must set:
c                  IWORK(40+I) = +1 if Y(I) must be .GE. 0,
c                  IWORK(40+I) = +2 if Y(I) must be .GT. 0,
c                  IWORK(40+I) = -1 if Y(I) must be .LE. 0, while
c                  IWORK(40+I) = -2 if Y(I) must be .LT. 0, while
c                  IWORK(40+I) =  0 if Y(I) is not constrained.
c
c       INFO(11) - SDASPK normally requires the initial T, Y, and
c              YPRIME to be consistent.  That is, you must have
c              G(T,Y,YPRIME) = 0 at the initial T.  If you do not know
c              the initial conditions precisely, in some cases
c              SDASPK may be able to compute it.
c
c              Denoting the differential variables in Y by Y_d
c              and the algebraic variables by Y_a, SDASPK can solve
c              one of two initialization problems:
c              1.  Given Y_d, calculate Y_a and Y'_d, or
c              2.  Given Y', calculate Y.
c              In either case, initial values for the given
c              components are input, and initial guesses for
c              the unknown components must also be provided as input.
c
c          ****  Are the initial T, Y, YPRIME consistent ...
c
c                 yes - set INFO(11) = 0
c                  no - set INFO(11) = 1 to calculate option 1 above,
c                    or set INFO(11) = 2 to calculate option 2 ****
c
c                  If you have specified INFO(11) = 1, then you
c                  will also need to identify  which are the
c                  differential and which are the algebraic
c                  components (algebraic components are components
c                  whose derivatives do not appear explicitly
c                  in the function G(T,Y,YPRIME)).  You must set:
c                  IWORK(LID+I) = +1 if Y(I) is a differential variable
c                  IWORK(LID+I) = -1 if Y(I) is an algebraic variable,
c                  where LID = 40 if INFO(10) = 0 or 2 and LID = 40+NEQ
c                  if INFO(10) = 1 or 3.
c
c       INFO(12) - Except for the addition of the RES argument CJ,
c              SDASPK by default is downward-compatible with SDASSL,
c              which uses only direct (dense or band) methods to solve
c              the linear systems involved.  You must set INFO(12) to
c              indicate whether you want the direct methods or the
c              Krylov iterative method.
c          ****   Do you want SDASPK to use standard direct methods
c                 (dense or band) or the Krylov (iterative) method ...
c                   direct methods - set INFO(12) = 0.
c                   Krylov method  - set INFO(12) = 1,
c                       and check the settings of INFO(13) and INFO(15).
c
c       INFO(13) - used for optional inputs to both direct and Krylov
c              method cases (INFO(12) = 0 or 1).  When INFO(12) = 0
c              or 1, EPNL is used as a swing factor in the Newton
c              iteration convergence test.  When INFO(12) = 1,
c              SDASPK uses scalars MAXL, KMP, NRMAX, and EPLI for the
c              iterative solution of linear systems.  INFO(13) allows
c              you to override the default values of these parameters.
c              These parameters and their defaults are as follows:
c              For INFO(12) = 0 or 1,
c              EPNL = swing factor in the Newton iteration convergence
c                 test.  The test is applied to the residual vector,
c                 premultiplied by the approximate Jacobian (in the
c                 direct case) or the preconditioner (in the Krylov
c                 case).  For convergence, the weighted RMS norm of
c                 this vector (scaled by the error weights) must be
c                 less than EPNL*EPCON, where EPCON = .33 is the
c                 analogous test constant used in the time steps.
c                 The default is EPNL = 1.
c              For INFO(12) = 1,
c              MAXL = maximum number of iterations in the SPIGMR
c                 algorithm (MAXL .le. NEQ).  The default is
c                 MAXL = MIN(5,NEQ).
c              KMP = number of vectors on which orthogonalization is
c                 done in the SPIGMR algorithm.  The default is
c                 KMP = MAXL, which corresponds to complete GMRES
c                 iteration, as opposed to the incomplete form.
c              NRMAX = maximum number of restarts of the SPIGMR
c                 algorithm per nonlinear iteration.  The default is
c                 NRMAX = 5.
c              EPLI = convergence test constant in SPIGMR algorithm.
c                 The default is EPLI = 0.05.
c              Note that the length of RWORK depends on both MAXL
c              and KMP.  See the definition of LRW below.
c          ****   Are EPNL, MAXL, KMP, and EPLI to be given their
c                 default values ...
c                  yes - set INFO(13) = 0
c                   no - set INFO(13) = 1,
c                        and set all of the following:
c                        RWORK(16) = EPNL (.GT. 0.0)  ****
c                        IWORK(24) = MAXL (1 .le. MAXL .le. NEQ)
c                        IWORK(25) = KMP  (1 .le. KMP .le. MAXL)
c                        IWORK(26) = NRMAX  (NRMAX .ge. 0)
c                        RWORK(10) = EPLI (0 .lt. EPLI .lt. 1.0) ****
c
c        INFO(14) - used with INFO(11) > 0 (initial condition
c               calculation is requested).  In this case, you may
c               request control to be returned to the calling program
c               immediately after the initial condition calculation,
c               before proceeding to the integration of the system
c               (e.g. to examine the computed Y and YPRIME).
c               If this is done, and if the initialization succeeded
c               (IDID = 4), you should reset INFO(11) to 0 for the
c               next call, to prevent the solver from repeating the
c               initialization (and to avoid an infinite loop).
c          ****   Do you want to proceed to the integration after
c                 the initial condition calculation is done ...
c                 yes - set INFO(14) = 0
c                  no - set INFO(14) = 1                        ****
c
c        INFO(15) - used when INFO(12) = 1 (Krylov methods).
c               When using preconditioning in the Krylov method,
c               you must supply a subroutine, PSOL, which solves the
c               associated linear systems using P.
c               The usage of SDASPK is simpler if PSOL can carry out
c               the solution without any prior calculation of data.
c               However, if some partial derivative data is to be
c               calculated in advance and used repeatedly in PSOL,
c               then you must supply a JAC routine to do this,
c               and set INFO(15) to indicate that JAC is to be called
c               for this purpose.  For example, P might be an
c               approximation to a part of the matrix A which can be
c               calculated and LU-factored for repeated solutions of
c               the preconditioner system.  The arrays WP and IWP
c               (described under JAC and PSOL) can be used to
c               communicate data between JAC and PSOL.
c          ****   Does PSOL operate with no prior preparation ...
c                 yes - set INFO(15) = 0 (no JAC routine)
c                  no - set INFO(15) = 1
c                       and supply a JAC routine to evaluate and
c                       preprocess any required Jacobian data.  ****
c
c         INFO(16) - option to exclude algebraic variables from
c               the error test.
c          ****   Do you wish to control errors locally on
c                 all the variables...
c                 yes - set INFO(16) = 0
c                  no - set INFO(16) = 1
c                       If you have specified INFO(16) = 1, then you
c                       will also need to identify  which are the
c                       differential and which are the algebraic
c                       components (algebraic components are components
c                       whose derivatives do not appear explicitly
c                       in the function G(T,Y,YPRIME)).  You must set:
c                       IWORK(LID+I) = +1 if Y(I) is a differential
c                                      variable, and
c                       IWORK(LID+I) = -1 if Y(I) is an algebraic
c                                      variable,
c                       where LID = 40 if INFO(10) = 0 or 2 and
c                       LID = 40 + NEQ if INFO(10) = 1 or 3.
c
c       INFO(17) - used when INFO(11) > 0 (SDASPK is to do an
c              initial condition calculation).
c              SDASPK uses several heuristic control quantities in the
c              initial condition calculation.  They have default values,
c              but can  also be set by the user using INFO(17).
c              These parameters and their defaults are as follows:
c              MXNIT  = maximum number of Newton iterations
c                 per Jacobian or preconditioner evaluation.
c                 The default is:
c                 MXNIT =  5 in the direct case (INFO(12) = 0), and
c                 MXNIT = 15 in the Krylov case (INFO(12) = 1).
c              MXNJ   = maximum number of Jacobian or preconditioner
c                 evaluations.  The default is:
c                 MXNJ = 6 in the direct case (INFO(12) = 0), and
c                 MXNJ = 2 in the Krylov case (INFO(12) = 1).
c              MXNH   = maximum number of values of the artificial
c                 stepsize parameter H to be tried if INFO(11) = 1.
c                 The default is MXNH = 5.
c                 NOTE: the maximum number of Newton iterations
c                 allowed in all is MXNIT*MXNJ*MXNH if INFO(11) = 1,
c                 and MXNIT*MXNJ if INFO(11) = 2.
c              LSOFF  = flag to turn off the linesearch algorithm
c                 (LSOFF = 0 means linesearch is on, LSOFF = 1 means
c                 it is turned off).  The default is LSOFF = 0.
c              STPTOL = minimum scaled step in linesearch algorithm.
c                 The default is STPTOL = (unit roundoff)**(2/3).
c              EPINIT = swing factor in the Newton iteration convergence
c                 test.  The test is applied to the residual vector,
c                 premultiplied by the approximate Jacobian (in the
c                 direct case) or the preconditioner (in the Krylov
c                 case).  For convergence, the weighted RMS norm of
c                 this vector (scaled by the error weights) must be
c                 less than EPINIT*EPCON, where EPCON = .33 is the
c                 analogous test constant used in the time steps.
c                 The default is EPINIT = .01.
c          ****   Are the initial condition heuristic controls to be
c                 given their default values...
c                  yes - set INFO(17) = 0
c                   no - set INFO(17) = 1,
c                        and set all of the following:
c                        IWORK(32) = MXNIT (.GT. 0)
c                        IWORK(33) = MXNJ (.GT. 0)
c                        IWORK(34) = MXNH (.GT. 0)
c                        IWORK(35) = LSOFF ( = 0 or 1)
c                        RWORK(14) = STPTOL (.GT. 0.0)
c                        RWORK(15) = EPINIT (.GT. 0.0)  ****
c
c         INFO(18) - option to get extra printing in initial condition
c                calculation.
c          ****   Do you wish to have extra printing...
c                 no  - set INFO(18) = 0
c                 yes - set INFO(18) = 1 for minimal printing, or
c                       set INFO(18) = 2 for full printing.
c                       If you have specified INFO(18) .ge. 1, data
c                       will be printed with the error handler routines.
c                       To print to a non-default unit number L, include
c                       the line  CALL XSETUN(L)  in your program.  ****
c
c   RTOL, ATOL -- You must assign relative (RTOL) and absolute (ATOL)
c               error tolerances to tell the code how accurately you
c               want the solution to be computed.  They must be defined
c               as variables because the code may change them.
c               you have two choices --
c                     Both RTOL and ATOL are scalars (INFO(2) = 0), or
c                     both RTOL and ATOL are vectors (INFO(2) = 1).
c               In either case all components must be non-negative.
c
c               The tolerances are used by the code in a local error
c               test at each step which requires roughly that
c                        abs(local error in Y(i)) .le. EWT(i) ,
c               where EWT(i) = RTOL*abs(Y(i)) + ATOL is an error weight
c               quantity, for each vector component.
c               (More specifically, a root-mean-square norm is used to
c               measure the size of vectors, and the error test uses the
c               magnitude of the solution at the beginning of the step.)
c
c               The true (global) error is the difference between the
c               true solution of the initial value problem and the
c               computed approximation.  Practically all present day
c               codes, including this one, control the local error at
c               each step and do not even attempt to control the global
c               error directly.
c
c               Usually, but not always, the true accuracy of
c               the computed Y is comparable to the error tolerances.
c               This code will usually, but not always, deliver a more
c               accurate solution if you reduce the tolerances and
c               integrate again.  By comparing two such solutions you
c               can get a fairly reliable idea of the true error in the
c               solution at the larger tolerances.
c
c               Setting ATOL = 0. results in a pure relative error test
c               on that component.  Setting RTOL = 0. results in a pure
c               absolute error test on that component.  A mixed test
c               with non-zero RTOL and ATOL corresponds roughly to a
c               relative error test when the solution component is
c               much bigger than ATOL and to an absolute error test
c               when the solution component is smaller than the
c               threshold ATOL.
c
c               The code will not attempt to compute a solution at an
c               accuracy unreasonable for the machine being used.  It
c               will advise you if you ask for too much accuracy and
c               inform you as to the maximum accuracy it believes
c               possible.
c
c  RWORK(*) -- a real work array, which should be dimensioned in your
c               calling program with a length equal to the value of
c               LRW (or greater).
c
c  LRW -- Set it to the declared length of the RWORK array.  The
c               minimum length depends on the options you have selected,
c               given by a base value plus additional storage as described
c               below.
c
c               If INFO(12) = 0 (standard direct method), the base value is
c               base = 50 + MAX(MAXORD+4,7)*NEQ.
c               The default value is MAXORD = 5 (see INFO(9)).  With the
c               default MAXORD, base = 50 + 9*NEQ.
c               Additional storage must be added to the base value for
c               any or all of the following options:
c                 if INFO(6) = 0 (dense matrix), add NEQ**2
c                 if INFO(6) = 1 (banded matrix), then
c                    if INFO(5) = 0, add (2*ML+MU+1)*NEQ + 2*(NEQ/(ML+MU+1)+1),
c                    if INFO(5) = 1, add (2*ML+MU+1)*NEQ,
c                 if INFO(16) = 1, add NEQ.
c
c              If INFO(12) = 1 (Krylov method), the base value is
c              base = 50 + (MAXORD+5)*NEQ + (MAXL+3+MIN(1,MAXL-KMP))*NEQ +
c                      + (MAXL+3)*MAXL + 1 + LENWP.
c              See PSOL for description of LENWP.  The default values are:
c              MAXORD = 5 (see INFO(9)), MAXL = MIN(5,NEQ) and KMP = MAXL
c              (see INFO(13)).
c              With the default values for MAXORD, MAXL and KMP,
c              base = 91 + 18*NEQ + LENWP.
c              Additional storage must be added to the base value for
c              any or all of the following options:
c                if INFO(16) = 1, add NEQ.
c
c
c  IWORK(*) -- an integer work array, which should be dimensioned in
c              your calling program with a length equal to the value
c              of LIW (or greater).
c
c  LIW -- Set it to the declared length of the IWORK array.  The
c             minimum length depends on the options you have selected,
c             given by a base value plus additional storage as described
c             below.
c
c             If INFO(12) = 0 (standard direct method), the base value is
c             base = 40 + NEQ.
c             IF INFO(10) = 1 or 3, add NEQ to the base value.
c             If INFO(11) = 1 or INFO(16) =1, add NEQ to the base value.
c
c             If INFO(12) = 1 (Krylov method), the base value is
c             base = 40 + LENIWP.
c             See PSOL for description of LENIWP.
c             IF INFO(10) = 1 or 3, add NEQ to the base value.
c             If INFO(11) = 1 or INFO(16) = 1, add NEQ to the base value.
c
c
c  RPAR, IPAR -- These are arrays of single precision and integer type,
c             respectively, which are available for you to use
c             for communication between your program that calls
c             SDASPK and the RES subroutine (and the JAC and PSOL
c             subroutines).  They are not altered by SDASPK.
c             If you do not need RPAR or IPAR, ignore these
c             parameters by treating them as dummy arguments.
c             If you do choose to use them, dimension them in
c             your calling program and in RES (and in JAC and PSOL)
c             as arrays of appropriate length.
c
c  JAC -- This is the name of a routine that you may supply
c         (optionally) that relates to the Jacobian matrix of the
c         nonlinear system that the code must solve at each T step.
c         The role of JAC (and its call sequence) depends on whether
c         a direct (INFO(12) = 0) or Krylov (INFO(12) = 1) method
c         is selected.
c
c         **** INFO(12) = 0 (direct methods):
c           If you are letting the code generate partial derivatives
c           numerically (INFO(5) = 0), then JAC can be absent
c           (or perhaps a dummy routine to satisfy the loader).
c           Otherwise you must supply a JAC routine to compute
c           the matrix A = dG/dY + CJ*dG/dYPRIME.  It must have
c           the form
c
c           SUBROUTINE JAC (T, Y, YPRIME, PD, CJ, RPAR, IPAR)
c
c           The JAC routine must dimension Y, YPRIME, and PD (and RPAR
c           and IPAR if used).  CJ is a scalar which is input to JAC.
c           For the given values of T, Y, and YPRIME, the JAC routine
c           must evaluate the nonzero elements of the matrix A, and
c           store these values in the array PD.  The elements of PD are
c           set to zero before each call to JAC, so that only nonzero
c           elements need to be defined.
c           The way you store the elements into the PD array depends
c           on the structure of the matrix indicated by INFO(6).
c           *** INFO(6) = 0 (full or dense matrix) ***
c               Give PD a first dimension of NEQ.  When you evaluate the
c               nonzero partial derivatives of equation i (i.e. of G(i))
c               with respect to component j (of Y and YPRIME), you must
c               store the element in PD according to
c                  PD(i,j) = dG(i)/dY(j) + CJ*dG(i)/dYPRIME(j).
c           *** INFO(6) = 1 (banded matrix with half-bandwidths ML, MU
c                            as described under INFO(6)) ***
c               Give PD a first dimension of 2*ML+MU+1.  When you
c               evaluate the nonzero partial derivatives of equation i
c               (i.e. of G(i)) with respect to component j (of Y and
c               YPRIME), you must store the element in PD according to
c                  IROW = i - j + ML + MU + 1
c                  PD(IROW,j) = dG(i)/dY(j) + CJ*dG(i)/dYPRIME(j).
c
c          **** INFO(12) = 1 (Krylov method):
c            If you are not calculating Jacobian data in advance for use
c            in PSOL (INFO(15) = 0), JAC can be absent (or perhaps a
c            dummy routine to satisfy the loader).  Otherwise, you may
c            supply a JAC routine to compute and preprocess any parts of
c            of the Jacobian matrix  A = dG/dY + CJ*dG/dYPRIME that are
c            involved in the preconditioner matrix P.
c            It is to have the form
c
c            SUBROUTINE JAC (RES, IRES, NEQ, T, Y, YPRIME, REWT, SAVR,
c                            WK, H, CJ, WP, IWP, IER, RPAR, IPAR)
c
c           The JAC routine must dimension Y, YPRIME, REWT, SAVR, WK,
c           and (if used) WP, IWP, RPAR, and IPAR.
c           The Y, YPRIME, and SAVR arrays contain the current values
c           of Y, YPRIME, and the residual G, respectively.
c           The array WK is work space of length NEQ.
c           H is the step size.  CJ is a scalar, input to JAC, that is
c           normally proportional to 1/H.  REWT is an array of
c           reciprocal error weights, 1/EWT(i), where EWT(i) is
c           RTOL*abs(Y(i)) + ATOL (unless you supplied routine SDAWTS
c           instead), for use in JAC if needed.  For example, if JAC
c           computes difference quotient approximations to partial
c           derivatives, the REWT array may be useful in setting the
c           increments used.  The JAC routine should do any
c           factorization operations called for, in preparation for
c           solving linear systems in PSOL.  The matrix P should
c           be an approximation to the Jacobian,
c           A = dG/dY + CJ*dG/dYPRIME.
c
c           WP and IWP are real and integer work arrays which you may
c           use for communication between your JAC routine and your
c           PSOL routine.  These may be used to store elements of the
c           preconditioner P, or related matrix data (such as factored
c           forms).  They are not altered by SDASPK.
c           If you do not need WP or IWP, ignore these parameters by
c           treating them as dummy arguments.  If you do use them,
c           dimension them appropriately in your JAC and PSOL routines.
c           See the PSOL description for instructions on setting
c           the lengths of WP and IWP.
c
c           On return, JAC should set the error flag IER as follows..
c             IER = 0    if JAC was successful,
c             IER .ne. 0 if JAC was unsuccessful (e.g. if Y or YPRIME
c                        was illegal, or a singular matrix is found).
c           (If IER .ne. 0, a smaller stepsize will be tried.)
c           If RES is used within JAC, then a nonzero value of IRES will
c           override any nonzero value of IER (see the RES description).
c           IER = 0 on entry to JAC, so need be reset only on a failure.
c
c         Regardless of the method type, subroutine JAC must not
c         alter T, Y(*), YPRIME(*), H, CJ, or REWT(*).
c         You must declare the name JAC in an EXTERNAL statement in
c         your program that calls SDASPK.
c
c PSOL --  This is the name of a routine you must supply if you have
c         selected a Krylov method (INFO(12) = 1) with preconditioning.
c         In the direct case (INFO(12) = 0), PSOL can be absent
c         (a dummy routine may have to be supplied to satisfy the
c         loader).  Otherwise, you must provide a PSOL routine to
c         solve linear systems arising from preconditioning.
c         When supplied with INFO(12) = 1, the PSOL routine is to
c         have the form
c
c         SUBROUTINE PSOL (NEQ, T, Y, YPRIME, SAVR, WK, CJ, WGHT,
c                          WP, IWP, B, EPLIN, IER, RPAR, IPAR)
c
c         The PSOL routine must solve linear systems of the form
c         P*x = b where P is the left preconditioner matrix.
c
c         The right-hand side vector b is in the B array on input, and
c         PSOL must return the solution vector x in B.
c         The Y, YPRIME, and SAVR arrays contain the current values
c         of Y, YPRIME, and the residual G, respectively.
c
c         Work space required by JAC and/or PSOL, and space for data to
c         be communicated from JAC to PSOL is made available in the form
c         of arrays WP and IWP, which are parts of the RWORK and IWORK
c         arrays, respectively.  The lengths of these real and integer
c         work spaces WP and IWP must be supplied in LENWP and LENIWP,
c         respectively, as follows..
c           IWORK(27) = LENWP = length of real work space WP
c           IWORK(28) = LENIWP = length of integer work space IWP.
c
c         WK is a work array of length NEQ for use by PSOL.
c         CJ is a scalar, input to PSOL, that is normally proportional
c         to 1/H (H = stepsize).  If the old value of CJ
c         (at the time of the last JAC call) is needed, it must have
c         been saved by JAC in WP.
c         WGHT is an array of weights, to be used if PSOL uses an
c         iterative method and performs a convergence test.  (In terms
c         of the argument REWT to JAC, WGHT is REWT/sqrt(NEQ).)
c         If PSOL uses an iterative method, it should use EPLIN
c         (a heuristic parameter) as the bound on the weighted norm of
c         the residual for the computed solution.  Specifically, the
c         residual vector R should satisfy
c
c              SQRT (SUM ( (R(i)*WGHT(i))**2 ) ) .le. EPLIN
c
c         PSOL must not alter NEQ, T, Y, YPRIME, SAVR, CJ, WGHT, EPLIN.
c
c         On return, PSOL should set the error flag IER as follows..
c           IER = 0 if PSOL was successful,
c           IER .lt. 0 if an unrecoverable error occurred, meaning
c                 control will be passed to the calling routine,
c           IER .gt. 0 if a recoverable error occurred, meaning that
c                 the step will be retried with the same step size
c                 but with a call to JAC to update necessary data,
c                 unless the Jacobian data is current, in which case
c                 the step will be retried with a smaller step size.
c           IER = 0 on entry to PSOL so need be reset only on a failure.
c
c         You must declare the name PSOL in an EXTERNAL statement in
c         your program that calls SDASPK.
c
c
c  OPTIONALLY REPLACEABLE SUBROUTINE:
c
c  SDASPK uses a weighted root-mean-square norm to measure the
c  size of various error vectors.  The weights used in this norm
c  are set in the following subroutine:
c
c    SUBROUTINE SDAWTS (NEQ, IWT, RTOL, ATOL, Y, EWT, RPAR, IPAR)
c    DIMENSION RTOL(*), ATOL(*), Y(*), EWT(*), RPAR(*), IPAR(*)
c
c  A SDAWTS routine has been included with SDASPK which sets the
c  weights according to
c    EWT(I) = RTOL*ABS(Y(I)) + ATOL
c  in the case of scalar tolerances (IWT = 0) or
c    EWT(I) = RTOL(I)*ABS(Y(I)) + ATOL(I)
c  in the case of array tolerances (IWT = 1).  (IWT is INFO(2).)
c  In some special cases, it may be appropriate for you to define
c  your own error weights by writing a subroutine SDAWTS to be
c  called instead of the version supplied.  However, this should
c  be attempted only after careful thought and consideration.
c  If you supply this routine, you may use the tolerances and Y
c  as appropriate, but do not overwrite these variables.  You
c  may also use RPAR and IPAR to communicate data as appropriate.
c  ***Note: Aside from the values of the weights, the choice of
c  norm used in SDASPK (weighted root-mean-square) is not subject
c  to replacement by the user.  In this respect, SDASPK is not
c  downward-compatible with the original SDASSL solver (in which
c  the norm routine was optionally user-replaceable).
c
c
c------OUTPUT - AFTER ANY RETURN FROM SDASPK----------------------------
c
c  The principal aim of the code is to return a computed solution at
c  T = TOUT, although it is also possible to obtain intermediate
c  results along the way.  To find out whether the code achieved its
c  goal or if the integration process was interrupted before the task
c  was completed, you must check the IDID parameter.
c
c
c   T -- The output value of T is the point to which the solution
c        was successfully advanced.
c
c   Y(*) -- contains the computed solution approximation at T.
c
c   YPRIME(*) -- contains the computed derivative approximation at T.
c
c   IDID -- reports what the code did, described as follows:
c
c                     *** TASK COMPLETED ***
c                Reported by positive values of IDID
c
c           IDID = 1 -- a step was successfully taken in the
c                   intermediate-output mode.  The code has not
c                   yet reached TOUT.
c
c           IDID = 2 -- the integration to TSTOP was successfully
c                   completed (T = TSTOP) by stepping exactly to TSTOP.
c
c           IDID = 3 -- the integration to TOUT was successfully
c                   completed (T = TOUT) by stepping past TOUT.
c                   Y(*) and YPRIME(*) are obtained by interpolation.
c
c           IDID = 4 -- the initial condition calculation, with
c                   INFO(11) > 0, was successful, and INFO(14) = 1.
c                   No integration steps were taken, and the solution
c                   is not considered to have been started.
c
c                    *** TASK INTERRUPTED ***
c                Reported by negative values of IDID
c
c           IDID = -1 -- a large amount of work has been expended
c                     (about 500 steps).
c
c           IDID = -2 -- the error tolerances are too stringent.
c
c           IDID = -3 -- the local error test cannot be satisfied
c                     because you specified a zero component in ATOL
c                     and the corresponding computed solution component
c                     is zero.  Thus, a pure relative error test is
c                     impossible for this component.
c
c           IDID = -5 -- there were repeated failures in the evaluation
c                     or processing of the preconditioner (in JAC).
c
c           IDID = -6 -- SDASPK had repeated error test failures on the
c                     last attempted step.
c
c           IDID = -7 -- the nonlinear system solver in the time integration
c                     could not converge.
c
c           IDID = -8 -- the matrix of partial derivatives appears
c                     to be singular (direct method).
c
c           IDID = -9 -- the nonlinear system solver in the time integration
c                     failed to achieve convergence, and there were repeated
c                     error test failures in this step.
c
c           IDID =-10 -- the nonlinear system solver in the time integration
c                     failed to achieve convergence because IRES was equal
c                     to -1.
c
c           IDID =-11 -- IRES = -2 was encountered and control is
c                     being returned to the calling program.
c
c           IDID =-12 -- SDASPK failed to compute the initial Y, YPRIME.
c
c           IDID =-13 -- unrecoverable error encountered inside user's
c                     PSOL routine, and control is being returned to
c                     the calling program.
c
c           IDID =-14 -- the Krylov linear system solver could not
c                     achieve convergence.
c
c           IDID =-15,..,-32 -- Not applicable for this code.
c
c                    *** TASK TERMINATED ***
c                reported by the value of IDID=-33
c
c           IDID = -33 -- the code has encountered trouble from which
c                   it cannot recover.  A message is printed
c                   explaining the trouble and control is returned
c                   to the calling program.  For example, this occurs
c                   when invalid input is detected.
c
c   RTOL, ATOL -- these quantities remain unchanged except when
c               IDID = -2.  In this case, the error tolerances have been
c               increased by the code to values which are estimated to
c               be appropriate for continuing the integration.  However,
c               the reported solution at T was obtained using the input
c               values of RTOL and ATOL.
c
c   RWORK, IWORK -- contain information which is usually of no interest
c               to the user but necessary for subsequent calls.
c               However, you may be interested in the performance data
c               listed below.  These quantities are accessed in RWORK
c               and IWORK but have internal mnemonic names, as follows..
c
c               RWORK(3)--contains H, the step size h to be attempted
c                        on the next step.
c
c               RWORK(4)--contains TN, the current value of the
c                        independent variable, i.e. the farthest point
c                        integration has reached.  This will differ
c                        from T if interpolation has been performed
c                        (IDID = 3).
c
c               RWORK(7)--contains HOLD, the stepsize used on the last
c                        successful step.  If INFO(11) = INFO(14) = 1,
c                        this contains the value of H used in the
c                        initial condition calculation.
c
c               IWORK(7)--contains K, the order of the method to be
c                        attempted on the next step.
c
c               IWORK(8)--contains KOLD, the order of the method used
c                        on the last step.
c
c               IWORK(11)--contains NST, the number of steps (in T)
c                        taken so far.
c
c               IWORK(12)--contains NRE, the number of calls to RES
c                        so far.
c
c               IWORK(13)--contains NJE, the number of calls to JAC so
c                        far (Jacobian or preconditioner evaluations).
c
c               IWORK(14)--contains NETF, the total number of error test
c                        failures so far.
c
c               IWORK(15)--contains NCFN, the total number of nonlinear
c                        convergence failures so far (includes counts
c                        of singular iteration matrix or singular
c                        preconditioners).
c
c               IWORK(16)--contains NCFL, the number of convergence
c                        failures of the linear iteration so far.
c
c               IWORK(17)--contains LENIW, the length of IWORK actually
c                        required.  This is defined on normal returns
c                        and on an illegal input return for
c                        insufficient storage.
c
c               IWORK(18)--contains LENRW, the length of RWORK actually
c                        required.  This is defined on normal returns
c                        and on an illegal input return for
c                        insufficient storage.
c
c               IWORK(19)--contains NNI, the total number of nonlinear
c                        iterations so far (each of which calls a
c                        linear solver).
c
c               IWORK(20)--contains NLI, the total number of linear
c                        (Krylov) iterations so far.
c
c               IWORK(21)--contains NPS, the number of PSOL calls so
c                        far, for preconditioning solve operations or
c                        for solutions with the user-supplied method.
c
c               Note: The various counters in IWORK do not include
c               counts during a call made with INFO(11) > 0 and
c               INFO(14) = 1.
c
c
c------INPUT - WHAT TO DO TO CONTINUE THE INTEGRATION  -----------------
c              (CALLS AFTER THE FIRST)
c
c     This code is organized so that subsequent calls to continue the
c     integration involve little (if any) additional effort on your
c     part.  You must monitor the IDID parameter in order to determine
c     what to do next.
c
c     Recalling that the principal task of the code is to integrate
c     from T to TOUT (the interval mode), usually all you will need
c     to do is specify a new TOUT upon reaching the current TOUT.
c
c     Do not alter any quantity not specifically permitted below.  In
c     particular do not alter NEQ, T, Y(*), YPRIME(*), RWORK(*),
c     IWORK(*), or the differential equation in subroutine RES.  Any
c     such alteration constitutes a new problem and must be treated
c     as such, i.e. you must start afresh.
c
c     You cannot change from array to scalar error control or vice
c     versa (INFO(2)), but you can change the size of the entries of
c     RTOL or ATOL.  Increasing a tolerance makes the equation easier
c     to integrate.  Decreasing a tolerance will make the equation
c     harder to integrate and should generally be avoided.
c
c     You can switch from the intermediate-output mode to the
c     interval mode (INFO(3)) or vice versa at any time.
c
c     If it has been necessary to prevent the integration from going
c     past a point TSTOP (INFO(4), RWORK(1)), keep in mind that the
c     code will not integrate to any TOUT beyond the currently
c     specified TSTOP.  Once TSTOP has been reached, you must change
c     the value of TSTOP or set INFO(4) = 0.  You may change INFO(4)
c     or TSTOP at any time but you must supply the value of TSTOP in
c     RWORK(1) whenever you set INFO(4) = 1.
c
c     Do not change INFO(5), INFO(6), INFO(12-17) or their associated
c     IWORK/RWORK locations unless you are going to restart the code.
c
c                    *** FOLLOWING A COMPLETED TASK ***
c
c     If..
c     IDID = 1, call the code again to continue the integration
c                  another step in the direction of TOUT.
c
c     IDID = 2 or 3, define a new TOUT and call the code again.
c                  TOUT must be different from T.  You cannot change
c                  the direction of integration without restarting.
c
c     IDID = 4, reset INFO(11) = 0 and call the code again to begin
c                  the integration.  (If you leave INFO(11) > 0 and
c                  INFO(14) = 1, you may generate an infinite loop.)
c                  In this situation, the next call to DASPK is
c                  considered to be the first call for the problem,
c                  in that all initializations are done.
c
c                    *** FOLLOWING AN INTERRUPTED TASK ***
c
c     To show the code that you realize the task was interrupted and
c     that you want to continue, you must take appropriate action and
c     set INFO(1) = 1.
c
c     If..
c     IDID = -1, the code has taken about 500 steps.  If you want to
c                  continue, set INFO(1) = 1 and call the code again.
c                  An additional 500 steps will be allowed.
c
c
c     IDID = -2, the error tolerances RTOL, ATOL have been increased
c                  to values the code estimates appropriate for
c                  continuing.  You may want to change them yourself.
c                  If you are sure you want to continue with relaxed
c                  error tolerances, set INFO(1) = 1 and call the code
c                  again.
c
c     IDID = -3, a solution component is zero and you set the
c                  corresponding component of ATOL to zero.  If you
c                  are sure you want to continue, you must first alter
c                  the error criterion to use positive values of ATOL
c                  for those components corresponding to zero solution
c                  components, then set INFO(1) = 1 and call the code
c                  again.
c
c     IDID = -4  --- cannot occur with this code.
c
c     IDID = -5, your JAC routine failed with the Krylov method.  Check
c                  for errors in JAC and restart the integration.
c
c     IDID = -6, repeated error test failures occurred on the last
c                  attempted step in SDASPK.  A singularity in the
c                  solution may be present.  If you are absolutely
c                  certain you want to continue, you should restart
c                  the integration.  (Provide initial values of Y and
c                  YPRIME which are consistent.)
c
c     IDID = -7, repeated convergence test failures occurred on the last
c                  attempted step in SDASPK.  An inaccurate or ill-
c                  conditioned Jacobian or preconditioner may be the
c                  problem.  If you are absolutely certain you want
c                  to continue, you should restart the integration.
c
c
c     IDID = -8, the matrix of partial derivatives is singular, with
c                  the use of direct methods.  Some of your equations
c                  may be redundant.  SDASPK cannot solve the problem
c                  as stated.  It is possible that the redundant
c                  equations could be removed, and then SDASPK could
c                  solve the problem.  It is also possible that a
c                  solution to your problem either does not exist
c                  or is not unique.
c
c     IDID = -9, SDASPK had multiple convergence test failures, preceded
c                  by multiple error test failures, on the last
c                  attempted step.  It is possible that your problem is
c                  ill-posed and cannot be solved using this code.  Or,
c                  there may be a discontinuity or a singularity in the
c                  solution.  If you are absolutely certain you want to
c                  continue, you should restart the integration.
c
c     IDID = -10, SDASPK had multiple convergence test failures
c                  because IRES was equal to -1.  If you are
c                  absolutely certain you want to continue, you
c                  should restart the integration.
c
c     IDID = -11, there was an unrecoverable error (IRES = -2) from RES
c                  inside the nonlinear system solver.  Determine the
c                  cause before trying again.
c
c     IDID = -12, SDASPK failed to compute the initial Y and YPRIME
c                  vectors.  This could happen because the initial
c                  approximation to Y or YPRIME was not very good, or
c                  because no consistent values of these vectors exist.
c                  The problem could also be caused by an inaccurate or
c                  singular iteration matrix, or a poor preconditioner.
c
c     IDID = -13, there was an unrecoverable error encountered inside
c                  your PSOL routine.  Determine the cause before
c                  trying again.
c
c     IDID = -14, the Krylov linear system solver failed to achieve
c                  convergence.  This may be due to ill-conditioning
c                  in the iteration matrix, or a singularity in the
c                  preconditioner (if one is being used).
c                  Another possibility is that there is a better
c                  choice of Krylov parameters (see INFO(13)).
c                  Possibly the failure is caused by redundant equations
c                  in the system, or by inconsistent equations.
c                  In that case, reformulate the system to make it
c                  consistent and non-redundant.
c
c     IDID = -15,..,-32 --- Cannot occur with this code.
c
c                       *** FOLLOWING A TERMINATED TASK ***
c
c     If IDID = -33, you cannot continue the solution of this problem.
c                  An attempt to do so will result in your run being
c                  terminated.
c
c  ---------------------------------------------------------------------
c
c***REFERENCES
c  1.  L. R. Petzold, A Description of DASSL: A Differential/Algebraic
c      System Solver, in Scientific Computing, R. S. Stepleman et al.
c      (Eds.), North-Holland, Amsterdam, 1983, pp. 65-68.
c  2.  K. E. Brenan, S. L. Campbell, and L. R. Petzold, Numerical
c      Solution of Initial-Value Problems in Differential-Algebraic
c      Equations, Elsevier, New York, 1989.
c  3.  P. N. Brown and A. C. Hindmarsh, Reduced Storage Matrix Methods
c      in Stiff ODE Systems, J. Applied Mathematics and Computation,
c      31 (1989), pp. 40-91.
c  4.  P. N. Brown, A. C. Hindmarsh, and L. R. Petzold, Using Krylov
c      Methods in the Solution of Large-Scale Differential-Algebraic
c      Systems, SIAM J. Sci. Comp., 15 (1994), pp. 1467-1488.
c  5.  P. N. Brown, A. C. Hindmarsh, and L. R. Petzold, Consistent
c      Initial Condition Calculation for Differential-Algebraic
c      Systems, LLNL Report UCRL-JC-122175, August 1995; submitted to
c      SIAM J. Sci. Comp.
c
c***ROUTINES CALLED
c
c   The following are all the subordinate routines used by SDASPK.
c
c   SDASIC computes consistent initial conditions.
c   SYYPNW updates Y and YPRIME in linesearch for initial condition
c          calculation.
c   SDSTP  carries out one step of the integration.
c   SCNSTR/SCNST0 check the current solution for constraint violations.
c   SDAWTS sets error weight quantities.
c   SINVWT tests and inverts the error weights.
c   SDATRP performs interpolation to get an output solution.
c   SDWNRM computes the weighted root-mean-square norm of a vector.
c   R1MACH8 provides the unit roundoff of the computer.
c   XERRWV/XSETF/XSETUN/IXSAV is a package to handle error messages.
c   SDASID nonlinear equation driver to initialize Y and YPRIME using
c          direct linear system solver methods.  Interfaces to Newton
c          solver (direct case).
c   SNSID  solves the nonlinear system for unknown initial values by
c          modified Newton iteration and direct linear system methods.
c   SLINSD carries out linesearch algorithm for initial condition
c          calculation (direct case).
c   SFNRMD calculates weighted norm of preconditioned residual in
c          initial condition calculation (direct case).
c   SNEDD  nonlinear equation driver for direct linear system solver
c          methods.  Interfaces to Newton solver (direct case).
c   SMATD  assembles the iteration matrix (direct case).
c   SNSD   solves the associated nonlinear system by modified
c          Newton iteration and direct linear system methods.
c   SSLVD  interfaces to linear system solver (direct case).
c   SDASIK nonlinear equation driver to initialize Y and YPRIME using
c          Krylov iterative linear system methods.  Interfaces to
c          Newton solver (Krylov case).
c   SNSIK  solves the nonlinear system for unknown initial values by
c          Newton iteration and Krylov iterative linear system methods.
c   SLINSK carries out linesearch algorithm for initial condition
c          calculation (Krylov case).
c   SFNRMK calculates weighted norm of preconditioned residual in
c          initial condition calculation (Krylov case).
c   SNEDK  nonlinear equation driver for iterative linear system solver
c          methods.  Interfaces to Newton solver (Krylov case).
c   SNSK   solves the associated nonlinear system by Inexact Newton
c          iteration and (linear) Krylov iteration.
c   SSLVK  interfaces to linear system solver (Krylov case).
c   SSPIGM solves a linear system by SPIGMR algorithm.
c   SATV   computes matrix-vector product in Krylov algorithm.
c   SORTH  performs orthogonalization of Krylov basis vectors.
c   SHEQR  performs QR factorization of Hessenberg matrix.
c   SHELS  finds least-squares solution of Hessenberg linear system.
c   SGEFA, SGESL, SGBFA, SGBSL are LINPACK routines for solving
c          linear systems (dense or band direct methods).
c   SAXPY, SCOPY, SDOT, SNRM2, SSCAL are Basic Linear Algebra (BLAS)
c          routines.
c
c The routines called directly by SDASPK are:
c   SCNST0, SDAWTS, SINVWT, R1MACH8, SDWNRM, SDASIC, SDATRP, SDSTP,
c   XERRWV
c
c***END PROLOGUE SDASPK
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER LRW,LIW,LML,LMU,LMTYPE,LIWM,LMXORD,LJCALC,LPHASE, LK,LKOLD
     &   ,LNS,LNSTL,LNST,LNRE,LNJE,LETF,LNCFN, LNCFL,LNIW,LNRW,LNNI,LNLI
     &   ,LNPS,LNPD,LMITER,LMAXL, LKMP,LNRMAX,LLNWP,LLNIWP,LLOCWP,LLCIWP
     &   ,LKPRIN, LMXNIT,LMXNJ,LMXNH,LLSOFF,LICNS,INFO

      INTEGER LTSTOP,LHMAX,LH,LTN,LCJ,LCJOLD,LHOLD,LS,LROUND, LEPLI,
     &   LSQRN,LRSQRN,LEPCON,LSTOL,LEPIN,LEPNL, LALPHA,LBETA,LGAMMA,LPSI
     &   ,LSIGMA,LDELTA

      INTEGER I,ITEMP,NEQ,MXORD,IWORK,ICNFLG,NONNEG,LID,LSOFF, LENIC,
     &   LENID,NCPHI,LENPD,LENRW,MBAND,MSAVE,LENIW,LENWP, LENIWP,MAXL,
     &   ICI,IRET,IDI,IDID,NLI0,NNI0,NCFN0,NCFL0,NWARN, NZFLG,LE,LWT,LVT
     &   ,LPHI,LWM,IER,NWT,LYIC,LYPIC,LPWK,NSTD
      INTEGER NNID,LSAVR,IPAR

      LOGICAL done, LAVL, LCFN, LCFL, LWARN
      DIMENSION Y(*),YPRIME(*)
      DIMENSION INFO(20)
      DIMENSION RWORK(LRW),IWORK(LIW)
      DIMENSION RTOL(*),ATOL(*)
      DIMENSION RPAR(*),IPAR(*)
      CHARACTER MSG*80
      EXTERNAL RES, JAC, PSOL, SDASID, SDASIK, SNEDD, SNEDK
      common /comsatv/ scaleps
c
c     Set pointers into IWORK.
c


      PARAMETER (LML=1, LMU=2, LMTYPE=4, LIWM=1, LMXORD=3, LJCALC=5, 
     &   LPHASE=6, LK=7, LKOLD=8, LNS=9, LNSTL=10, LNST=11, LNRE=12, 
     &   LNJE=13, LETF=14, LNCFN=15, LNCFL=16, LNIW=17, LNRW=18, LNNI=19
     &   , LNLI=20, LNPS=21, LNPD=22, LMITER=23, LMAXL=24, LKMP=25, 
     &   LNRMAX=26, LLNWP=27, LLNIWP=28, LLOCWP=29, LLCIWP=30, LKPRIN=31
     &   , LMXNIT=32, LMXNJ=33, LMXNH=34, LLSOFF=35, LICNS=41)
c
c     Set pointers into RWORK.
c
      PARAMETER (LTSTOP=1, LHMAX=2, LH=3, LTN=4, LCJ=5, LCJOLD=6, LHOLD=
     &   7, LS=8, LROUND=9, LEPLI=10, LSQRN=11, LRSQRN=12, LEPCON=13, 
     &   LSTOL=14, LEPIN=15, LEPNL=16, LALPHA=21, LBETA=27, LGAMMA=33, 
     &   LPSI=39, LSIGMA=45, LDELTA=51)
c
      SAVE LID, LENID
c
c
c***FIRST EXECUTABLE STATEMENT  SDASPK
c
c
      scaleps = scalpk
      IF(INFO(1).NE.0) GO TO 100
c
c-----------------------------------------------------------------------
c     This block is executed for the initial call only.
c     It contains checking of inputs and initializations.
c-----------------------------------------------------------------------
c
c     First check INFO array to make sure all elements of INFO
c     Are within the proper range.  (INFO(1) is checked later, because
c     it must be tested on every call.) ITEMP holds the location
c     within INFO which may be out of range.
c
      DO 10 I=2,9
      ITEMP = I
      IF (INFO(I) .NE. 0 .AND. INFO(I) .NE. 1) GO TO 701
   10 CONTINUE
      ITEMP = 10
      IF(INFO(10).LT.0 .OR. INFO(10).GT.3) GO TO 701
      ITEMP = 11
      IF(INFO(11).LT.0 .OR. INFO(11).GT.2) GO TO 701
      DO 15 I=12,17
      ITEMP = I
      IF (INFO(I) .NE. 0 .AND. INFO(I) .NE. 1) GO TO 701
   15 CONTINUE
      ITEMP = 18
      IF(INFO(18).LT.0 .OR. INFO(18).GT.2) GO TO 701

c
c     Check NEQ to see if it is positive.
c
      IF (NEQ .LE. 0) GO TO 702
c
c     Check and compute maximum order.
c
      MXORD=5
      IF (INFO(9) .NE. 0) THEN
      MXORD=IWORK(LMXORD)
      IF (MXORD .LT. 1 .OR. MXORD .GT. 5) GO TO 703
      ENDIF
      IWORK(LMXORD)=MXORD
c
c     Set and/or check inputs for constraint checking (INFO(10) .NE. 0).
c     Set values for ICNFLG, NONNEG, and pointer LID.
c
      ICNFLG = 0
      NONNEG = 0
      LID = LICNS
      IF (INFO(10) .EQ. 0) GO TO 20
      IF (INFO(10) .EQ. 1) THEN
      ICNFLG = 1
      NONNEG = 0
      LID = LICNS + NEQ
      ELSEIF (INFO(10) .EQ. 2) THEN
      ICNFLG = 0
      NONNEG = 1
      ELSE
      ICNFLG = 1
      NONNEG = 1
      LID = LICNS + NEQ
      ENDIF
c
   20 CONTINUE
c
c     Set and/or check inputs for Krylov solver (INFO(12) .NE. 0).
c     If indicated, set default values for MAXL, KMP, NRMAX, and EPLI.
c     Otherwise, verify inputs required for iterative solver.
c
      IF (INFO(12) .EQ. 0) GO TO 25
c
      IWORK(LMITER) = INFO(12)
      IF (INFO(13) .EQ. 0) THEN
      IWORK(LMAXL) = MIN(5,NEQ)
      IWORK(LKMP) = IWORK(LMAXL)
      IWORK(LNRMAX) = 5
      RWORK(LEPLI) = 0.05d0
      ELSE
      IF(IWORK(LMAXL) .LT. 1 .OR. IWORK(LMAXL) .GT. NEQ) GO TO 720
      IF(IWORK(LKMP) .LT. 1 .OR. IWORK(LKMP) .GT. IWORK(LMAXL)) GO TO 
     &   721
      IF(IWORK(LNRMAX) .LT. 0) GO TO 722
      IF(RWORK(LEPLI).LE.0.0d0 .OR. RWORK(LEPLI).GE.1.0d0)GO TO 723
      ENDIF
c
   25 CONTINUE
c
c     Set the correct value of EPNL, stored in RWORK(LEPNL).
c
      IF (INFO(13) .EQ. 0) THEN
      RWORK(LEPNL) = 1.0d0
      ELSE
      IF(RWORK(LEPNL) .LE. 0.0d0) GO TO 728
      ENDIF
c
c     Set and/or check controls for the initial condition calculation
c     (INFO(11) .GT. 0).  If indicated, set default values.
c     Otherwise, verify inputs required for iterative solver.
c
      IF (INFO(11) .EQ. 0) GO TO 30
      IF (INFO(17) .EQ. 0) THEN
      IWORK(LMXNIT) = 5
      IF (INFO(12) .GT. 0) IWORK(LMXNIT) = 15
      IWORK(LMXNJ) = 6
      IF (INFO(12) .GT. 0) IWORK(LMXNJ) = 2
      IWORK(LMXNH) = 5
      IWORK(LLSOFF) = 0
      RWORK(LEPIN) = 0.01d0
      ELSE
      IF (IWORK(LMXNIT) .LE. 0) GO TO 725
      IF (IWORK(LMXNJ) .LE. 0) GO TO 725
      IF (IWORK(LMXNH) .LE. 0) GO TO 725
      LSOFF = IWORK(LLSOFF)
      IF (LSOFF .LT. 0 .OR. LSOFF .GT. 1) GO TO 725
      IF (RWORK(LEPIN) .LE. 0.0d0) GO TO 725
      ENDIF
c
   30 CONTINUE
c
c     Below is the computation and checking of the work array lengths
c     LENIW and LENRW, using direct methods (INFO(12) = 0) or
c     the Krylov methods (INFO(12) = 1).
c
      LENIC = 0
      IF (INFO(10) .EQ. 1 .OR. INFO(10) .EQ. 3) LENIC = NEQ
      LENID = 0
      IF (INFO(11) .EQ. 1 .OR. INFO(16) .EQ. 1) LENID = NEQ
      IF (INFO(12) .EQ. 0) THEN
c
c        Compute MTYPE, etc.  Check ML and MU.
c
      NCPHI = MAX(MXORD + 1, 4)
      IF(INFO(6).EQ.0) THEN
      LENPD = NEQ**2
      LENRW = 50 + (NCPHI+3)*NEQ + LENPD
      IF(INFO(5).EQ.0) THEN
      IWORK(LMTYPE)=2
      ELSE
      IWORK(LMTYPE)=1
      ENDIF
      ELSE
      IF(IWORK(LML).LT.0.OR.IWORK(LML).GE.NEQ)GO TO 717
      IF(IWORK(LMU).LT.0.OR.IWORK(LMU).GE.NEQ)GO TO 718
      LENPD=(2*IWORK(LML)+IWORK(LMU)+1)*NEQ
      IF(INFO(5).EQ.0) THEN
      IWORK(LMTYPE)=5
      MBAND=IWORK(LML)+IWORK(LMU)+1
      MSAVE=(NEQ/MBAND)+1
      LENRW = 50 + (NCPHI+3)*NEQ + LENPD + 2*MSAVE
      ELSE
      IWORK(LMTYPE)=4
      LENRW = 50 + (NCPHI+3)*NEQ + LENPD
      ENDIF
      ENDIF
c
c        Compute LENIW, LENWP, LENIWP.
c
      LENIW = 40 + LENIC + LENID + NEQ
      LENWP = 0
      LENIWP = 0
c
      ELSE IF (INFO(12) .EQ. 1) THEN
      MAXL = IWORK(LMAXL)
      LENWP = IWORK(LLNWP)
      LENIWP = IWORK(LLNIWP)
      LENPD = (MAXL+3+MIN(1,MAXL-IWORK(LKMP)))*NEQ + (MAXL+3)*MAXL + 1 + 
     &   LENWP
      LENRW = 50 + (IWORK(LMXORD)+5)*NEQ + LENPD
      LENIW = 40 + LENIC + LENID + LENIWP
c
      ENDIF
      IF(INFO(16) .NE. 0) LENRW = LENRW + NEQ
c
c     Check lengths of RWORK and IWORK.
c
      IWORK(LNIW)=LENIW
      IWORK(LNRW)=LENRW
      IWORK(LNPD)=LENPD
      IWORK(LLOCWP) = LENPD-LENWP+1
      IF(LRW.LT.LENRW)GO TO 704
      IF(LIW.LT.LENIW)GO TO 705
c
c     Check ICNSTR for legality.
c
      IF (LENIC .GT. 0) THEN
      DO 40 I = 1,NEQ
      ICI = IWORK(LICNS-1+I)
      IF (ICI .LT. -2 .OR. ICI .GT. 2) GO TO 726
   40 CONTINUE
      ENDIF
c
c     Check Y for consistency with constraints.
c
      IF (LENIC .GT. 0) THEN
      CALL SCNST0(NEQ,Y,IWORK(LICNS),IRET)
      IF (IRET .NE. 0) GO TO 727
      ENDIF
c
c     Check ID for legality.
c
      IF (LENID .GT. 0) THEN
      DO 50 I = 1,NEQ
      IDI = IWORK(LID-1+I)
      IF (IDI .NE. 1 .AND. IDI .NE. -1) GO TO 724
   50 CONTINUE
      ENDIF
c
c     Check to see that TOUT is different from T.
c
      IF(TOUT .EQ. T)GO TO 719
c
c     Check HMAX.
c
      IF(INFO(7) .NE. 0) THEN
      HMAX = RWORK(LHMAX)
      IF (HMAX .LE. 0.0d0) GO TO 710
      ENDIF
c
c     Initialize counters and other flags.
c
      IWORK(LNST)=0
      IWORK(LNRE)=0
      IWORK(LNJE)=0
      IWORK(LETF)=0
      IWORK(LNCFN)=0
      IWORK(LNNI)=0
      IWORK(LNLI)=0
      IWORK(LNPS)=0
      IWORK(LNCFL)=0
      IWORK(LKPRIN)=INFO(18)
      IDID=1
      GO TO 200
c
c-----------------------------------------------------------------------
c     This block is for continuation calls only.
c     Here we check INFO(1), and if the last step was interrupted,
c     we check whether appropriate action was taken.
c-----------------------------------------------------------------------
c
  100 CONTINUE
      IF(INFO(1).EQ.1)GO TO 110
      ITEMP = 1
      IF(INFO(1).NE.-1)GO TO 701
c
c     If we are here, the last step was interrupted by an error
c     condition from SDSTP, and appropriate action was not taken.
c     This is a fatal error.
c
      MSG = 'DASPK--  THE LAST STEP TERMINATED WITH A NEGATIVE'
      CALL dxerrwv_u(MSG,49,201,0,0,0,0,0,0.0d0,0.0d0)
      MSG = 'DASPK--  VALUE (=I1) OF IDID AND NO APPROPRIATE'
      CALL dxerrwv_u(MSG,47,202,0,1,IDID,0,0,0.0d0,0.0d0)
      MSG = 'DASPK--  ACTION WAS TAKEN. RUN TERMINATED'
      CALL dxerrwv_u(MSG,41,203,1,0,0,0,0,0.0d0,0.0d0)
      RETURN
  110 CONTINUE
c
c-----------------------------------------------------------------------
c     This block is executed on all calls.
c
c     Counters are saved for later checks of performance.
c     Then the error tolerance parameters are checked, and the
c     work array pointers are set.
c-----------------------------------------------------------------------
c
  200 CONTINUE
c
c     Save counters for use later.
c
      IWORK(LNSTL)=IWORK(LNST)
      NLI0 = IWORK(LNLI)
      NNI0 = IWORK(LNNI)
      NCFN0 = IWORK(LNCFN)
      NCFL0 = IWORK(LNCFL)
      NWARN = 0
c
c     Check RTOL and ATOL.
c
      NZFLG = 0
      RTOLI = RTOL(1)
      ATOLI = ATOL(1)
      DO 210 I=1,NEQ
      IF (INFO(2) .EQ. 1) RTOLI = RTOL(I)
      IF (INFO(2) .EQ. 1) ATOLI = ATOL(I)
      IF (RTOLI .GT. 0.0d0 .OR. ATOLI .GT. 0.0d0) NZFLG = 1
      IF (RTOLI .LT. 0.0d0) GO TO 706
      IF (ATOLI .LT. 0.0d0) GO TO 707
  210 CONTINUE
      IF (NZFLG .EQ. 0) GO TO 708
c
c     Set pointers to RWORK and IWORK segments.
c     For direct methods, SAVR is not used.
c
      IWORK(LLCIWP) = LID + LENID
      LSAVR = LDELTA
      IF (INFO(12) .NE. 0) LSAVR = LDELTA + NEQ
      LE = LSAVR + NEQ
      LWT = LE + NEQ
      LVT = LWT
      IF (INFO(16) .NE. 0) LVT = LWT + NEQ
      LPHI = LVT + NEQ
      LWM = LPHI + (IWORK(LMXORD)+1)*NEQ
      IF (INFO(1) .EQ. 1) GO TO 400
c
c-----------------------------------------------------------------------
c     This block is executed on the initial call only.
c     Set the initial step size, the error weight vector, and PHI.
c     Compute unknown initial components of Y and YPRIME, if requested.
c-----------------------------------------------------------------------
c
  300 CONTINUE
      TN=T
      IDID=1
c
c     Set error weight array WT and altered weight array VT.
c
      CALL SDAWTS(NEQ,INFO(2),RTOL,ATOL,Y,RWORK(LWT),RPAR,IPAR)
      CALL SINVWT(NEQ,RWORK(LWT),IER)
      IF (IER .NE. 0) GO TO 713
      IF (INFO(16) .NE. 0) THEN
      DO 305 I = 1, NEQ
  305 RWORK(LVT+I-1) = MAX(IWORK(LID+I-1),0)*RWORK(LWT+I-1)
      ENDIF
c
c     Compute unit roundoff and HMIN.
c
      UROUND = R1MACH8(4)
      RWORK(LROUND) = UROUND
      HMIN = 4.0d0*UROUND*MAX(ABS(T),ABS(TOUT))
c
c     Set/check STPTOL control for initial condition calculation.
c
      IF (INFO(11) .NE. 0) THEN
      IF( INFO(17) .EQ. 0) THEN
      RWORK(LSTOL) = UROUND**.6667d0
      ELSE
      IF (RWORK(LSTOL) .LE. 0.0d0) GO TO 725
      ENDIF
      ENDIF
c
c     Compute EPCON and square root of NEQ and its reciprocal, used
c     inside iterative solver.
c
      RWORK(LEPCON) = 0.33d0
      FLOATN = NEQ
      RWORK(LSQRN) = SQRT(FLOATN)
      RWORK(LRSQRN) = 1.d0/RWORK(LSQRN)
c
c     Check initial interval to see that it is long enough.
c
      TDIST = ABS(TOUT - T)
      IF(TDIST .LT. HMIN) GO TO 714
c
c     Check H0, if this was input.
c
      IF (INFO(8) .EQ. 0) GO TO 310
      H0 = RWORK(LH)
      IF ((TOUT - T)*H0 .LT. 0.0d0) GO TO 711
      IF (H0 .EQ. 0.0d0) GO TO 712
      GO TO 320
  310 CONTINUE
c
c     Compute initial stepsize, to be used by either
c     SDSTP or SDASIC, depending on INFO(11).
c
      H0 = 0.001d0*TDIST
      YPNORM = SDWNRM(NEQ,YPRIME,RWORK(LVT),RPAR,IPAR)
      IF (YPNORM .GT. 0.5d0/H0) H0 = 0.5d0/YPNORM
      H0 = SIGN(H0,TOUT-T)
c
c     Adjust H0 if necessary to meet HMAX bound.
c
  320 IF (INFO(7) .EQ. 0) GO TO 330
      RH = ABS(H0)/RWORK(LHMAX)
      IF (RH .GT. 1.0d0) H0 = H0/RH
c
c     Check against TSTOP, if applicable.
c
  330 IF (INFO(4) .EQ. 0) GO TO 340
      TSTOP = RWORK(LTSTOP)
      IF ((TSTOP - T)*H0 .LT. 0.0d0) GO TO 715
      IF ((T + H0 - TSTOP)*H0 .GT. 0.0d0) H0 = TSTOP - T
      IF ((TSTOP - TOUT)*H0 .LT. 0.0d0) GO TO 709
c
  340 IF (INFO(11) .EQ. 0) GO TO 370
c
c     Compute unknown components of initial Y and YPRIME, depending
c     on INFO(11) and INFO(12).  INFO(12) represents the nonlinear
c     solver type (direct/Krylov).  Pass the name of the specific
c     nonlinear solver, depending on INFO(12).  The location of the work
c     arrays SAVR, YIC, YPIC, PWK also differ in the two cases.
c
      NWT = 1
      EPCONI = RWORK(LEPIN)*RWORK(LEPCON)
  350 IF (INFO(12) .EQ. 0) THEN
      LYIC = LPHI + 2*NEQ
      LYPIC = LYIC + NEQ
      LPWK = LYPIC
      CALL SDASIC(TN,Y,YPRIME,NEQ,INFO(11),IWORK(LID), RES,JAC,PSOL,H0,
     &   RWORK(LWT),NWT,IDID,RPAR,IPAR, RWORK(LPHI),RWORK(LSAVR),RWORK(
     &   LDELTA),RWORK(LE), RWORK(LYIC),RWORK(LYPIC),RWORK(LPWK),RWORK(
     &   LWM),IWORK(LIWM), HMIN,RWORK(LROUND),RWORK(LEPLI),RWORK(LSQRN),
     &   RWORK(LRSQRN), EPCONI,RWORK(LSTOL),INFO(15),ICNFLG,IWORK(LICNS)
     &   ,SDASID)
      ELSE IF (INFO(12) .EQ. 1) THEN
      LYIC = LWM
      LYPIC = LYIC + NEQ
      LPWK = LYPIC + NEQ
      CALL SDASIC(TN,Y,YPRIME,NEQ,INFO(11),IWORK(LID), RES,JAC,PSOL,H0,
     &   RWORK(LWT),NWT,IDID,RPAR,IPAR, RWORK(LPHI),RWORK(LSAVR),RWORK(
     &   LDELTA),RWORK(LE), RWORK(LYIC),RWORK(LYPIC),RWORK(LPWK),RWORK(
     &   LWM),IWORK(LIWM), HMIN,RWORK(LROUND),RWORK(LEPLI),RWORK(LSQRN),
     &   RWORK(LRSQRN), EPCONI,RWORK(LSTOL),INFO(15),ICNFLG,IWORK(LICNS)
     &   ,SDASIK)
      ENDIF
c
      IF (IDID .LT. 0) GO TO 600
c
c     SDASIC was successful.  If this was the first call to SDASIC,
c     update the WT array (with the current Y) and call it again.
c
      IF (NWT .EQ. 2) GO TO 355
      NWT = 2
      CALL SDAWTS(NEQ,INFO(2),RTOL,ATOL,Y,RWORK(LWT),RPAR,IPAR)
      CALL SINVWT(NEQ,RWORK(LWT),IER)
      IF (IER .NE. 0) GO TO 713
      GO TO 350
c
c     If INFO(14) = 1, return now with IDID = 4.
c
  355 IF (INFO(14) .EQ. 1) THEN
      IDID = 4
      H = H0
      IF (INFO(11) .EQ. 1) RWORK(LHOLD) = H0
      GO TO 590
      ENDIF
c
c     Update the WT and VT arrays one more time, with the new Y.
c
      CALL SDAWTS(NEQ,INFO(2),RTOL,ATOL,Y,RWORK(LWT),RPAR,IPAR)
      CALL SINVWT(NEQ,RWORK(LWT),IER)
      IF (IER .NE. 0) GO TO 713
      IF (INFO(16) .NE. 0) THEN
      DO 357 I = 1, NEQ
  357 RWORK(LVT+I-1) = MAX(IWORK(LID+I-1),0)*RWORK(LWT+I-1)
      ENDIF
c
c     Reset the initial stepsize to be used by SDSTP.
c     Use H0, if this was input.  Otherwise, recompute H0,
c     and adjust it if necessary to meet HMAX bound.
c
      IF (INFO(8) .NE. 0) THEN
      H0 = RWORK(LH)
      GO TO 360
      ENDIF
c
      H0 = 0.001d0*TDIST
      YPNORM = SDWNRM(NEQ,YPRIME,RWORK(LVT),RPAR,IPAR)
      IF (YPNORM .GT. 0.5d0/H0) H0 = 0.5d0/YPNORM
      H0 = SIGN(H0,TOUT-T)
c
  360 IF (INFO(7) .NE. 0) THEN
      RH = ABS(H0)/RWORK(LHMAX)
      IF (RH .GT. 1.0d0) H0 = H0/RH
      ENDIF
c
c     Check against TSTOP, if applicable.
c
      IF (INFO(4) .NE. 0) THEN
      TSTOP = RWORK(LTSTOP)
      IF ((T + H0 - TSTOP)*H0 .GT. 0.0d0) H0 = TSTOP - T
      ENDIF
c
c     Load H and RWORK(LH) with H0.
c
  370 H = H0
      RWORK(LH) = H
c
c     Load Y and H*YPRIME into PHI(*,1) and PHI(*,2).
c
      ITEMP = LPHI + NEQ
      DO 380 I = 1,NEQ
      RWORK(LPHI + I - 1) = Y(I)
  380 RWORK(ITEMP + I - 1) = H*YPRIME(I)
c
      GO TO 500
c
c-----------------------------------------------------------------------
c     This block is for continuation calls only.
c     Its purpose is to check stop conditions before taking a step.
c     Adjust H if necessary to meet HMAX bound.
c-----------------------------------------------------------------------
c
  400 CONTINUE
      UROUND=RWORK(LROUND)
      done = .false.
      TN=RWORK(LTN)
      H=RWORK(LH)
      IF(INFO(7) .EQ. 0) GO TO 410
      RH = ABS(H)/RWORK(LHMAX)
      IF(RH .GT. 1.0d0) H = H/RH
  410 CONTINUE
      IF(T .EQ. TOUT) GO TO 719
      IF((T - TOUT)*H .GT. 0.0d0) GO TO 711
      IF(INFO(4) .EQ. 1) GO TO 430
      IF(INFO(3) .EQ. 1) GO TO 420
      IF((TN-TOUT)*H.LT.0.0d0)GO TO 490
      CALL SDATRP(TN,TOUT,Y,YPRIME,NEQ,IWORK(LKOLD), RWORK(LPHI),RWORK(
     &   LPSI))
      T=TOUT
      IDID = 3
      done = .true.
      GO TO 490
  420 IF((TN-T)*H .LE. 0.0d0) GO TO 490
      IF((TN - TOUT)*H .GT. 0.0d0) GO TO 425
      CALL SDATRP(TN,TN,Y,YPRIME,NEQ,IWORK(LKOLD), RWORK(LPHI),RWORK(
     &   LPSI))
      T = TN
      IDID = 1
      done = .true.
      GO TO 490
  425 CONTINUE
      CALL SDATRP(TN,TOUT,Y,YPRIME,NEQ,IWORK(LKOLD), RWORK(LPHI),RWORK(
     &   LPSI))
      T = TOUT
      IDID = 3
      done = .true.
      GO TO 490
  430 IF(INFO(3) .EQ. 1) GO TO 440
      TSTOP=RWORK(LTSTOP)
      IF((TN-TSTOP)*H.GT.0.0d0) GO TO 715
      IF((TSTOP-TOUT)*H.LT.0.0d0)GO TO 709
      IF((TN-TOUT)*H.LT.0.0d0)GO TO 450
      CALL SDATRP(TN,TOUT,Y,YPRIME,NEQ,IWORK(LKOLD), RWORK(LPHI),RWORK(
     &   LPSI))
      T=TOUT
      IDID = 3
      done = .true.
      GO TO 490
  440 TSTOP = RWORK(LTSTOP)
      IF((TN-TSTOP)*H .GT. 0.0d0) GO TO 715
      IF((TSTOP-TOUT)*H .LT. 0.0d0) GO TO 709
      IF((TN-T)*H .LE. 0.0d0) GO TO 450
      IF((TN - TOUT)*H .GT. 0.0d0) GO TO 445
      CALL SDATRP(TN,TN,Y,YPRIME,NEQ,IWORK(LKOLD), RWORK(LPHI),RWORK(
     &   LPSI))
      T = TN
      IDID = 1
      done = .true.
      GO TO 490
  445 CONTINUE
      CALL SDATRP(TN,TOUT,Y,YPRIME,NEQ,IWORK(LKOLD), RWORK(LPHI),RWORK(
     &   LPSI))
      T = TOUT
      IDID = 3
      done = .true.
      GO TO 490
  450 CONTINUE
c
c     Check whether we are within roundoff of TSTOP.
c
      IF(ABS(TN-TSTOP).GT.100.0d0*UROUND* (ABS(TN)+ABS(H)))GO TO 460
      CALL SDATRP(TN,TSTOP,Y,YPRIME,NEQ,IWORK(LKOLD), RWORK(LPHI),RWORK(
     &   LPSI))
      IDID=2
      T=TSTOP
      done = .true.
      GO TO 490
  460 TNEXT=TN+H
      IF((TNEXT-TSTOP)*H.LE.0.0d0)GO TO 490
      H=TSTOP-TN
      RWORK(LH)=H
c
  490 IF (done) GO TO 590
c
c-----------------------------------------------------------------------
c     The next block contains the call to the one-step integrator SDSTP.
c     This is a looping point for the integration steps.
c     Check for too many steps.
c     Check for poor Newton/Krylov performance.
c     Update WT.  Check for too much accuracy requested.
c     Compute minimum stepsize.
c-----------------------------------------------------------------------
c
  500 CONTINUE
c
c     Check for too many steps.
c
      IF((IWORK(LNST)-IWORK(LNSTL)).LT.500) GO TO 505
      IDID=-1
      GO TO 527
c
c Check for poor Newton/Krylov performance.
c
  505 IF (INFO(12) .EQ. 0) GO TO 510
      NSTD = IWORK(LNST) - IWORK(LNSTL)
      NNID = IWORK(LNNI) - NNI0
      IF (NSTD .LT. 10 .OR. NNID .EQ. 0) GO TO 510
      AVLIN = dble(IWORK(LNLI) - NLI0)/dble(NNID)
      RCFN = dble(IWORK(LNCFN) - NCFN0)/dble(NSTD)
      RCFL = dble(IWORK(LNCFL) - NCFL0)/dble(NNID)
      FMAXL = IWORK(LMAXL)
      LAVL = AVLIN .GT. FMAXL
      LCFN = RCFN .GT. 0.9d0
      LCFL = RCFL .GT. 0.9d0
      LWARN = LAVL .OR. LCFN .OR. LCFL
      IF (.NOT.LWARN) GO TO 510
      NWARN = NWARN + 1
      IF (NWARN .GT. 10) GO TO 510
      IF (LAVL) THEN
      MSG = 'DASPK-- Warning. Poor iterative algorithm performance   '
      CALL dxerrwv_u(MSG, 56, 501, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      MSG = '      at T = R1. Average no. of linear iterations = R2  '
      CALL dxerrwv_u(MSG, 56, 501, 0, 0, 0, 0, 2, TN, AVLIN)
      ENDIF
      IF (LCFN) THEN
      MSG = 'DASPK-- Warning. Poor iterative algorithm performance   '
      CALL dxerrwv_u(MSG, 56, 502, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      MSG = '      at T = R1. Nonlinear convergence failure rate = R2'
      CALL dxerrwv_u(MSG, 56, 502, 0, 0, 0, 0, 2, TN, RCFN)
      ENDIF
      IF (LCFL) THEN
      MSG = 'DASPK-- Warning. Poor iterative algorithm performance   '
      CALL dxerrwv_u(MSG, 56, 503, 0, 0, 0, 0, 0, 0.0d0, 0.0d0)
      MSG = '      at T = R1. Linear convergence failure rate = R2   '
      CALL dxerrwv_u(MSG, 56, 503, 0, 0, 0, 0, 2, TN, RCFL)
      ENDIF
c
c     Update WT and VT, if this is not the first call.
c
  510 CALL SDAWTS(NEQ,INFO(2),RTOL,ATOL,RWORK(LPHI),RWORK(LWT), RPAR,
     &   IPAR)
      CALL SINVWT(NEQ,RWORK(LWT),IER)
      IF (IER .NE. 0) THEN
      IDID = -3
      GO TO 527
      ENDIF
      IF (INFO(16) .NE. 0) THEN
      DO 515 I = 1, NEQ
  515 RWORK(LVT+I-1) = MAX(IWORK(LID+I-1),0)*RWORK(LWT+I-1)
      ENDIF
c
c     Test for too much accuracy requested.
c
      R = SDWNRM(NEQ,RWORK(LPHI),RWORK(LWT),RPAR,IPAR)*100.0d0*UROUND
      IF (R .LE. 1.0d0) GO TO 525
c
c     Multiply RTOL and ATOL by R and return.
c
      IF(INFO(2).EQ.1)GO TO 523
      RTOL(1)=R*RTOL(1)
      ATOL(1)=R*ATOL(1)
      IDID=-2
      GO TO 527
  523 DO 524 I=1,NEQ
      RTOL(I)=R*RTOL(I)
  524 ATOL(I)=R*ATOL(I)
      IDID=-2
      GO TO 527
  525 CONTINUE
c
c     Compute minimum stepsize.
c
      HMIN=4.0d0*UROUND*MAX(ABS(TN),ABS(TOUT))
c
c     Test H vs. HMAX
      IF (INFO(7) .NE. 0) THEN
      RH = ABS(H)/RWORK(LHMAX)
      IF (RH .GT. 1.0d0) H = H/RH
      ENDIF
c
c     Call the one-step integrator.
c     Note that INFO(12) represents the nonlinear solver type.
c     Pass the required nonlinear solver, depending upon INFO(12).
c
      EPCON = RWORK(LEPNL)*RWORK(LEPCON)
      IF (INFO(12) .EQ. 0) THEN
      CALL SDSTP(TN,Y,YPRIME,NEQ, RES,JAC,PSOL,H,RWORK(LWT),RWORK(LVT),
     &   INFO(1),IDID,RPAR,IPAR, RWORK(LPHI),RWORK(LSAVR),RWORK(LDELTA),
     &   RWORK(LE), RWORK(LWM),IWORK(LIWM), RWORK(LALPHA),RWORK(LBETA),
     &   RWORK(LGAMMA), RWORK(LPSI),RWORK(LSIGMA), RWORK(LCJ),RWORK(
     &   LCJOLD),RWORK(LHOLD),RWORK(LS),HMIN, RWORK(LROUND), RWORK(LEPLI
     &   ),RWORK(LSQRN),RWORK(LRSQRN), EPCON, IWORK(LPHASE),IWORK(LJCALC
     &   ),INFO(15), IWORK(LK), IWORK(LKOLD),IWORK(LNS),NONNEG,INFO(12), 
     &   SNEDD,RWORK(1),IWORK(1))
c ... Last two arguments are added to accommodate the run-time diagnostics
      ELSE IF (INFO(12) .EQ. 1) THEN
      CALL SDSTP(TN,Y,YPRIME,NEQ, RES,JAC,PSOL,H,RWORK(LWT),RWORK(LVT),
     &   INFO(1),IDID,RPAR,IPAR, RWORK(LPHI),RWORK(LSAVR),RWORK(LDELTA),
     &   RWORK(LE), RWORK(LWM),IWORK(LIWM), RWORK(LALPHA),RWORK(LBETA),
     &   RWORK(LGAMMA), RWORK(LPSI),RWORK(LSIGMA), RWORK(LCJ),RWORK(
     &   LCJOLD),RWORK(LHOLD),RWORK(LS),HMIN, RWORK(LROUND), RWORK(LEPLI
     &   ),RWORK(LSQRN),RWORK(LRSQRN), EPCON, IWORK(LPHASE),IWORK(LJCALC
     &   ),INFO(15), IWORK(LK), IWORK(LKOLD),IWORK(LNS),NONNEG,INFO(12), 
     &   SNEDK,RWORK(1),IWORK(1))
c ... Last two arguments are added to accommodate the run-time diagnostics
      ENDIF
c
  527 IF(IDID.LT.0)GO TO 600
c
c-----------------------------------------------------------------------
c     This block handles the case of a successful return from SDSTP
c     (IDID=1).  Test for stop conditions.
c-----------------------------------------------------------------------
c
      IF(INFO(4).NE.0)GO TO 540
      IF(INFO(3).NE.0)GO TO 530
      IF((TN-TOUT)*H.LT.0.0d0)GO TO 500
      CALL SDATRP(TN,TOUT,Y,YPRIME,NEQ, IWORK(LKOLD),RWORK(LPHI),RWORK(
     &   LPSI))
      IDID=3
      T=TOUT
      GO TO 580
  530 IF((TN-TOUT)*H.GE.0.0d0)GO TO 535
      T=TN
      IDID=1
      GO TO 580
  535 CALL SDATRP(TN,TOUT,Y,YPRIME,NEQ, IWORK(LKOLD),RWORK(LPHI),RWORK(
     &   LPSI))
      IDID=3
      T=TOUT
      GO TO 580
  540 IF(INFO(3).NE.0)GO TO 550
      IF((TN-TOUT)*H.LT.0.0d0)GO TO 542
      CALL SDATRP(TN,TOUT,Y,YPRIME,NEQ, IWORK(LKOLD),RWORK(LPHI),RWORK(
     &   LPSI))
      T=TOUT
      IDID=3
      GO TO 580
  542 IF(ABS(TN-TSTOP).LE.100.0d0*UROUND* (ABS(TN)+ABS(H)))GO TO 545
      TNEXT=TN+H
      IF((TNEXT-TSTOP)*H.LE.0.0d0)GO TO 500
      H=TSTOP-TN
      GO TO 500
  545 CALL SDATRP(TN,TSTOP,Y,YPRIME,NEQ, IWORK(LKOLD),RWORK(LPHI),RWORK(
     &   LPSI))
      IDID=2
      T=TSTOP
      GO TO 580
  550 IF((TN-TOUT)*H.GE.0.0d0)GO TO 555
      IF(ABS(TN-TSTOP).LE.100.0d0*UROUND*(ABS(TN)+ABS(H)))GO TO 552
      T=TN
      IDID=1
      GO TO 580
  552 CALL SDATRP(TN,TSTOP,Y,YPRIME,NEQ, IWORK(LKOLD),RWORK(LPHI),RWORK(
     &   LPSI))
      IDID=2
      T=TSTOP
      GO TO 580
  555 CALL SDATRP(TN,TOUT,Y,YPRIME,NEQ, IWORK(LKOLD),RWORK(LPHI),RWORK(
     &   LPSI))
      T=TOUT
      IDID=3
  580 CONTINUE
c
c-----------------------------------------------------------------------
c     All successful returns from SDASPK are made from this block.
c-----------------------------------------------------------------------
c
  590 CONTINUE
      RWORK(LTN)=TN
      RWORK(LH)=H
      RETURN
c
c-----------------------------------------------------------------------
c     This block handles all unsuccessful returns other than for
c     illegal input.
c-----------------------------------------------------------------------
c
  600 CONTINUE
      ITEMP = -IDID
      GO TO (610,620,630,700,655,640,650,660,670,675, 680,685,690,695), 
     &   ITEMP
c
c     The maximum number of steps was taken before
c     reaching tout.
c
  610 MSG = 'DASPK--  AT CURRENT T (=R1)  500 STEPS'
      CALL dxerrwv_u(MSG,38,610,0,0,0,0,1,TN,0.0d0)
      MSG = 'DASPK--  TAKEN ON THIS CALL BEFORE REACHING TOUT'
      CALL dxerrwv_u(MSG,48,611,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     Too much accuracy for machine precision.
c
  620 MSG = 'DASPK--  AT T (=R1) TOO MUCH ACCURACY REQUESTED'
      CALL dxerrwv_u(MSG,47,620,0,0,0,0,1,TN,0.0d0)
      MSG = 'DASPK--  FOR PRECISION OF MACHINE. RTOL AND ATOL'
      CALL dxerrwv_u(MSG,48,621,0,0,0,0,0,0.0d0,0.0d0)
      MSG = 'DASPK--  WERE INCREASED TO APPROPRIATE VALUES'
      CALL dxerrwv_u(MSG,45,622,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     WT(I) .LE. 0.0E0 for some I (not at start of problem).
c
  630 MSG = 'DASPK--  AT T (=R1) SOME ELEMENT OF WT'
      CALL dxerrwv_u(MSG,38,630,0,0,0,0,1,TN,0.0d0)
      MSG = 'DASPK--  HAS BECOME .LE. 0.0'
      CALL dxerrwv_u(MSG,28,631,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     Error test failed repeatedly or with H=HMIN.
c
  640 MSG = 'DASPK--  AT T (=R1) AND STEPSIZE H (=R2) THE'
      CALL dxerrwv_u(MSG,44,640,0,0,0,0,2,TN,H)
      MSG='DASPK--  ERROR TEST FAILED REPEATEDLY OR WITH ABS(H)=HMIN'
      CALL dxerrwv_u(MSG,57,641,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     Nonlinear solver failed to converge repeatedly or with H=HMIN.
c
  650 MSG = 'DASPK--  AT T (=R1) AND STEPSIZE H (=R2) THE'
      CALL dxerrwv_u(MSG,44,650,0,0,0,0,2,TN,H)
      MSG = 'DASPK--  NONLINEAR SOLVER FAILED TO CONVERGE'
      CALL dxerrwv_u(MSG,44,651,0,0,0,0,0,0.0d0,0.0d0)
      MSG = 'DASPK--  REPEATEDLY OR WITH ABS(H)=HMIN'
      CALL dxerrwv_u(MSG,40,652,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     The preconditioner had repeated failures.
c
  655 MSG = 'DASPK--  AT T (=R1) AND STEPSIZE H (=R2) THE'
      CALL dxerrwv_u(MSG,44,655,0,0,0,0,2,TN,H)
      MSG = 'DASPK--  PRECONDITIONER HAD REPEATED FAILURES.'
      CALL dxerrwv_u(MSG,46,656,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     The iteration matrix is singular.
c
  660 MSG = 'DASPK--  AT T (=R1) AND STEPSIZE H (=R2) THE'
      CALL dxerrwv_u(MSG,44,660,0,0,0,0,2,TN,H)
      MSG = 'DASPK--  ITERATION MATRIX IS SINGULAR.'
      CALL dxerrwv_u(MSG,38,661,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     Nonlinear system failure preceded by error test failures.
c
  670 MSG = 'DASPK--  AT T (=R1) AND STEPSIZE H (=R2) THE'
      CALL dxerrwv_u(MSG,44,670,0,0,0,0,2,TN,H)
      MSG = 'DASPK--  NONLINEAR SOLVER COULD NOT CONVERGE.'
      CALL dxerrwv_u(MSG,45,671,0,0,0,0,0,0.0d0,0.0d0)
      MSG = 'DASPK--  ALSO, THE ERROR TEST FAILED REPEATEDLY.'
      CALL dxerrwv_u(MSG,49,672,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     Nonlinear system failure because IRES = -1.
c
  675 MSG = 'DASPK--  AT T (=R1) AND STEPSIZE H (=R2) THE'
      CALL dxerrwv_u(MSG,44,675,0,0,0,0,2,TN,H)
      MSG = 'DASPK--  NONLINEAR SYSTEM SOLVER COULD NOT CONVERGE'
      CALL dxerrwv_u(MSG,51,676,0,0,0,0,0,0.0d0,0.0d0)
      MSG = 'DASPK--  BECAUSE IRES WAS EQUAL TO MINUS ONE'
      CALL dxerrwv_u(MSG,44,677,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     Failure because IRES = -2.
c
  680 MSG = 'DASPK--  AT T (=R1) AND STEPSIZE H (=R2)'
      CALL dxerrwv_u(MSG,40,680,0,0,0,0,2,TN,H)
      MSG = 'DASPK--  IRES WAS EQUAL TO MINUS TWO'
      CALL dxerrwv_u(MSG,36,681,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     Failed to compute initial YPRIME.
c
  685 MSG = 'DASPK--  AT T (=R1) AND STEPSIZE H (=R2) THE'
      CALL dxerrwv_u(MSG,44,685,0,0,0,0,0,0.0d0,0.0d0)
      MSG = 'DASPK--  INITIAL (Y,YPRIME) COULD NOT BE COMPUTED'
      CALL dxerrwv_u(MSG,49,686,0,0,0,0,2,TN,H0)
      GO TO 700
c
c     Failure because IER was negative from PSOL.
c
  690 MSG = 'DASPK--  AT T (=R1) AND STEPSIZE H (=R2)'
      CALL dxerrwv_u(MSG,40,690,0,0,0,0,2,TN,H)
      MSG = 'DASPK--  IER WAS NEGATIVE FROM PSOL'
      CALL dxerrwv_u(MSG,35,691,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c     Failure because the linear system solver could not converge.
c
  695 MSG = 'DASPK--  AT T (=R1) AND STEPSIZE H (=R2) THE'
      CALL dxerrwv_u(MSG,44,695,0,0,0,0,2,TN,H)
      MSG = 'DASPK--  LINEAR SYSTEM SOLVER COULD NOT CONVERGE.'
      CALL dxerrwv_u(MSG,50,696,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 700
c
c
  700 CONTINUE
      INFO(1)=-1
      T=TN
      RWORK(LTN)=TN
      RWORK(LH)=H
      RETURN
c
c-----------------------------------------------------------------------
c     This block handles all error returns due to illegal input,
c     as detected before calling SDSTP.
c     First the error message routine is called.  If this happens
c     twice in succession, execution is terminated.
c-----------------------------------------------------------------------
c
  701 MSG = 'DASPK--  ELEMENT (=I1) OF INFO VECTOR IS NOT VALID'
      CALL dxerrwv_u(MSG,50,1,0,1,ITEMP,0,0,0.0d0,0.0d0)
      GO TO 750
  702 MSG = 'DASPK--  NEQ (=I1) .LE. 0'
      CALL dxerrwv_u(MSG,25,2,0,1,NEQ,0,0,0.0d0,0.0d0)
      GO TO 750
  703 MSG = 'DASPK--  MAXORD (=I1) NOT IN RANGE'
      CALL dxerrwv_u(MSG,34,3,0,1,MXORD,0,0,0.0d0,0.0d0)
      GO TO 750
  704 MSG='DASPK--  RWORK LENGTH NEEDED, LENRW (=I1), EXCEEDS LRW (=I2)'
      CALL dxerrwv_u(MSG,60,4,0,2,LENRW,LRW,0,0.0d0,0.0d0)
      GO TO 750
  705 MSG='DASPK--  IWORK LENGTH NEEDED, LENIW (=I1), EXCEEDS LIW (=I2)'
      CALL dxerrwv_u(MSG,60,5,0,2,LENIW,LIW,0,0.0d0,0.0d0)
      GO TO 750
  706 MSG = 'DASPK--  SOME ELEMENT OF RTOL IS .LT. 0'
      CALL dxerrwv_u(MSG,39,6,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 750
  707 MSG = 'DASPK--  SOME ELEMENT OF ATOL IS .LT. 0'
      CALL dxerrwv_u(MSG,39,7,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 750
  708 MSG = 'DASPK--  ALL ELEMENTS OF RTOL AND ATOL ARE ZERO'
      CALL dxerrwv_u(MSG,47,8,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 750
  709 MSG='DASPK--  INFO(4) = 1 AND TSTOP (=R1) BEHIND TOUT (=R2)'
      CALL dxerrwv_u(MSG,54,9,0,0,0,0,2,TSTOP,TOUT)
      GO TO 750
  710 MSG = 'DASPK--  HMAX (=R1) .LT. 0.0'
      CALL dxerrwv_u(MSG,28,10,0,0,0,0,1,HMAX,0.0d0)
      GO TO 750
  711 MSG = 'DASPK--  TOUT (=R1) BEHIND T (=R2)'
      CALL dxerrwv_u(MSG,34,11,0,0,0,0,2,TOUT,T)
      GO TO 750
  712 MSG = 'DASPK--  INFO(8)=1 AND H0=0.0'
      CALL dxerrwv_u(MSG,29,12,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 750
  713 MSG = 'DASPK--  SOME ELEMENT OF WT IS .LE. 0.0'
      CALL dxerrwv_u(MSG,39,13,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 750
  714 MSG='DASPK-- TOUT (=R1) TOO CLOSE TO T (=R2) TO START INTEGRATION'
      CALL dxerrwv_u(MSG,60,14,0,0,0,0,2,TOUT,T)
      GO TO 750
  715 MSG = 'DASPK--  INFO(4)=1 AND TSTOP (=R1) BEHIND T (=R2)'
      CALL dxerrwv_u(MSG,49,15,0,0,0,0,2,TSTOP,T)
      GO TO 750
  717 MSG = 'DASPK--  ML (=I1) ILLEGAL. EITHER .LT. 0 OR .GT. NEQ'
      CALL dxerrwv_u(MSG,52,17,0,1,IWORK(LML),0,0,0.0d0,0.0d0)
      GO TO 750
  718 MSG = 'DASPK--  MU (=I1) ILLEGAL. EITHER .LT. 0 OR .GT. NEQ'
      CALL dxerrwv_u(MSG,52,18,0,1,IWORK(LMU),0,0,0.0d0,0.0d0)
      GO TO 750
  719 MSG = 'DASPK--  TOUT (=R1) IS EQUAL TO T (=R2)'
      CALL dxerrwv_u(MSG,39,19,0,0,0,0,2,TOUT,T)
      GO TO 750
  720 MSG = 'DASPK--  MAXL (=I1) ILLEGAL. EITHER .LT. 1 OR .GT. NEQ'
      CALL dxerrwv_u(MSG,54,20,0,1,IWORK(LMAXL),0,0,0.0d0,0.0d0)
      GO TO 750
  721 MSG = 'DASPK--  KMP (=I1) ILLEGAL. EITHER .LT. 1 OR .GT. MAXL'
      CALL dxerrwv_u(MSG,54,21,0,1,IWORK(LKMP),0,0,0.0d0,0.0d0)
      GO TO 750
  722 MSG = 'DASPK--  NRMAX (=I1) ILLEGAL. .LT. 0'
      CALL dxerrwv_u(MSG,36,22,0,1,IWORK(LNRMAX),0,0,0.0d0,0.0d0)
      GO TO 750
  723 MSG = 'DASPK--  EPLI (=R1) ILLEGAL. EITHER .LE. 0.E0 OR .GE. 1.E0'
      CALL dxerrwv_u(MSG,58,23,0,0,0,0,1,RWORK(LEPLI),0.0d0)
      GO TO 750
  724 MSG = 'DASPK--  ILLEGAL IWORK VALUE FOR INFO(11) .NE. 0'
      CALL dxerrwv_u(MSG,48,24,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 750
  725 MSG = 'DASPK--  ONE OF THE INPUTS FOR INFO(17) = 1 IS ILLEGAL'
      CALL dxerrwv_u(MSG,54,25,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 750
  726 MSG = 'DASPK--  ILLEGAL IWORK VALUE FOR INFO(10) .NE. 0'
      CALL dxerrwv_u(MSG,48,26,0,0,0,0,0,0.0d0,0.0d0)
      GO TO 750
  727 MSG = 'DASPK--  Y(I) AND IWORK(40+I) (I=I1) INCONSISTENT'
      CALL dxerrwv_u(MSG,49,27,0,1,IRET,0,0,0.0d0,0.0d0)
      GO TO 750
  728 MSG = 'DASPK--  EPNL (=R1) ILLEGAL. IT MUST BE .GT. 0.E0'
      CALL dxerrwv_u(MSG,49,23,0,0,0,0,1,RWORK(LEPNL),0.0d0)
      GO TO 750
  750 IF(INFO(1).EQ.-1) GO TO 760
      INFO(1)=-1
      IDID=-33
      RETURN
  760 MSG = 'DASPK--  REPEATED OCCURRENCES OF ILLEGAL INPUT'
      CALL dxerrwv_u(MSG,46,701,0,0,0,0,0,0.0d0,0.0d0)
  770 MSG = 'DASPK--  RUN TERMINATED. APPARENT INFINITE LOOP'
      CALL dxerrwv_u(MSG,47,702,1,0,0,0,0,0.0d0,0.0d0)
      RETURN
c
c------END OF SUBROUTINE SDASPK-----------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SDASIC(X,Y,YPRIME,NEQ,ICOPT,ID,RES,JAC,PSOL,H,WT,NIC, 
     &   IDID,RPAR,IPAR,PHI,SAVR,DELTA,E,YIC,YPIC,PWK,WM,IWM,HMIN, 
     &   UROUND,EPLI,SQRTN,RSQRTN,EPCONI,STPTOL,JFLG,ICNFLG,ICNSTR, 
     &   NLSIC)
c
c***BEGIN PROLOGUE  SDASIC
c***REFER TO  SDASPK
c***DATE WRITTEN   940628   (YYMMDD)
c***REVISION DATE  941206   (YYMMDD)
c***REVISION DATE  950714   (YYMMDD)
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SDASIC is a driver routine to compute consistent initial values
c     for Y and YPRIME.  There are two different options:
c     Denoting the differential variables in Y by Y_d, and
c     the algebraic variables by Y_a, the problem solved is either:
c     1.  Given Y_d, calculate Y_a and Y_d', or
c     2.  Given Y', calculate Y.
c     In either case, initial values for the given components
c     are input, and initial guesses for the unknown components
c     must also be provided as input.
c
c     The external routine NLSIC solves the resulting nonlinear system.
c
c     The parameters represent
c
c     X  --        Independent variable.
c     Y  --        Solution vector at X.
c     YPRIME --    Derivative of solution vector.
c     NEQ --       Number of equations to be integrated.
c     ICOPT     -- Flag indicating initial condition option chosen.
c                    ICOPT = 1 for option 1 above.
c                    ICOPT = 2 for option 2.
c     ID        -- Array of dimension NEQ, which must be initialized
c                  if option 1 is chosen.
c                    ID(i) = +1 if Y_i is a differential variable,
c                    ID(i) = -1 if Y_i is an algebraic variable.
c     RES --       External user-supplied subroutine to evaluate the
c                  residual.  See RES description in SDASPK prologue.
c     JAC --       External user-supplied routine to update Jacobian
c                  or preconditioner information in the nonlinear solver
c                  (optional).  See JAC description in SDASPK prologue.
c     PSOL --      External user-supplied routine to solve
c                  a linear system using preconditioning.
c                  See PSOL in SDASPK prologue.
c     H --         Scaling factor in iteration matrix.  SDASIC may
c                  reduce H to achieve convergence.
c     WT --        Vector of weights for error criterion.
c     NIC --       Input number of initial condition calculation call
c                  (= 1 or 2).
c     IDID --      Completion code.  See IDID in SDASPK prologue.
c     RPAR,IPAR -- Real and integer parameter arrays that
c                  are used for communication between the
c                  calling program and external user routines.
c                  They are not altered by SNSK
c     PHI --       Work space for SDASIC of length at least 2*NEQ.
c     SAVR --      Work vector for SDASIC of length NEQ.
c     DELTA --     Work vector for SDASIC of length NEQ.
c     E --         Work vector for SDASIC of length NEQ.
c     YIC,YPIC --  Work vectors for SDASIC, each of length NEQ.
c     PWK --       Work vector for SDASIC of length NEQ.
c     WM,IWM --    Real and integer arrays storing
c                  information required by the linear solver.
c     EPCONI --    Test constant for Newton iteration convergence.
c     ICNFLG --    Flag showing whether constraints on Y are to apply.
c     ICNSTR --    Integer array of length NEQ with constraint types.
c
c     The other parameters are for use internally by SDASIC.
c
c-----------------------------------------------------------------------
c***ROUTINES CALLED
c   SCOPY, NLSIC
c
c***END PROLOGUE  SDASIC
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER IPAR,NEQ,LCFN,LMXNH,MXNH,IWM,IDID,NH,JSKIP,NIC,ICOPT, 
     &   IERNLS,ICNFLG,JFLG,ID,ICNSTR

      DIMENSION Y(*),YPRIME(*),ID(*),WT(*),PHI(NEQ,*)
      DIMENSION SAVR(*),DELTA(*),E(*),YIC(*),YPIC(*),PWK(*)
      DIMENSION WM(*),IWM(*), RPAR(*),IPAR(*), ICNSTR(*)
      EXTERNAL RES, JAC, PSOL, NLSIC
c
      PARAMETER (LCFN=15)
      PARAMETER (LMXNH=34)
c
c-----------------------------------------------------------------------
c The following parameters are data-loaded here:
c     RHCUT  = factor by which H is reduced on retry of Newton solve.
c     RATEMX = maximum convergence rate for which Newton iteration
c              is considered converging.
c
      SAVE RHCUT, RATEMX
      DATA RHCUT/0.1d0/, RATEMX/0.8d0/
c
c
c-----------------------------------------------------------------------
c     BLOCK 1.
c     Initializations.
c     JSKIP is a flag set to 1 when NIC = 2 and NH = 1, to signal that
c     the initial call to the JAC routine is to be skipped then.
c     Save Y and YPRIME in PHI.  Initialize IDID, NH, and CJ.
c-----------------------------------------------------------------------
c
      MXNH = IWM(LMXNH)
      IDID = 1
      NH = 1
      JSKIP = 0
      IF (NIC .EQ. 2) JSKIP = 1
      CALL dcopy_u(NEQ, Y, 1, PHI(1,1), 1)
      CALL dcopy_u(NEQ, YPRIME, 1, PHI(1,2), 1)
c
      IF (ICOPT .EQ. 2) THEN
      CJ = 0.0d0
      ELSE
      CJ = 1.0d0/H
      ENDIF
c
c-----------------------------------------------------------------------
c     BLOCK 2
c     Call the nonlinear system solver to obtain
c     consistent initial values for Y and YPRIME.
c-----------------------------------------------------------------------
c
  200 CONTINUE
      CALL NLSIC(X,Y,YPRIME,NEQ,ICOPT,ID,RES,JAC,PSOL,H,WT,JSKIP, RPAR,
     &   IPAR,SAVR,DELTA,E,YIC,YPIC,PWK,WM,IWM,CJ,UROUND, EPLI,SQRTN,
     &   RSQRTN,EPCONI,RATEMX,STPTOL,JFLG,ICNFLG,ICNSTR, IERNLS)
c
      IF (IERNLS .EQ. 0) RETURN
c
c-----------------------------------------------------------------------
c     BLOCK 3
c     The nonlinear solver was unsuccessful.  Increment NCFN.
c     Return with IDID = -12 if either
c       IERNLS = -1: error is considered unrecoverable,
c       ICOPT = 2: we are doing initialization problem type 2, or
c       NH = MXNH: the maximum number of H values has been tried.
c     Otherwise (problem 1 with IERNLS .GE. 1), reduce H and try again.
c     If IERNLS > 1, restore Y and YPRIME to their original values.
c-----------------------------------------------------------------------
c
      IWM(LCFN) = IWM(LCFN) + 1
      JSKIP = 0
c
      IF (IERNLS .EQ. -1) GO TO 350
      IF (ICOPT .EQ. 2) GO TO 350
      IF (NH .EQ. MXNH) GO TO 350
c
      NH = NH + 1
      H = H*RHCUT
      CJ = 1.0d0/H
c
      IF (IERNLS .EQ. 1) GO TO 200
c
      CALL dcopy_u(NEQ, PHI(1,1), 1, Y, 1)
      CALL dcopy_u(NEQ, PHI(1,2), 1, YPRIME, 1)
      GO TO 200
c
  350 IDID = -12
      RETURN
c
c------END OF SUBROUTINE SDASIC-----------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SYYPNW (NEQ, Y, YPRIME, CJ, RL, P, ICOPT, ID, YNEW, 
     &   YPNEW)
c
c***BEGIN PROLOGUE  SYYPNW
c***REFER TO  SLINSK
c***DATE WRITTEN   940830   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SYYPNW calculates the new (Y,YPRIME) pair needed in the
c     linesearch algorithm based on the current lambda value.  It is
c     called by SLINSK and SLINSD.  Based on the ICOPT and ID values,
c     the corresponding entry in Y or YPRIME is updated.
c
c     In addition to the parameters described in the calling programs,
c     the parameters represent
c
c     P      -- Array of length NEQ that contains the current
c               approximate Newton step.
c     RL     -- Scalar containing the current lambda value.
c     YNEW   -- Array of length NEQ containing the updated Y vector.
c     YPNEW  -- Array of length NEQ containing the updated YPRIME
c               vector.
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED (NONE)
c
c***END PROLOGUE  SYYPNW
c
c
      IMPLICIT doubleprecision (A-H,O-Z)
      INTEGER ICOPT,I,NEQ,ID

      DIMENSION Y(*), YPRIME(*), YNEW(*), YPNEW(*), ID(*), P(*)
c
      IF (ICOPT .EQ. 1) THEN
      DO 10 I=1,NEQ
      IF(ID(I) .LT. 0) THEN
      YNEW(I) = Y(I) - RL*P(I)
      YPNEW(I) = YPRIME(I)
      ELSE
      YNEW(I) = Y(I)
      YPNEW(I) = YPRIME(I) - RL*CJ*P(I)
      ENDIF
   10 CONTINUE
      ELSE
      DO 20 I = 1,NEQ
      YNEW(I) = Y(I) - RL*P(I)
      YPNEW(I) = YPRIME(I)
   20 CONTINUE
      ENDIF
      RETURN
c----------------------- END OF SUBROUTINE SYYPNW ----------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SDSTP(X,Y,YPRIME,NEQ,RES,JAC,PSOL,H,WT,VT, JSTART,IDID,
     &   RPAR,IPAR,PHI,SAVR,DELTA,E,WM,IWM, ALPHA,BETA,GAMMA,PSI,SIGMA,
     &   CJ,CJOLD,HOLD,S,HMIN,UROUND, EPLI,SQRTN,RSQRTN,EPCON,IPHASE,
     &   JCALC,JFLG,K,KOLD,NS,NONNEG, NTYPE,NLS,RDAT,IDAT)
c
c***BEGIN PROLOGUE  SDSTP
c***REFER TO  SDASPK
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***REVISION DATE  940909   (YYMMDD) (Reset PSI(1), PHI(*,2) at 690)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SDSTP solves a system of differential/algebraic equations of
c     the form G(X,Y,YPRIME) = 0, for one step (normally from X to X+H).
c
c     The methods used are modified divided difference, fixed leading
c     coefficient forms of backward differentiation formulas.
c     The code adjusts the stepsize and order to control the local error
c     per step.
c
c
c     The parameters represent
c     X  --        Independent variable.
c     Y  --        Solution vector at X.
c     YPRIME --    Derivative of solution vector
c                  after successful step.
c     NEQ --       Number of equations to be integrated.
c     RES --       External user-supplied subroutine
c                  to evaluate the residual.  See RES description
c                  in SDASPK prologue.
c     JAC --       External user-supplied routine to update
c                  Jacobian or preconditioner information in the
c                  nonlinear solver.  See JAC description in SDASPK
c                  prologue.
c     PSOL --      External user-supplied routine to solve
c                  a linear system using preconditioning.
c                  (This is optional).  See PSOL in SDASPK prologue.
c     H --         Appropriate step size for next step.
c                  Normally determined by the code.
c     WT --        Vector of weights for error criterion used in Newton test.
c     VT --        Masked vector of weights used in error test.
c     JSTART --    Integer variable set 0 for
c                  first step, 1 otherwise.
c     IDID --      Completion code returned from the nonlinear solver.
c                  See IDID description in SDASPK prologue.
c     RPAR,IPAR -- Real and integer parameter arrays that
c                  are used for communication between the
c                  calling program and external user routines.
c                  They are not altered by SNSK
c     PHI --       Array of divided differences used by
c                  SDSTP. The length is NEQ*(K+1), where
c                  K is the maximum order.
c     SAVR --      Work vector for SDSTP of length NEQ.
c     DELTA,E --   Work vectors for SDSTP of length NEQ.
c     WM,IWM --    Real and integer arrays storing
c                  information required by the linear solver.
c
c     The other parameters are information
c     which is needed internally by SDSTP to
c     continue from step to step.
c
c     RDAT,IDAT -- Are parameters to inquire about statistics while
c                  it is running (Added by JLM 3/7/92; updated 8/25/95)
c-----------------------------------------------------------------------
c***ROUTINES CALLED
c   NLS, SDWNRM, SDATRP
c
c***END PROLOGUE  SDSTP
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER NEQ,LMXORD,LNST,LETF,LCFN,NCF,NEF,JSTART,K,KOLD,IPHASE, NS
     &   ,KP1,KP2,KM1,NSP1,I,J,IDID,IERNLS,KNEW,IWM,KDIFF,J1,NONNEG, 
     &   IDAT,NTYPE,JCALC,JFLG,IPAR
      DIMENSION Y(*),YPRIME(*),WT(*),VT(*)
      DIMENSION PHI(NEQ,*),SAVR(*),DELTA(*),E(*)
      DIMENSION WM(*),IWM(*)
      DIMENSION PSI(*),ALPHA(*),BETA(*),GAMMA(*),SIGMA(*)
      DIMENSION RPAR(*),IPAR(*), RDAT(*), IDAT(*)
      EXTERNAL RES, JAC, PSOL, NLS
c
      PARAMETER (LMXORD=3)
      PARAMETER (LNST=11, LETF=14, LCFN=15)
c
c-----------------------------------------------------------------------
c  Declarations necessary for the inquiring while running.
      character*80 msgjm
      integer nrcv, ierrjm, ijmgetmr, imxer2, imxer3
      doubleprecision big2, big3, size2
c
c-----------------------------------------------------------------------
c     BLOCK 1.
c     Initialize.  On the first call, set
c     the order to 1 and initialize
c     other variables.
c-----------------------------------------------------------------------
c
c     Initializations for all calls
c
      XOLD=X
      NCF=0
      NEF=0
      IF(JSTART .NE. 0) GO TO 120
c
c     If this is the first step, perform
c     other initializations
c
      K=1
      KOLD=0
      HOLD=0.0d0
      PSI(1)=H
      CJ = 1.d0/H
      IPHASE = 0
      NS=0
  120 CONTINUE
c
c
c
c
c
c-----------------------------------------------------------------------
c     BLOCK 2
c     Compute coefficients of formulas for
c     this step.
c-----------------------------------------------------------------------
  200 CONTINUE
      KP1=K+1
      KP2=K+2
      KM1=K-1
      IF(H.NE.HOLD.OR.K .NE. KOLD) NS = 0
      NS=MIN(NS+1,KOLD+2)
      NSP1=NS+1
      IF(KP1 .LT. NS)GO TO 230
c
      BETA(1)=1.0d0
      ALPHA(1)=1.0d0
      TEMP1=H
      GAMMA(1)=0.0d0
      SIGMA(1)=1.0d0
      DO 210 I=2,KP1
      TEMP2=PSI(I-1)
      PSI(I-1)=TEMP1
      BETA(I)=BETA(I-1)*PSI(I-1)/TEMP2
      TEMP1=TEMP2+H
      ALPHA(I)=H/TEMP1
      SIGMA(I)=(I-1)*SIGMA(I-1)*ALPHA(I)
      GAMMA(I)=GAMMA(I-1)+ALPHA(I-1)/H
  210 CONTINUE
      PSI(KP1)=TEMP1
  230 CONTINUE
c
c     Compute ALPHAS, ALPHA0
c
      ALPHAS = 0.0d0
      ALPHA0 = 0.0d0
      DO 240 I = 1,K
      ALPHAS = ALPHAS - 1.0d0/I
      ALPHA0 = ALPHA0 - ALPHA(I)
  240 CONTINUE
c
c     Compute leading coefficient CJ
c
      CJLAST = CJ
      CJ = -ALPHAS/H
c
c     Compute variable stepsize error coefficient CK
c
      CK = ABS(ALPHA(KP1) + ALPHAS - ALPHA0)
      CK = MAX(CK,ALPHA(KP1))
c
c     Change PHI to PHI STAR
c
      IF(KP1 .LT. NSP1) GO TO 280
      DO 270 J=NSP1,KP1
      DO 260 I=1,NEQ
  260 PHI(I,J)=BETA(J)*PHI(I,J)
  270 CONTINUE
  280 CONTINUE
c
c     Update time
c
      X=X+H
c
c     Initialize IDID to 1
c
      IDID = 1
c
c
c
c
c
c-----------------------------------------------------------------------
c     BLOCK 3
c     Call the nonlinear system solver to obtain the solution and
c     derivative.
c-----------------------------------------------------------------------
c
      CALL NLS(X,Y,YPRIME,NEQ, RES,JAC,PSOL,H,WT,JSTART,IDID,RPAR,IPAR,
     &   PHI,GAMMA, SAVR,DELTA,E,WM,IWM,CJ,CJOLD,CJLAST,S, UROUND,EPLI,
     &   SQRTN,RSQRTN,EPCON,JCALC,JFLG,KP1, NONNEG,NTYPE,IERNLS)
c
      IF(IERNLS .NE. 0)GO TO 600
c
c
c
c
c
c-----------------------------------------------------------------------
c     BLOCK 4
c     Estimate the errors at orders K,K-1,K-2
c     as if constant stepsize was used. Estimate
c     the local error at order K and test
c     whether the current step is successful.
c-----------------------------------------------------------------------
c
c     Estimate errors at orders K,K-1,K-2
c
      ENORM = SDWNRM(NEQ,E,VT,RPAR,IPAR)
      ERK = SIGMA(K+1)*ENORM
      TERK = (K+1)*ERK
      EST = ERK
      KNEW=K
      IF(K .EQ. 1)GO TO 430
      DO 405 I = 1,NEQ
  405 DELTA(I) = PHI(I,KP1) + E(I)
      ERKM1=SIGMA(K)*SDWNRM(NEQ,DELTA,VT,RPAR,IPAR)
      TERKM1 = K*ERKM1
      IF(K .GT. 2)GO TO 410
      IF(TERKM1 .LE. 0.5d0*TERK)GO TO 420
      GO TO 430
  410 CONTINUE
      DO 415 I = 1,NEQ
  415 DELTA(I) = PHI(I,K) + DELTA(I)
      ERKM2=SIGMA(K-1)*SDWNRM(NEQ,DELTA,VT,RPAR,IPAR)
      TERKM2 = (K-1)*ERKM2
      IF(MAX(TERKM1,TERKM2).GT.TERK)GO TO 430
c
c     Lower the order
c
  420 CONTINUE
      KNEW=K-1
      EST = ERKM1
c
c
c     Calculate the local error for the current step
c     to see if the step was successful
c
  430 CONTINUE
c----------------------------------------------------------------------
c     Special error message section JLM 3/7/92 ------------------------
ccc      ierrjm = ijmgetmr(msgjm,80,1,nrcv)
ccc      if (ierrjm .eq. 0) then
ccc         if (msgjm(1:nrcv).eq.'status' .or. msgjm(1:nrcv).eq.'s' ) then
c          big2 = 0.0e0
c          imxer2 = 1
c          do 452 i = 1,n
c             size2 = abs( acor(i)*ewt(i) )
c             if (big2 .ge. size2) go to 452
c             big2 = size2
c             imxer2 = i
c452       continue
c          big3 = 0.0e0
c          imxer3 = 1
c          do 453 i = 1,n
c             size2 = abs( savx(i)*ewt(i) )
c             if (big2 .ge. size2) go to 453
c             big3 = size2
c             imxer3 = i
c453       continue
ccc            write(*,*) 'nfe = ', idat(12), '   npe = ', idat(13)
ccc            write(*,*) 'time = ', x, '   dt = ', h
ccc         elseif(msgjm(1:nrcv).eq.'kaboom' .or. msgjm(1:nrcv).eq.'k')then
ccc            call xerrab("")
ccc         endif
ccc      endif
c-----------------------------------------------------------------------
      err = CK * ENORM
      IF(err .GT. 1.0d0)GO TO 600
c
c
c
c
c
c-----------------------------------------------------------------------
c     BLOCK 5
c     The step is successful. Determine
c     the best order and stepsize for
c     the next step. Update the differences
c     for the next step.
c-----------------------------------------------------------------------
      IDID=1
      IWM(LNST)=IWM(LNST)+1
      KDIFF=K-KOLD
      KOLD=K
      HOLD=H
c
c
c     Estimate the error at order K+1 unless
c        already decided to lower order, or
c        already using maximum order, or
c        stepsize not constant, or
c        order raised in previous step
c
      IF(KNEW.EQ.KM1.OR.K.EQ.IWM(LMXORD))IPHASE=1
      IF(IPHASE .EQ. 0)GO TO 545
      IF(KNEW.EQ.KM1)GO TO 540
      IF(K.EQ.IWM(LMXORD)) GO TO 550
      IF(KP1.GE.NS.OR.KDIFF.EQ.1)GO TO 550
      DO 510 I=1,NEQ
  510 DELTA(I)=E(I)-PHI(I,KP2)
      ERKP1 = (1.0d0/(K+2))*SDWNRM(NEQ,DELTA,VT,RPAR,IPAR)
      TERKP1 = (K+2)*ERKP1
      IF(K.GT.1)GO TO 520
      IF(TERKP1.GE.0.5d0*TERK)GO TO 550
      GO TO 530
  520 IF(TERKM1.LE.MIN(TERK,TERKP1))GO TO 540
      IF(TERKP1.GE.TERK.OR.K.EQ.IWM(LMXORD))GO TO 550
c
c     Raise order
c
  530 K=KP1
      EST = ERKP1
      GO TO 550
c
c     Lower order
c
  540 K=KM1
      EST = ERKM1
      GO TO 550
c
c     If IPHASE = 0, increase order by one and multiply stepsize by
c     factor two
c
  545 K = KP1
      HNEW = H*2.0d0
      H = HNEW
      GO TO 575
c
c
c     Determine the appropriate stepsize for
c     the next step.
c
  550 HNEW=H
      TEMP2=K+1
      R=(2.0d0*EST+0.0001d0)**(-1.0d0/TEMP2)
      IF(R .LT. 2.0d0) GO TO 555
      HNEW = 2.0d0*H
      GO TO 560
  555 IF(R .GT. 1.0d0) GO TO 560
      R = MAX(0.5d0,MIN(0.9d0,R))
      HNEW = H*R
  560 H=HNEW
c
c
c     Update differences for next step
c
  575 CONTINUE
      IF(KOLD.EQ.IWM(LMXORD))GO TO 585
      DO 580 I=1,NEQ
  580 PHI(I,KP2)=E(I)
  585 CONTINUE
      DO 590 I=1,NEQ
  590 PHI(I,KP1)=PHI(I,KP1)+E(I)
      DO 595 J1=2,KP1
      J=KP1-J1+1
      DO 595 I=1,NEQ
  595 PHI(I,J)=PHI(I,J)+PHI(I,J+1)
      JSTART = 1
      RETURN
c
c
c
c
c
c-----------------------------------------------------------------------
c     BLOCK 6
c     The step is unsuccessful. Restore X,PSI,PHI
c     Determine appropriate stepsize for
c     continuing the integration, or exit with
c     an error flag if there have been many
c     failures.
c-----------------------------------------------------------------------
  600 IPHASE = 1
c
c     Restore X,PHI,PSI
c
      X=XOLD
      IF(KP1.LT.NSP1)GO TO 630
      DO 620 J=NSP1,KP1
      TEMP1=1.0d0/BETA(J)
      DO 610 I=1,NEQ
  610 PHI(I,J)=TEMP1*PHI(I,J)
  620 CONTINUE
  630 CONTINUE
      DO 640 I=2,KP1
  640 PSI(I-1)=PSI(I)-H
c
c
c     Test whether failure is due to nonlinear solver
c     or error test
c
      IF(IERNLS .EQ. 0)GO TO 660
      IWM(LCFN)=IWM(LCFN)+1
c
c
c     The nonlinear solver failed to converge.
c     Determine the cause of the failure and take appropriate action.
c     If IERNLS .LT. 0, then return.  Otherwise, reduce the stepsize
c     and try again, unless too many failures have occurred.
c
      IF (IERNLS .LT. 0) GO TO 675
      NCF = NCF + 1
      R = 0.25d0
      H = H*R
      IF (NCF .LT. 10 .AND. ABS(H) .GE. HMIN) GO TO 690
      IF (IDID .EQ. 1) IDID = -7
      IF (NEF .GE. 3) IDID = -9
      GO TO 675
c
c
c     The nonlinear solver converged, and the cause
c     of the failure was the error estimate
c     exceeding the tolerance.
c
  660 NEF=NEF+1
      IWM(LETF)=IWM(LETF)+1
      IF (NEF .GT. 1) GO TO 665
c
c     On first error test failure, keep current order or lower
c     order by one.  Compute new stepsize based on differences
c     of the solution.
c
      K = KNEW
      TEMP2 = K + 1
      R = 0.90d0*(2.0d0*EST+0.0001d0)**(-1.0d0/TEMP2)
      R = MAX(0.25d0,MIN(0.9d0,R))
      H = H*R
      IF (ABS(H) .GE. HMIN) GO TO 690
      IDID = -6
      GO TO 675
c
c     On second error test failure, use the current order or
c     decrease order by one.  Reduce the stepsize by a factor of
c     one quarter.
c
  665 IF (NEF .GT. 2) GO TO 670
      K = KNEW
      R = 0.25d0
      H = R*H
      IF (ABS(H) .GE. HMIN) GO TO 690
      IDID = -6
      GO TO 675
c
c     On third and subsequent error test failures, set the order to
c     one, and reduce the stepsize by a factor of one quarter.
c
  670 K = 1
      R = 0.25d0
      H = R*H
      IF (ABS(H) .GE. HMIN) GO TO 690
      IDID = -6
      GO TO 675
c
c
c
c
c     For all crashes, restore Y to its last value,
c     interpolate to find YPRIME at last X, and return.
c
c     Before returning, verify that the user has not set
c     IDID to a nonnegative value.  If the user has set IDID
c     to a nonnegative value, then reset IDID to be -7, indicating
c     a failure in the nonlinear system solver.
c
  675 CONTINUE
      CALL SDATRP(X,X,Y,YPRIME,NEQ,K,PHI,PSI)
      JSTART = 1
      IF (IDID .GE. 0) IDID = -7
      RETURN
c
c
c     Go back and try this step again.
c     If this is the first step, reset PSI(1) and rescale PHI(*,2).
c
  690 IF (KOLD .EQ. 0) THEN
      PSI(1) = H
      DO 695 I = 1,NEQ
  695 PHI(I,2) = R*PHI(I,2)
      ENDIF
      GO TO 200
c
c------END OF SUBROUTINE SDSTP------------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SCNSTR (NEQ, Y, YNEW, ICNSTR, TAU, RLX, IRET, IVAR)
c
c***BEGIN PROLOGUE  SCNSTR
c***DATE WRITTEN   950808   (YYMMDD)
c***REVISION DATE  950814   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c This subroutine checks for constraint violations in the proposed
c new approximate solution YNEW.
c If a constraint violation occurs, then a new step length, TAU,
c is calculated, and this value is to be given to the linesearch routine
c to calculate a new approximate solution YNEW.
c
c On entry:
c
c   NEQ    -- size of the nonlinear system, and the length of arrays
c             Y, YNEW and ICNSTR.
c
c   Y      -- real array containing the current approximate y.
c
c   YNEW   -- real array containing the new approximate y.
c
c   ICNSTR -- INTEGER array of length NEQ containing flags indicating
c             which entries in YNEW are to be constrained.
c             if ICNSTR(I) =  2, then YNEW(I) must be .GT. 0,
c             if ICNSTR(I) =  1, then YNEW(I) must be .GE. 0,
c             if ICNSTR(I) = -1, then YNEW(I) must be .LE. 0, while
c             if ICNSTR(I) = -2, then YNEW(I) must be .LT. 0, while
c             if ICNSTR(I) =  0, then YNEW(I) is not constrained.
c
c   RLX    -- real scalar restricting update, if ICNSTR(I) = 2 or -2,
c             to ABS( (YNEW-Y)/Y ) < FAC2*RLX in component I.
c
c   TAU    -- the current size of the step length for the linesearch.
c
c On return
c
c   TAU    -- the adjusted size of the step length if a constraint
c             violation occurred (otherwise, it is unchanged).  it is
c             the step length to give to the linesearch routine.
c
c   IRET   -- output flag.
c             IRET=0 means that YNEW satisfied all constraints.
c             IRET=1 means that YNEW failed to satisfy all the
c                    constraints, and a new linesearch step
c                    must be computed.
c
c   IVAR   -- index of variable causing constraint to be violated.
c
c-----------------------------------------------------------------------
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER NEQ,IRET,IVAR,I,ICNSTR
      DIMENSION Y(NEQ), YNEW(NEQ), ICNSTR(NEQ)
      SAVE FAC, FAC2, ZERO
      DATA FAC /0.6d0/, FAC2 /0.9d0/, ZERO/0.0d0/
c-----------------------------------------------------------------------
c Check constraints for proposed new step YNEW.  If a constraint has
c been violated, then calculate a new step length, TAU, to be
c used in the linesearch routine.
c-----------------------------------------------------------------------
      IRET = 0
      RDYMX = ZERO
      IVAR = 0
      DO 100 I = 1,NEQ
c
      IF (ICNSTR(I) .EQ. 2) THEN
      RDY = ABS( (YNEW(I)-Y(I))/Y(I) )
      IF (RDY .GT. RDYMX) THEN
      RDYMX = RDY
      IVAR = I
      ENDIF
      IF (YNEW(I) .LE. ZERO) THEN
      TAU = FAC*TAU
      IVAR = I
      IRET = 1
      RETURN
      ENDIF
c
      ELSEIF (ICNSTR(I) .EQ. 1) THEN
      IF (YNEW(I) .LT. ZERO) THEN
      TAU = FAC*TAU
      IVAR = I
      IRET = 1
      RETURN
      ENDIF
c
      ELSEIF (ICNSTR(I) .EQ. -1) THEN
      IF (YNEW(I) .GT. ZERO) THEN
      TAU = FAC*TAU
      IVAR = I
      IRET = 1
      RETURN
      ENDIF
c
      ELSEIF (ICNSTR(I) .EQ. -2) THEN
      RDY = ABS( (YNEW(I)-Y(I))/Y(I) )
      IF (RDY .GT. RDYMX) THEN
      RDYMX = RDY
      IVAR = I
      ENDIF
      IF (YNEW(I) .GE. ZERO) THEN
      TAU = FAC*TAU
      IVAR = I
      IRET = 1
      RETURN
      ENDIF
c
      ENDIF
  100 CONTINUE

      IF(RDYMX .GE. RLX) THEN
      TAU = FAC2*TAU*RLX/RDYMX
      IRET = 1
      ENDIF
c
      RETURN
c----------------------- END OF SUBROUTINE SCNSTR ----------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SCNST0 (NEQ, Y, ICNSTR, IRET)
c
c***BEGIN PROLOGUE  SCNST0
c***DATE WRITTEN   950808   (YYMMDD)
c***REVISION DATE  950808   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c This subroutine checks for constraint violations in the initial
c approximate solution u.
c
c On entry
c
c   NEQ    -- size of the nonlinear system, and the length of arrays
c             Y and ICNSTR.
c
c   Y      -- real array containing the initial approximate root.
c
c   ICNSTR -- INTEGER array of length NEQ containing flags indicating
c             which entries in Y are to be constrained.
c             if ICNSTR(I) =  2, then Y(I) must be .GT. 0,
c             if ICNSTR(I) =  1, then Y(I) must be .GE. 0,
c             if ICNSTR(I) = -1, then Y(I) must be .LE. 0, while
c             if ICNSTR(I) = -2, then Y(I) must be .LT. 0, while
c             if ICNSTR(I) =  0, then Y(I) is not constrained.
c
c On return
c
c   IRET   -- output flag.
c             IRET=0    means that u satisfied all constraints.
c             IRET.NE.0 means that Y(IRET) failed to satisfy its
c                       constraint.
c
c-----------------------------------------------------------------------
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER ICNSTR,I,NEQ,IRET
      DIMENSION Y(NEQ), ICNSTR(NEQ)
      SAVE ZERO
      DATA ZERO/0.d0/
c-----------------------------------------------------------------------
c Check constraints for initial Y.  If a constraint has been violated,
c set IRET = I to signal an error return to calling routine.
c-----------------------------------------------------------------------
      IRET = 0
      DO 100 I = 1,NEQ
      IF (ICNSTR(I) .EQ. 2) THEN
      IF (Y(I) .LE. ZERO) THEN
      IRET = I
      RETURN
      ENDIF
      ELSEIF (ICNSTR(I) .EQ. 1) THEN
      IF (Y(I) .LT. ZERO) THEN
      IRET = I
      RETURN
      ENDIF
      ELSEIF (ICNSTR(I) .EQ. -1) THEN
      IF (Y(I) .GT. ZERO) THEN
      IRET = I
      RETURN
      ENDIF
      ELSEIF (ICNSTR(I) .EQ. -2) THEN
      IF (Y(I) .GE. ZERO) THEN
      IRET = I
      RETURN
      ENDIF
      ENDIF
  100 CONTINUE
      RETURN
c----------------------- END OF SUBROUTINE SCNST0 ----------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SDAWTS(NEQ,IWT,RTOL,ATOL,Y,WT,RPAR,IPAR)
c
c***BEGIN PROLOGUE  SDAWTS
c***REFER TO  SDASPK
c***ROUTINES CALLED  (NONE)
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***END PROLOGUE  SDAWTS
c-----------------------------------------------------------------------
c     This subroutine sets the error weight vector,
c     WT, according to WT(I)=RTOL(I)*ABS(Y(I))+ATOL(I),
c     I = 1 to NEQ.
c     RTOL and ATOL are scalars if IWT = 0,
c     and vectors if IWT = 1.
c-----------------------------------------------------------------------
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER I,NEQ,IWT,IPAR
      DIMENSION RTOL(*),ATOL(*),Y(*),WT(*)
      DIMENSION RPAR(*),IPAR(*)
      RTOLI=RTOL(1)
      ATOLI=ATOL(1)
      DO 20 I=1,NEQ
      IF (IWT .EQ.0) GO TO 10
      RTOLI=RTOL(I)
      ATOLI=ATOL(I)
   10 WT(I)=RTOLI*ABS(Y(I))+ATOLI
   20 CONTINUE
      RETURN
c
c------END OF SUBROUTINE SDAWTS-----------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SINVWT(NEQ,WT,IER)
c
c***BEGIN PROLOGUE  SINVWT
c***REFER TO  SDASPK
c***ROUTINES CALLED  (NONE)
c***DATE WRITTEN   950125   (YYMMDD)
c***END PROLOGUE  SINVWT
c-----------------------------------------------------------------------
c     This subroutine checks the error weight vector WT, of length NEQ,
c     for components that are .le. 0, and if none are found, it
c     inverts the WT(I) in place.  This replaces division operations
c     with multiplications in all norm evaluations.
c     IER is returned as 0 if all WT(I) were found positive,
c     and the first I with WT(I) .le. 0.0 otherwise.
c-----------------------------------------------------------------------
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER I,NEQ,IER
      DIMENSION WT(*)
c
      DO 10 I = 1,NEQ
      IF (WT(I) .LE. 0.0d0) GO TO 30
   10 CONTINUE
      DO 20 I = 1,NEQ
   20 WT(I) = 1.0d0/WT(I)
      IER = 0
      RETURN
c
   30 IER = I
      RETURN
c
c------END OF SUBROUTINE SINVWT-----------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SDATRP(X,XOUT,YOUT,YPOUT,NEQ,KOLD,PHI,PSI)
c
c***BEGIN PROLOGUE  SDATRP
c***REFER TO  SDASPK
c***ROUTINES CALLED  (NONE)
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***END PROLOGUE  SDATRP
c
c-----------------------------------------------------------------------
c     The methods in subroutine SDSTP use polynomials
c     to approximate the solution.  SDATRP approximates the
c     solution and its derivative at time XOUT by evaluating
c     one of these polynomials, and its derivative, there.
c     Information defining this polynomial is passed from
c     SDSTP, so SDATRP cannot be used alone.
c
c     The parameters are
c
c     X     The current time in the integration.
c     XOUT  The time at which the solution is desired.
c     YOUT  The interpolated approximation to Y at XOUT.
c           (This is output.)
c     YPOUT The interpolated approximation to YPRIME at XOUT.
c           (This is output.)
c     NEQ   Number of equations.
c     KOLD  Order used on last successful step.
c     PHI   Array of scaled divided differences of Y.
c     PSI   Array of past stepsize history.
c-----------------------------------------------------------------------
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER NEQ,KOLDP1,KOLD,I,J
      DIMENSION YOUT(*),YPOUT(*)
      DIMENSION PHI(NEQ,*),PSI(*)
      KOLDP1=KOLD+1
      TEMP1=XOUT-X
      DO 10 I=1,NEQ
      YOUT(I)=PHI(I,1)
   10 YPOUT(I)=0.0d0
      C=1.0d0
      D=0.0d0
      GAMMA=TEMP1/PSI(1)
      DO 30 J=2,KOLDP1
      D=D*GAMMA+C/PSI(J-1)
      C=C*GAMMA
      GAMMA=(TEMP1+PSI(J-1))/PSI(J)
      DO 20 I=1,NEQ
      YOUT(I)=YOUT(I)+C*PHI(I,J)
   20 YPOUT(I)=YPOUT(I)+D*PHI(I,J)
   30 CONTINUE
      RETURN
c
c------END OF SUBROUTINE SDATRP-----------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      doubleprecision FUNCTION SDWNRM(NEQ,V,RWT,RPAR,IPAR)
c
c***BEGIN PROLOGUE  SDWNRM
c***ROUTINES CALLED  (NONE)
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***END PROLOGUE  SDWNRM
c-----------------------------------------------------------------------
c     This function routine computes the weighted
c     root-mean-square norm of the vector of length
c     NEQ contained in the array V, with reciprocal weights
c     contained in the array RWT of length NEQ.
c        SDWNRM=SQRT((1/NEQ)*SUM(V(I)*RWT(I))**2)
c-----------------------------------------------------------------------
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER I,NEQ,IPAR
      DIMENSION V(*),RWT(*)
      DIMENSION RPAR(*),IPAR(*)
      SDWNRM = 0.0d0
      VMAX = 0.0d0
      DO 10 I = 1,NEQ
      IF(ABS(V(I)*RWT(I)) .GT. VMAX) VMAX = ABS(V(I)*RWT(I))
   10 CONTINUE
      IF(VMAX .LE. 0.0d0) GO TO 30
      SUM = 0.0d0
      DO 20 I = 1,NEQ
   20 SUM = SUM + ((V(I)*RWT(I))/VMAX)**2
      SDWNRM = VMAX*SQRT(SUM/NEQ)
   30 CONTINUE
      RETURN
c
c------END OF FUNCTION SDWNRM-------------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SDASID(X,Y,YPRIME,NEQ,ICOPT,ID,RES,JACD,PDUM,H,WT, 
     &   JSDUM,RPAR,IPAR,DUMSVR,DELTA,R,YIC,YPIC,DUMPWK,WM,IWM,CJ,UROUND
     &   , DUME,DUMS,DUMR,EPCON,RATEMX,STPTOL,JFDUM, ICNFLG,ICNSTR,
     &   IERNLS)
c
c***BEGIN PROLOGUE  SDASID
c***REFER TO  SDASPK
c***DATE WRITTEN   940701   (YYMMDD)
c***REVISION DATE  950808   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c
c     SDASID solves a nonlinear system of algebraic equations of the
c     form G(X,Y,YPRIME) = 0 for the unknown parts of Y and YPRIME in
c     the initial conditions.
c
c     The method used is a modified Newton scheme.
c
c     The parameters represent
c
c     X         -- Independent variable.
c     Y         -- Solution vector.
c     YPRIME    -- Derivative of solution vector.
c     NEQ       -- Number of unknowns.
c     ICOPT     -- Initial condition option chosen (1 or 2).
c     ID        -- Array of dimension NEQ, which must be initialized
c                  if ICOPT = 1.  See SDASIC.
c     RES       -- External user-supplied subroutine to evaluate the
c                  residual.  See RES description in SDASPK prologue.
c     JACD      -- External user-supplied routine to evaluate the
c                  Jacobian.  See JAC description for the case
c                  INFO(12) = 0 in the SDASPK prologue.
c     PDUM      -- Dummy argument.
c     H         -- Scaling factor for this initial condition calc.
c     WT        -- Vector of weights for error criterion.
c     JSDUM     -- Dummy argument.
c     RPAR,IPAR -- Real and integer arrays used for communication
c                  between the calling program and external user
c                  routines.  They are not altered within DASPK.
c     DUMSVR    -- Dummy argument.
c     DELTA     -- Work vector for NLS of length NEQ.
c     R         -- Work vector for NLS of length NEQ.
c     YIC,YPIC  -- Work vectors for NLS, each of length NEQ.
c     DUMPWK    -- Dummy argument.
c     WM,IWM    -- Real and integer arrays storing matrix information
c                  such as the matrix of partial derivatives,
c                  permutation vector, and various other information.
c     CJ        -- Matrix parameter = 1/H (ICOPT = 1) or 0 (ICOPT = 2).
c     UROUND    -- Unit roundoff.
c     DUME      -- Dummy argument.
c     DUMS      -- Dummy argument.
c     DUMR      -- Dummy argument.
c     EPCON     -- Tolerance to test for convergence of the Newton
c                  iteration.
c     RATEMX    -- Maximum convergence rate for which Newton iteration
c                  is considered converging.
c     JFDUM     -- Dummy argument.
c     STPTOL    -- Tolerance used in calculating the minimum lambda
c                  value allowed.
c     ICNFLG    -- Integer scalar.  If nonzero, then constraint
c                  violations in the proposed new approximate solution
c                  will be checked for, and the maximum step length
c                  will be adjusted accordingly.
c     ICNSTR    -- Integer array of length NEQ containing flags for
c                  checking constraints.
c     IERNLS    -- Error flag for nonlinear solver.
c                   0   ==> nonlinear solver converged.
c                   1,2 ==> recoverable error inside nonlinear solver.
c                           1 => retry with current Y, YPRIME
c                           2 => retry with original Y, YPRIME
c                  -1   ==> unrecoverable error in nonlinear solver.
c
c     All variables with "DUM" in their names are dummy variables
c     which are not used in this routine.
c
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED
c   RES, SMATD, SNSID
c
c***END PROLOGUE  SDASID
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER IPAR,LNRE,LNJE,LMXNIT,LMXNJ,MXNIT,IWM,MXNJ,IERNLS,NJ, IRES
     &   ,IERJ,IERNEW,JFDUM,ICNFLG,JSDUM,ICNSTR,NEQ,ID,ICOPT
      DIMENSION Y(*),YPRIME(*),ID(*),WT(*),ICNSTR(*)
      DIMENSION DELTA(*),R(*),YIC(*),YPIC(*)
      DIMENSION WM(*),IWM(*), RPAR(*),IPAR(*)
      EXTERNAL RES, JACD
c
      PARAMETER (LNRE=12, LNJE=13, LMXNIT=32, LMXNJ=33)
c
c
c     Perform initializations.
c
      MXNIT = IWM(LMXNIT)
      MXNJ = IWM(LMXNJ)
      IERNLS = 0
      NJ = 0
c
c     Call RES to initialize DELTA.
c
      IRES = 0
      IWM(LNRE) = IWM(LNRE) + 1
      CALL RES(X,Y,YPRIME,CJ,DELTA,IRES,RPAR,IPAR)
      IF (IRES .LT. 0) GO TO 370
c
c     Looping point for updating the Jacobian.
c
  300 CONTINUE
c
c     Initialize all error flags to zero.
c
      IERJ = 0
      IRES = 0
      IERNEW = 0
c
c     Reevaluate the iteration matrix, J = dG/dY + CJ*dG/dYPRIME,
c     where G(X,Y,YPRIME) = 0.
c
      NJ = NJ + 1
      IWM(LNJE)=IWM(LNJE)+1
      CALL SMATD(NEQ,X,Y,YPRIME,DELTA,CJ,H,IERJ,WT,R, WM,IWM,RES,IRES,
     &   UROUND,JACD,RPAR,IPAR)
      IF (IRES .LT. 0 .OR. IERJ .NE. 0) GO TO 370
c
c     Call the nonlinear Newton solver for up to MXNIT iterations.
c
      CALL SNSID(X,Y,YPRIME,NEQ,ICOPT,ID,RES,WT,RPAR,IPAR,DELTA,R, YIC,
     &   YPIC,WM,IWM,CJ,EPCON,RATEMX,MXNIT,STPTOL, ICNFLG,ICNSTR,IERNEW)
c
      IF (IERNEW .EQ. 1 .AND. NJ .LT. MXNJ) THEN
c
c        MXNIT iterations were done, the convergence rate is < 1,
c        and the number of Jacobian evaluations is less than MXNJ.
c        Call RES, reevaluate the Jacobian, and try again.
c
      IWM(LNRE)=IWM(LNRE)+1
      CALL RES(X,Y,YPRIME,CJ,DELTA,IRES,RPAR,IPAR)
      IF (IRES .LT. 0) GO TO 370
      GO TO 300
      ENDIF
c
      IF (IERNEW .NE. 0) GO TO 380

      RETURN
c
c
c     Unsuccessful exits from nonlinear solver.
c     Compute IERNLS accordingly.
c
  370 IERNLS = 2
      IF (IRES .LE. -2) IERNLS = -1
      RETURN
c
  380 IERNLS = MIN(IERNEW,2)
      RETURN
c
  390 IERNLS = 2
      RETURN
c
c------END OF SUBROUTINE SDASID-----------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SNSID(X,Y,YPRIME,NEQ,ICOPT,ID,RES,WT,RPAR,IPAR, DELTA,R
     &   ,YIC,YPIC,WM,IWM,CJ,EPCON,RATEMX,MAXIT,STPTOL, ICNFLG,ICNSTR,
     &   IERNEW)
c
c***BEGIN PROLOGUE  SNSID
c***REFER TO  SDASPK
c***DATE WRITTEN   940701   (YYMMDD)
c***REVISION DATE  950713   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SNSID solves a nonlinear system of algebraic equations of the
c     form G(X,Y,YPRIME) = 0 for the unknown parts of Y and YPRIME
c     in the initial conditions.
c
c     The method used is a modified Newton scheme.
c
c     The parameters represent
c
c     X         -- Independent variable.
c     Y         -- Solution vector.
c     YPRIME    -- Derivative of solution vector.
c     NEQ       -- Number of unknowns.
c     ICOPT     -- Initial condition option chosen (1 or 2).
c     ID        -- Array of dimension NEQ, which must be initialized
c                  if ICOPT = 1.  See SDASIC.
c     RES       -- External user-supplied subroutine to evaluate the
c                  residual.  See RES description in SDASPK prologue.
c     WT        -- Vector of weights for error criterion.
c     RPAR,IPAR -- Real and integer arrays used for communication
c                  between the calling program and external user
c                  routines.  They are not altered within DASPK.
c     DELTA     -- Residual vector on entry, and work vector of
c                  length NEQ for SNSID.
c     WM,IWM    -- Real and integer arrays storing matrix information
c                  such as the matrix of partial derivatives,
c                  permutation vector, and various other information.
c     CJ        -- Matrix parameter = 1/H (ICOPT = 1) or 0 (ICOPT = 2).
c     R         -- Array of length NEQ used as workspace by the
c                  linesearch routine SLINSD.
c     YIC,YPIC  -- Work vectors for SLINSD, each of length NEQ.
c     EPCON     -- Tolerance to test for convergence of the Newton
c                  iteration.
c     RATEMX    -- Maximum convergence rate for which Newton iteration
c                  is considered converging.
c     MAXIT     -- Maximum allowed number of Newton iterations.
c     STPTOL    -- Tolerance used in calculating the minimum lambda
c                  value allowed.
c     ICNFLG    -- Integer scalar.  If nonzero, then constraint
c                  violations in the proposed new approximate solution
c                  will be checked for, and the maximum step length
c                  will be adjusted accordingly.
c     ICNSTR    -- Integer array of length NEQ containing flags for
c                  checking constraints.
c     IERNEW    -- Error flag for Newton iteration.
c                   0  ==> Newton iteration converged.
c                   1  ==> failed to converge, but RATE .le. RATEMX.
c                   2  ==> failed to converge, RATE .gt. RATEMX.
c                   3  ==> other recoverable error (IRES = -1, or
c                          linesearch failed).
c                  -1  ==> unrecoverable error (IRES = -2).
c
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED
c   SSLVD, SDWNRM, SLINSD, SCOPY
c
c***END PROLOGUE  SNSID
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER LNNI,LLSOFF,LSOFF,IWM,M,IRET,MAXIT,IERNEW,IRES, ICNFLG,
     &   IPAR,ICNSTR,NEQ,ID,ICOPT
      DIMENSION Y(*),YPRIME(*),WT(*),R(*)
      DIMENSION ID(*),DELTA(*), YIC(*), YPIC(*)
      DIMENSION WM(*),IWM(*), RPAR(*),IPAR(*)
      DIMENSION ICNSTR(*)
      EXTERNAL RES
c
      PARAMETER (LNNI=19, LLSOFF=35)
c
c
c     Initializations.  M is the Newton iteration counter.
c
      LSOFF = IWM(LLSOFF)
      M = 0
      RATE = 1.0d0
      RLX = 0.4d0
c
c     Compute a new step vector DELTA by back-substitution.
c
      CALL SSLVD (NEQ, DELTA, WM, IWM)
c
c     Get norm of DELTA.  Return now if norm(DELTA) .le. EPCON.
c
      DELNRM = SDWNRM(NEQ,DELTA,WT,RPAR,IPAR)
      FNRM = DELNRM
      IF (FNRM .LE. EPCON) RETURN
c
c     Newton iteration loop.
c
  300 CONTINUE
      IWM(LNNI) = IWM(LNNI) + 1
c
c     Call linesearch routine for global strategy and set RATE
c
      OLDFNM = FNRM
c
      CALL SLINSD (NEQ, Y, X, YPRIME, CJ, DELTA, DELNRM, WT, LSOFF, 
     &   STPTOL, IRET, RES, IRES, WM, IWM, FNRM, ICOPT, ID, R, YIC, YPIC
     &   , ICNFLG, ICNSTR, RLX, RPAR, IPAR)
c
      RATE = FNRM/OLDFNM
c
c     Check for error condition from linesearch.
      IF (IRET .NE. 0) GO TO 390
c
c     Test for convergence of the iteration, and return or loop.
c
      IF (FNRM .LE. EPCON) RETURN
c
c     The iteration has not yet converged.  Update M.
c     Test whether the maximum number of iterations have been tried.
c
      M = M + 1
      IF (M .GE. MAXIT) GO TO 380
c
c     Copy the residual to DELTA and its norm to DELNRM, and loop for
c     another iteration.
c
      CALL dcopy_u(NEQ, R, 1, DELTA, 1)
      DELNRM = FNRM
      GO TO 300
c
c     The maximum number of iterations was done.  Set IERNEW and return.
c
  380 IF (RATE .LE. RATEMX) THEN
      IERNEW = 1
      ELSE
      IERNEW = 2
      ENDIF
      RETURN
c
  390 IF (IRES .LE. -2) THEN
      IERNEW = -1
      ELSE
      IERNEW = 3
      ENDIF
      RETURN
c
c
c------END OF SUBROUTINE SNSID------------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SLINSD (NEQ, Y, T, YPRIME, CJ, P, PNRM, WT, LSOFF, 
     &   STPTOL, IRET, RES, IRES, WM, IWM, FNRM, ICOPT, ID, R, YNEW, 
     &   YPNEW, ICNFLG, ICNSTR, RLX, RPAR, IPAR)
c
c***BEGIN PROLOGUE  SLINSD
c***REFER TO  SNSID
c***DATE WRITTEN   941025   (YYMMDD)
c***REVISION DATE  941215   (YYMMDD)
c***REVISION DATE  960401   (Moved RL=ONE line to beginning.)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SLINSD uses a linesearch algorithm to calculate a new (Y,YPRIME)
c     pair (YNEW,YPNEW) such that
c
c     f(YNEW,YPNEW) .le. (1 - 2*ALPHA*RL)*f(Y,YPRIME) ,
c
c     where 0 < RL <= 1.  Here, f(y,y') is defined as
c
c      f(y,y') = (1/2)*norm( (J-inverse)*G(t,y,y') )**2 ,
c
c     where norm() is the weighted RMS vector norm, G is the DAE
c     system residual function, and J is the system iteration matrix
c     (Jacobian).
c
c     In addition to the parameters defined elsewhere, we have
c
c     P       -- Approximate Newton step used in backtracking.
c     PNRM    -- Weighted RMS norm of P.
c     LSOFF   -- Flag showing whether the linesearch algorithm is
c                to be invoked.  0 means do the linesearch, and
c                1 means turn off linesearch.
c     STPTOL  -- Tolerance used in calculating the minimum lambda
c                value allowed.
c     ICNFLG  -- Integer scalar.  If nonzero, then constraint violations
c                in the proposed new approximate solution will be
c                checked for, and the maximum step length will be
c                adjusted accordingly.
c     ICNSTR  -- Integer array of length NEQ containing flags for
c                checking constraints.
c     RLX     -- Real scalar restricting update size in SCNSTR.
c     YNEW    -- Array of length NEQ used to hold the new Y in
c                performing the linesearch.
c     YPNEW   -- Array of length NEQ used to hold the new YPRIME in
c                performing the linesearch.
c     Y       -- Array of length NEQ containing the new Y (i.e.,=YNEW).
c     YPRIME  -- Array of length NEQ containing the new YPRIME
c                (i.e.,=YPNEW).
c     FNRM    -- Real scalar containing SQRT(2*f(Y,YPRIME)) for the
c                current (Y,YPRIME) on input and output.
c     R       -- Work array of length NEQ, containing the scaled
c                residual (J-inverse)*G(t,y,y') on return.
c     IRET    -- Return flag.
c                IRET=0 means that a satisfactory (Y,YPRIME) was found.
c                IRET=1 means that the routine failed to find a new
c                       (Y,YPRIME) that was sufficiently distinct from
c                       the current (Y,YPRIME) pair.
c                IRET=2 means IRES .ne. 0 from RES.
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED
c   SFNRMD, SYYPNW, SCOPY
c
c***END PROLOGUE  SLINSD
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER LNRE,LKPRIN,KPRIN,IWM,IVIO,ICNFLG,IRET,I,NEQ,LSOFF, IRES,
     &   IPAR,ICNSTR,IVAR,ID,ICOPT
      EXTERNAL RES
      DIMENSION Y(*), YPRIME(*), WT(*), R(*), ID(*)
      DIMENSION WM(*), IWM(*)
      DIMENSION YNEW(*), YPNEW(*), P(*), ICNSTR(*)
      DIMENSION RPAR(*), IPAR(*)
      CHARACTER MSG*80
c
      PARAMETER (LNRE=12, LKPRIN=31)
c
      SAVE ALPHA, ONE, TWO
      DATA ALPHA/1.0d-4/, ONE/1.0d0/, TWO/2.0d0/
c
      KPRIN=IWM(LKPRIN)
c
      F1NRM = (FNRM*FNRM)/TWO
      RATIO = ONE
      RL = ONE
      IF (KPRIN .GE. 2) THEN
      MSG = '------ IN ROUTINE SLINSD-- PNRM = (R1) )'
      CALL dxerrwv_u(MSG, 40, 901, 0, 0, 0, 0, 1, PNRM, 0.0d0)
      ENDIF
      TAU = PNRM
      IVIO = 0
c-----------------------------------------------------------------------
c Check for violations of the contraints, if any are imposed.
c If any violations are found, the step vector P is rescaled, and the
c constraint check is repeated, until no violations are found.
c-----------------------------------------------------------------------
      IF (ICNFLG .NE. 0) THEN
   10 CONTINUE
      CALL SYYPNW (NEQ,Y,YPRIME,CJ,RL,P,ICOPT,ID,YNEW,YPNEW)
      CALL SCNSTR (NEQ, Y, YNEW, ICNSTR, TAU, RLX, IRET, IVAR)
      IF (IRET .EQ. 1) THEN
      IVIO = 1
      RATIO1 = TAU/PNRM
      RATIO = RATIO*RATIO1
      DO 20 I = 1,NEQ
   20 P(I) = P(I)*RATIO1
      PNRM = TAU
      IF (KPRIN .GE. 2) THEN
      MSG = '------ CONSTRAINT VIOL., PNRM = (R1), INDEX = (I1)'
      CALL dxerrwv_u(MSG, 50, 902, 0, 1, IVAR, 0, 1, PNRM, 0.0d0)
      ENDIF
      IF (PNRM .LE. STPTOL) THEN
      IRET = 1
      RETURN
      ENDIF
      GO TO 10
      ENDIF
      ENDIF
c
      SLPI = (-TWO*F1NRM)*RATIO
      RLMIN = STPTOL/PNRM
      IF (LSOFF .EQ. 0 .AND. KPRIN .GE. 2) THEN
      MSG = '------ MIN. LAMBDA = (R1)'
      CALL dxerrwv_u(MSG, 25, 903, 0, 0, 0, 0, 1, RLMIN, 0.0d0)
      ENDIF
c-----------------------------------------------------------------------
c Begin iteration to find RL value satisfying alpha-condition.
c If RL becomes less than RLMIN, then terminate with IRET = 1.
c-----------------------------------------------------------------------
  100 CONTINUE
      CALL SYYPNW (NEQ,Y,YPRIME,CJ,RL,P,ICOPT,ID,YNEW,YPNEW)
      CALL SFNRMD (NEQ, YNEW, T, YPNEW, R, CJ, WT, RES, IRES, FNRMP, WM, 
     &   IWM, RPAR, IPAR)
      IWM(LNRE) = IWM(LNRE) + 1
      IF (IRES .NE. 0) THEN
      IRET = 2
      RETURN
      ENDIF
      IF (LSOFF .EQ. 1) GO TO 150
c
      F1NRMP = FNRMP*FNRMP/TWO
      IF (KPRIN .GE. 2) THEN
      MSG = '------ LAMBDA = (R1)'
      CALL dxerrwv_u(MSG, 20, 904, 0, 0, 0, 0, 1, RL, 0.0d0)
      MSG = '------ NORM(F1) = (R1),  NORM(F1NEW) = (R2)'
      CALL dxerrwv_u(MSG, 43, 905, 0, 0, 0, 0, 2, F1NRM, F1NRMP)
      ENDIF
      IF (F1NRMP .GT. F1NRM + ALPHA*SLPI*RL) GO TO 200
c-----------------------------------------------------------------------
c Alpha-condition is satisfied, or linesearch is turned off.
c Copy YNEW,YPNEW to Y,YPRIME and return.
c-----------------------------------------------------------------------
  150 IRET = 0
      CALL dcopy_u(NEQ, YNEW, 1, Y, 1)
      CALL dcopy_u(NEQ, YPNEW, 1, YPRIME, 1)
      FNRM = FNRMP
      IF (KPRIN .GE. 1) THEN
      MSG = '------ LEAVING ROUTINE SLINSD, FNRM = (R1)'
      CALL dxerrwv_u(MSG, 42, 906, 0, 0, 0, 0, 1, FNRM, 0.0d0)
      ENDIF
      RETURN
c-----------------------------------------------------------------------
c Alpha-condition not satisfied.  Perform backtrack to compute new RL
c value.  If no satisfactory YNEW,YPNEW can be found sufficiently
c distinct from Y,YPRIME, then return IRET = 1.
c-----------------------------------------------------------------------
  200 CONTINUE
      IF (RL .LT. RLMIN) THEN
      IRET = 1
      RETURN
      ENDIF
c
      RL = RL/TWO
      GO TO 100
c
c----------------------- END OF SUBROUTINE SLINSD ----------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SFNRMD (NEQ, Y, T, YPRIME, R, CJ, WT, RES, IRES, FNORM, 
     &   WM, IWM, RPAR, IPAR)
c
c***BEGIN PROLOGUE  SFNRMD
c***REFER TO  SLINSD
c***DATE WRITTEN   941025   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SFNRMD calculates the scaled preconditioned norm of the nonlinear
c     function used in the nonlinear iteration for obtaining consistent
c     initial conditions.  Specifically, SFNRMD calculates the weighted
c     root-mean-square norm of the vector (J-inverse)*G(T,Y,YPRIME),
c     where J is the Jacobian matrix.
c
c     In addition to the parameters described in the calling program
c     SLINSD, the parameters represent
c
c     R      -- Array of length NEQ that contains
c               (J-inverse)*G(T,Y,YPRIME) on return.
c     FNORM  -- Scalar containing the weighted norm of R on return.
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED
c   RES, SSLVD, SDWNRM
c
c***END PROLOGUE  SFNRMD
c
c
      IMPLICIT doubleprecision (A-H,O-Z)
      INTEGER IRES,IWM,IPAR,NEQ
      EXTERNAL RES
      DIMENSION Y(*), YPRIME(*), WT(*), R(*)
      DIMENSION WM(*),IWM(*), RPAR(*),IPAR(*)
c-----------------------------------------------------------------------
c     Call RES routine.
c-----------------------------------------------------------------------
      IRES = 0
      CALL RES(T,Y,YPRIME,CJ,R,IRES,RPAR,IPAR)
      IF (IRES .LT. 0) RETURN
c-----------------------------------------------------------------------
c     Apply inverse of Jacobian to vector R.
c-----------------------------------------------------------------------
      CALL SSLVD(NEQ,R,WM,IWM)
c-----------------------------------------------------------------------
c     Calculate norm of R.
c-----------------------------------------------------------------------
      FNORM = SDWNRM(NEQ,R,WT,RPAR,IPAR)
c
      RETURN
c----------------------- END OF SUBROUTINE SFNRMD ----------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SNEDD(X,Y,YPRIME,NEQ,RES,JACD,PDUM,H,WT, JSTART,IDID,
     &   RPAR,IPAR,PHI,GAMMA,DUMSVR,DELTA,E, WM,IWM,CJ,CJOLD,CJLAST,S,
     &   UROUND,DUME,DUMS,DUMR, EPCON,JCALC,JFDUM,KP1,NONNEG,NTYPE,
     &   IERNLS)
c
c***BEGIN PROLOGUE  SNEDD
c***REFER TO  SDASPK
c***DATE WRITTEN   891219   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SNEDD solves a nonlinear system of
c     algebraic equations of the form
c     G(X,Y,YPRIME) = 0 for the unknown Y.
c
c     The method used is a modified Newton scheme.
c
c     The parameters represent
c
c     X         -- Independent variable.
c     Y         -- Solution vector.
c     YPRIME    -- Derivative of solution vector.
c     NEQ       -- Number of unknowns.
c     RES       -- External user-supplied subroutine
c                  to evaluate the residual.  See RES description
c                  in SDASPK prologue.
c     JACD      -- External user-supplied routine to evaluate the
c                  Jacobian.  See JAC description for the case
c                  INFO(12) = 0 in the SDASPK prologue.
c     PDUM      -- Dummy argument.
c     H         -- Appropriate step size for next step.
c     WT        -- Vector of weights for error criterion.
c     JSTART    -- Indicates first call to this routine.
c                  If JSTART = 0, then this is the first call,
c                  otherwise it is not.
c     IDID      -- Completion flag, output by SNEDD.
c                  See IDID description in SDASPK prologue.
c     RPAR,IPAR -- Real and integer arrays used for communication
c                  between the calling program and external user
c                  routines.  They are not altered within DASPK.
c     PHI       -- Array of divided differences used by
c                  SNEDD.  The length is NEQ*(K+1),where
c                  K is the maximum order.
c     GAMMA     -- Array used to predict Y and YPRIME.  The length
c                  is MAXORD+1 where MAXORD is the maximum order.
c     DUMSVR    -- Dummy argument.
c     DELTA     -- Work vector for NLS of length NEQ.
c     E         -- Error accumulation vector for NLS of length NEQ.
c     WM,IWM    -- Real and integer arrays storing
c                  matrix information such as the matrix
c                  of partial derivatives, permutation
c                  vector, and various other information.
c     CJ        -- Parameter always proportional to 1/H.
c     CJOLD     -- Saves the value of CJ as of the last call to SMATD.
c                  Accounts for changes in CJ needed to
c                  decide whether to call SMATD.
c     CJLAST    -- Previous value of CJ.
c     S         -- A scalar determined by the approximate rate
c                  of convergence of the Newton iteration and used
c                  in the convergence test for the Newton iteration.
c
c                  If RATE is defined to be an estimate of the
c                  rate of convergence of the Newton iteration,
c                  then S = RATE/(1.E0-RATE).
c
c                  The closer RATE is to 0., the faster the Newton
c                  iteration is converging; the closer RATE is to 1.,
c                  the slower the Newton iteration is converging.
c
c                  On the first Newton iteration with an up-dated
c                  preconditioner S = 100.E0, Thus the initial
c                  RATE of convergence is approximately 1.
c
c                  S is preserved from call to call so that the rate
c                  estimate from a previous step can be applied to
c                  the current step.
c     UROUND    -- Unit roundoff.
c     DUME      -- Dummy argument.
c     DUMS      -- Dummy argument.
c     DUMR      -- Dummy argument.
c     EPCON     -- Tolerance to test for convergence of the Newton
c                  iteration.
c     JCALC     -- Flag used to determine when to update
c                  the Jacobian matrix.  In general:
c
c                  JCALC = -1 ==> Call the SMATD routine to update
c                                 the Jacobian matrix.
c                  JCALC =  0 ==> Jacobian matrix is up-to-date.
c                  JCALC =  1 ==> Jacobian matrix is out-dated,
c                                 but SMATD will not be called unless
c                                 JCALC is set to -1.
c     JFDUM     -- Dummy argument.
c     KP1       -- The current order(K) + 1;  updated across calls.
c     NONNEG    -- Flag to determine nonnegativity constraints.
c     NTYPE     -- Identification code for the NLS routine.
c                   0  ==> modified Newton; direct solver.
c     IERNLS    -- Error flag for nonlinear solver.
c                   0  ==> nonlinear solver converged.
c                   1  ==> recoverable error inside nonlinear solver.
c                  -1  ==> unrecoverable error inside nonlinear solver.
c
c     All variables with "DUM" in their names are dummy variables
c     which are not used in this routine.
c
c     Following is a list and description of local variables which
c     may not have an obvious usage.  They are listed in roughly the
c     order they occur in this subroutine.
c
c     The following group of variables are passed as arguments to
c     the Newton iteration solver.  They are explained in greater detail
c     in SNSD:
c        TOLNEW, MULDEL, MAXIT, IERNEW
c
c     IERTYP -- Flag which tells whether this subroutine is correct.
c               0 ==> correct subroutine.
c               1 ==> incorrect subroutine.
c
c-----------------------------------------------------------------------
c***ROUTINES CALLED
c   SDWNRM, RES, SMATD, SNSD
c
c***END PROLOGUE  SNEDD
c
c
      IMPLICIT doubleprecision(A-H,O-Z)

      INTEGER NEQ,LNRE,LNJE,IERTYP,NTYPE,JSTART,JCALC,IERNLS,IERJ, IRES,
     &   IERNEW,I,J,KP1,IWM,MULDEL,MAXIT,NONNEG,IDID,JFDUM,IDUM, IPAR
      DIMENSION Y(*),YPRIME(*),WT(*)
      DIMENSION DELTA(*),E(*)
      DIMENSION WM(*),IWM(*), RPAR(*),IPAR(*)
      DIMENSION PHI(NEQ,*),GAMMA(*)
      EXTERNAL RES, JACD
c
      PARAMETER (LNRE=12, LNJE=13)
c
      SAVE MULDEL, MAXIT, XRATE
      DATA MULDEL/1/, MAXIT/4/, XRATE/0.25d0/
c
c     Verify that this is the correct subroutine.
c
      IERTYP = 0
      IF (NTYPE .NE. 0) THEN
      IERTYP = 1
      GO TO 380
      ENDIF
c
c     If this is the first step, perform initializations.
c
      IF (JSTART .EQ. 0) THEN
      CJOLD = CJ
      JCALC = -1
      ENDIF
c
c     Perform all other initializations.
c
      IERNLS = 0
c
c     Decide whether new Jacobian is needed.
c
      TEMP1 = (1.0d0 - XRATE)/(1.0d0 + XRATE)
      TEMP2 = 1.0d0/TEMP1
      IF (CJ/CJOLD .LT. TEMP1 .OR. CJ/CJOLD .GT. TEMP2) JCALC = -1
      IF (CJ .NE. CJLAST) S = 100.d0
c
c-----------------------------------------------------------------------
c     Entry point for updating the Jacobian with current
c     stepsize.
c-----------------------------------------------------------------------
  300 CONTINUE
c
c     Initialize all error flags to zero.
c
      IERJ = 0
      IRES = 0
      IERNEW = 0
c
c     Predict the solution and derivative and compute the tolerance
c     for the Newton iteration.
c
      DO 310 I=1,NEQ
      Y(I)=PHI(I,1)
  310 YPRIME(I)=0.0d0
      DO 330 J=2,KP1
      DO 320 I=1,NEQ
      Y(I)=Y(I)+PHI(I,J)
  320 YPRIME(I)=YPRIME(I)+GAMMA(J)*PHI(I,J)
  330 CONTINUE
      PNORM = SDWNRM (NEQ,Y,WT,RPAR,IPAR)
      TOLNEW = 100.d0*UROUND*PNORM
c
c     Call RES to initialize DELTA.
c
      IWM(LNRE)=IWM(LNRE)+1
      CALL RES(X,Y,YPRIME,CJ,DELTA,IRES,RPAR,IPAR)
      IF (IRES .LT. 0) GO TO 380
c
c     If indicated, reevaluate the iteration matrix
c     J = dG/dY + CJ*dG/dYPRIME (where G(X,Y,YPRIME)=0).
c     Set JCALC to 0 as an indicator that this has been done.
c
      IF(JCALC .EQ. -1) THEN
      IWM(LNJE)=IWM(LNJE)+1
      JCALC=0
      CALL SMATD(NEQ,X,Y,YPRIME,DELTA,CJ,H,IERJ,WT,E,WM,IWM, RES,IRES,
     &   UROUND,JACD,RPAR,IPAR)
      CJOLD=CJ
      S = 100.d0
      IF (IRES .LT. 0) GO TO 380
      IF(IERJ .NE. 0)GO TO 380
      ENDIF
c
c     Call the nonlinear Newton solver.
c
      TEMP1 = 2.0d0/(1.0d0 + CJ/CJOLD)
      CALL SNSD(X,Y,YPRIME,NEQ,RES,PDUM,WT,RPAR,IPAR,DUMSVR, DELTA,E,WM,
     &   IWM,CJ,DUMS,DUMR,DUME,EPCON,S,TEMP1, TOLNEW,MULDEL,MAXIT,IRES,
     &   IDUM,IERNEW)
c
      IF (IERNEW .GT. 0 .AND. JCALC .NE. 0) THEN
c
c        The Newton iteration had a recoverable failure with an old
c        iteration matrix.  Retry the step with a new iteration matrix.
c
      JCALC = -1
      GO TO 300
      ENDIF
c
      IF (IERNEW .NE. 0) GO TO 380
c
c     The Newton iteration has converged.  If nonnegativity of
c     solution is required, set the solution nonnegative, if the
c     perturbation to do it is small enough.  If the change is too
c     large, then consider the corrector iteration to have failed.
c
  375 IF(NONNEG .EQ. 0) GO TO 390
      DO 377 I = 1,NEQ
  377 DELTA(I) = MIN(Y(I),0.0d0)
      DELNRM = SDWNRM(NEQ,DELTA,WT,RPAR,IPAR)
      IF(DELNRM .GT. EPCON) GO TO 380
      DO 378 I = 1,NEQ
  378 E(I) = E(I) - DELTA(I)
      GO TO 390
c
c
c     Exits from nonlinear solver.
c     No convergence with current iteration
c     matrix, or singular iteration matrix.
c     Compute IERNLS and IDID accordingly.
c
  380 CONTINUE
      IF (IRES .LE. -2 .OR. IERTYP .NE. 0) THEN
      IERNLS = -1
      IF (IRES .LE. -2) IDID = -11
      IF (IERTYP .NE. 0) IDID = -15
      ELSE
      IERNLS = 1
      IF (IRES .LT. 0) IDID = -10
      IF (IERJ .NE. 0) IDID = -8
      ENDIF
c
  390 JCALC = 1
      RETURN
c
c------END OF SUBROUTINE SNEDD------------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SNSD(X,Y,YPRIME,NEQ,RES,PDUM,WT,RPAR,IPAR, DUMSVR,DELTA
     &   ,E,WM,IWM,CJ,DUMS,DUMR,DUME,EPCON, S,CONFAC,TOLNEW,MULDEL,MAXIT
     &   ,IRES,IDUM,IERNEW)
c
c***BEGIN PROLOGUE  SNSD
c***REFER TO  SDASPK
c***DATE WRITTEN   891219   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***REVISION DATE  950126   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SNSD solves a nonlinear system of
c     algebraic equations of the form
c     G(X,Y,YPRIME) = 0 for the unknown Y.
c
c     The method used is a modified Newton scheme.
c
c     The parameters represent
c
c     X         -- Independent variable.
c     Y         -- Solution vector.
c     YPRIME    -- Derivative of solution vector.
c     NEQ       -- Number of unknowns.
c     RES       -- External user-supplied subroutine
c                  to evaluate the residual.  See RES description
c                  in SDASPK prologue.
c     PDUM      -- Dummy argument.
c     WT        -- Vector of weights for error criterion.
c     RPAR,IPAR -- Real and integer arrays used for communication
c                  between the calling program and external user
c                  routines.  They are not altered within DASPK.
c     DUMSVR    -- Dummy argument.
c     DELTA     -- Work vector for SNSD of length NEQ.
c     E         -- Error accumulation vector for SNSD of length NEQ.
c     WM,IWM    -- Real and integer arrays storing
c                  matrix information such as the matrix
c                  of partial derivatives, permutation
c                  vector, and various other information.
c     CJ        -- Parameter always proportional to 1/H (step size).
c     DUMS      -- Dummy argument.
c     DUMR      -- Dummy argument.
c     DUME      -- Dummy argument.
c     EPCON     -- Tolerance to test for convergence of the Newton
c                  iteration.
c     S         -- Used for error convergence tests.
c                  In the Newton iteration: S = RATE/(1 - RATE),
c                  where RATE is the estimated rate of convergence
c                  of the Newton iteration.
c                  The calling routine passes the initial value
c                  of S to the Newton iteration.
c     CONFAC    -- A residual scale factor to improve convergence.
c     TOLNEW    -- Tolerance on the norm of Newton correction in
c                  alternative Newton convergence test.
c     MULDEL    -- A flag indicating whether or not to multiply
c                  DELTA by CONFAC.
c                  0  ==> do not scale DELTA by CONFAC.
c                  1  ==> scale DELTA by CONFAC.
c     MAXIT     -- Maximum allowed number of Newton iterations.
c     IRES      -- Error flag returned from RES.  See RES description
c                  in SDASPK prologue.  If IRES = -1, then IERNEW
c                  will be set to 1.
c                  If IRES < -1, then IERNEW will be set to -1.
c     IDUM      -- Dummy argument.
c     IERNEW    -- Error flag for Newton iteration.
c                   0  ==> Newton iteration converged.
c                   1  ==> recoverable error inside Newton iteration.
c                  -1  ==> unrecoverable error inside Newton iteration.
c
c     All arguments with "DUM" in their names are dummy arguments
c     which are not used in this routine.
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED
c   SSLVD, SDWNRM, RES
c
c***END PROLOGUE  SNSD
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER LNRE,LNNI,M,I,NEQ,IWM,MULDEL,MAXIT,IRES,IERNEW,IDUM,IPAR
      DIMENSION Y(*),YPRIME(*),WT(*),DELTA(*),E(*)
      DIMENSION WM(*),IWM(*), RPAR(*),IPAR(*)
      EXTERNAL RES
c
      PARAMETER (LNRE=12, LNNI=19)
c
c     Initialize Newton counter M and accumulation vector E.
c
      M = 0
      DO 100 I=1,NEQ
  100 E(I)=0.0d0
c
c     Corrector loop.
c
  300 CONTINUE
      IWM(LNNI) = IWM(LNNI) + 1
c
c     If necessary, multiply residual by convergence factor.
c
      IF (MULDEL .EQ. 1) THEN
      DO 320 I = 1,NEQ
  320 DELTA(I) = DELTA(I) * CONFAC
      ENDIF
c
c     Compute a new iterate (back-substitution).
c     Store the correction in DELTA.
c
      CALL SSLVD(NEQ,DELTA,WM,IWM)
c
c     Update Y, E, and YPRIME.
c
      DO 340 I=1,NEQ
      Y(I)=Y(I)-DELTA(I)
      E(I)=E(I)-DELTA(I)
  340 YPRIME(I)=YPRIME(I)-CJ*DELTA(I)
c
c     Test for convergence of the iteration.
c
      DELNRM=SDWNRM(NEQ,DELTA,WT,RPAR,IPAR)
      IF (DELNRM .LE. TOLNEW) GO TO 370
      IF (M .EQ. 0) THEN
      OLDNRM = DELNRM
      ELSE
      RATE = (DELNRM/OLDNRM)**(1.0d0/M)
      IF (RATE .GT. 0.9d0) GO TO 380
      S = RATE/(1.0d0 - RATE)
      ENDIF
      IF (S*DELNRM .LE. EPCON) GO TO 370
c
c     The corrector has not yet converged.
c     Update M and test whether the
c     maximum number of iterations have
c     been tried.
c
      M=M+1
      IF(M.GE.MAXIT) GO TO 380
c
c     Evaluate the residual,
c     and go back to do another iteration.
c
      IWM(LNRE)=IWM(LNRE)+1
      CALL RES(X,Y,YPRIME,CJ,DELTA,IRES,RPAR,IPAR)
      IF (IRES .LT. 0) GO TO 380
      GO TO 300
c
c     The iteration has converged.
c
  370 RETURN
c
c     The iteration has not converged.  Set IERNEW appropriately.
c
  380 CONTINUE
      IF (IRES .LE. -2 ) THEN
      IERNEW = -1
      ELSE
      IERNEW = 1
      ENDIF
      RETURN
c
c
c------END OF SUBROUTINE SNSD-------------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SMATD(NEQ,X,Y,YPRIME,DELTA,CJ,H,IER,EWT,E, WM,IWM,RES,
     &   IRES,UROUND,JACD,RPAR,IPAR)
c
c***BEGIN PROLOGUE  SMATD
c***REFER TO  SDASPK
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***REVISION DATE  940701   (YYMMDD) (new LIPVT)
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     This routine computes the iteration matrix
c     J = dG/dY+CJ*dG/dYPRIME (where G(X,Y,YPRIME)=0).
c     Here J is computed by:
c       the user-supplied routine JACD if IWM(MTYPE) is 1 or 4, or
c       by numerical difference quotients if IWM(MTYPE) is 2 or 5.
c
c     The parameters have the following meanings.
c     X        = Independent variable.
c     Y        = Array containing predicted values.
c     YPRIME   = Array containing predicted derivatives.
c     DELTA    = Residual evaluated at (X,Y,YPRIME).
c                (Used only if IWM(MTYPE)=2 or 5).
c     CJ       = Scalar parameter defining iteration matrix.
c     H        = Current stepsize in integration.
c     IER      = Variable which is .NE. 0 if iteration matrix
c                is singular, and 0 otherwise.
c     EWT      = Vector of error weights for computing norms.
c     E        = Work space (temporary) of length NEQ.
c     WM       = Real work space for matrices.  On output
c                it contains the LU decomposition
c                of the iteration matrix.
c     IWM      = Integer work space containing
c                matrix information.
c     RES      = External user-supplied subroutine
c                to evaluate the residual.  See RES description
c                in SDASPK prologue.
c     IRES     = Flag which is equal to zero if no illegal values
c                in RES, and less than zero otherwise.  (If IRES
c                is less than zero, the matrix was not completed).
c                In this case (if IRES .LT. 0), then IER = 0.
c     UROUND   = The unit roundoff error of the machine being used.
c     JACD     = Name of the external user-supplied routine
c                to evaluate the iteration matrix.  (This routine
c                is only used if IWM(MTYPE) is 1 or 4)
c                See JAC description for the case INFO(12) = 0
c                in SDASPK prologue.
c     RPAR,IPAR= Real and integer parameter arrays that
c                are used for communication between the
c                calling program and external user routines.
c                They are not altered by SMATD.
c-----------------------------------------------------------------------
c***ROUTINES CALLED
c   JACD, RES, SGEFA, SGBFA
c
c***END PROLOGUE  SMATD
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER LML,LMU,LMTYPE,LNRE,LNPD,LLCIWP,LIPVT,IWM,IER,MTYPE, LENPD
     &   ,I,IRES,NROW,NEQ,L,MEBAND,MBAND,MBA,MEB1,MSAVE,ISAVE, IPSAVE,J,
     &   N,K,I1,I2,II,IPAR
      DIMENSION Y(*),YPRIME(*),DELTA(*),EWT(*),E(*)
      DIMENSION WM(*),IWM(*), RPAR(*),IPAR(*)
      EXTERNAL RES, JACD
c
      PARAMETER (LML=1, LMU=2, LMTYPE=4, LNRE=12, LNPD=22, LLCIWP=30)
c
      LIPVT = IWM(LLCIWP)
      IER = 0
      MTYPE=IWM(LMTYPE)
      GO TO (100,200,300,400,500),MTYPE
c
c
c     Dense user-supplied matrix.
c
  100 LENPD=IWM(LNPD)
      DO 110 I=1,LENPD
  110 WM(I)=0.0d0
      CALL JACD(X,Y,YPRIME,WM,CJ,RPAR,IPAR)
      GO TO 230
c
c
c     Dense finite-difference-generated matrix.
c
  200 IRES=0
      NROW=0
      SQUR = SQRT(UROUND)
      DO 210 I=1,NEQ
      DEL=SQUR*MAX(ABS(Y(I)),ABS(H*YPRIME(I)), ABS(1.d0/EWT(I)))
      DEL=SIGN(DEL,H*YPRIME(I))
      DEL=(Y(I)+DEL)-Y(I)
      YSAVE=Y(I)
      YPSAVE=YPRIME(I)
      Y(I)=Y(I)+DEL
      YPRIME(I)=YPRIME(I)+CJ*DEL
      IWM(LNRE)=IWM(LNRE)+1
      CALL RES(X,Y,YPRIME,CJ,E,IRES,RPAR,IPAR)
      IF (IRES .LT. 0) RETURN
      DELINV=1.0d0/DEL
      DO 220 L=1,NEQ
  220 WM(NROW+L)=(E(L)-DELTA(L))*DELINV
      NROW=NROW+NEQ
      Y(I)=YSAVE
      YPRIME(I)=YPSAVE
  210 CONTINUE
c
c
c     Do dense-matrix LU decomposition on J.
c
  230 CALL dgefa_u(WM,NEQ,NEQ,IWM(LIPVT),IER)
      RETURN
c
c
c     Dummy section for IWM(MTYPE)=3.
c
  300 RETURN
c
c
c     Banded user-supplied matrix.
c
  400 LENPD=IWM(LNPD)
      DO 410 I=1,LENPD
  410 WM(I)=0.0d0
      CALL JACD(X,Y,YPRIME,WM,CJ,RPAR,IPAR)
      MEBAND=2*IWM(LML)+IWM(LMU)+1
      GO TO 550
c
c
c     Banded finite-difference-generated matrix.
c
  500 MBAND=IWM(LML)+IWM(LMU)+1
      MBA=MIN(MBAND,NEQ)
      MEBAND=MBAND+IWM(LML)
      MEB1=MEBAND-1
      MSAVE=(NEQ/MBAND)+1
      ISAVE=IWM(LNPD)
      IPSAVE=ISAVE+MSAVE
      IRES=0
      SQUR=SQRT(UROUND)
      DO 540 J=1,MBA
      DO 510 N=J,NEQ,MBAND
      K= (N-J)/MBAND + 1
      WM(ISAVE+K)=Y(N)
      WM(IPSAVE+K)=YPRIME(N)
      DEL=SQUR*MAX(ABS(Y(N)),ABS(H*YPRIME(N)), ABS(1.d0/EWT(N)))
      DEL=SIGN(DEL,H*YPRIME(N))
      DEL=(Y(N)+DEL)-Y(N)
      Y(N)=Y(N)+DEL
  510 YPRIME(N)=YPRIME(N)+CJ*DEL
      IWM(LNRE)=IWM(LNRE)+1
      CALL RES(X,Y,YPRIME,CJ,E,IRES,RPAR,IPAR)
      IF (IRES .LT. 0) RETURN
      DO 530 N=J,NEQ,MBAND
      K= (N-J)/MBAND + 1
      Y(N)=WM(ISAVE+K)
      YPRIME(N)=WM(IPSAVE+K)
      DEL=SQUR*MAX(ABS(Y(N)),ABS(H*YPRIME(N)), ABS(1.d0/EWT(N)))
      DEL=SIGN(DEL,H*YPRIME(N))
      DEL=(Y(N)+DEL)-Y(N)
      DELINV=1.0d0/DEL
      I1=MAX(1,(N-IWM(LMU)))
      I2=MIN(NEQ,(N+IWM(LML)))
      II=N*MEB1-IWM(LML)
      DO 520 I=I1,I2
  520 WM(II+I)=(E(I)-DELTA(I))*DELINV
  530 CONTINUE
  540 CONTINUE
c
c
c     Do LU decomposition of banded J.
c
  550 CALL dgbfa_u(WM,MEBAND,NEQ,IWM(LML),IWM(LMU),IWM(LIPVT),IER)
      RETURN
c
c------END OF SUBROUTINE SMATD------------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SSLVD(NEQ,DELTA,WM,IWM)
c
c***BEGIN PROLOGUE  SSLVD
c***REFER TO  SDASPK
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***REVISION DATE  940701   (YYMMDD) (new LIPVT)
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     This routine manages the solution of the linear
c     system arising in the Newton iteration.
c     Real matrix information and real temporary storage
c     is stored in the array WM.
c     Integer matrix information is stored in the array IWM.
c     For a dense matrix, the LINPACK routine SGESL is called.
c     For a banded matrix, the LINPACK routine SGBSL is called.
c-----------------------------------------------------------------------
c***ROUTINES CALLED
c   SGESL, SGBSL
c
c***END PROLOGUE  SSLVD
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER LML,LMU,LMTYPE,LLCIWP,LIPVT,IWM,MTYPE,MEBAND,NEQ
      DIMENSION DELTA(*),WM(*),IWM(*)
c
      PARAMETER (LML=1, LMU=2, LMTYPE=4, LLCIWP=30)
c
      LIPVT = IWM(LLCIWP)
      MTYPE=IWM(LMTYPE)
      GO TO(100,100,300,400,400),MTYPE
c
c     Dense matrix.
c
  100 CALL dgesl_u(WM,NEQ,NEQ,IWM(LIPVT),DELTA,0)
      RETURN
c
c     Dummy section for MTYPE=3.
c
  300 CONTINUE
      RETURN
c
c     Banded matrix.
c
  400 MEBAND=2*IWM(LML)+IWM(LMU)+1
      CALL dgbsl_u(WM,MEBAND,NEQ,IWM(LML), IWM(LMU),IWM(LIPVT),DELTA,0)
      RETURN
c
c------END OF SUBROUTINE SSLVD------------------------------------------
      END
c Work perfored under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SDASIK(X,Y,YPRIME,NEQ,ICOPT,ID,RES,JACK,PSOL,H,WT, 
     &   JSKIP,RPAR,IPAR,SAVR,DELTA,R,YIC,YPIC,PWK,WM,IWM,CJ,UROUND, 
     &   EPLI,SQRTN,RSQRTN,EPCON,RATEMX,STPTOL,JFLG, ICNFLG,ICNSTR,
     &   IERNLS)
c
c***BEGIN PROLOGUE  SDASIK
c***REFER TO  SDASPK
c***DATE WRITTEN   941026   (YYMMDD)
c***REVISION DATE  950808   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c
c     SDASIK solves a nonlinear system of algebraic equations of the
c     form G(X,Y,YPRIME) = 0 for the unknown parts of Y and YPRIME in
c     the initial conditions.
c
c     An initial value for Y and initial guess for YPRIME are input.
c
c     The method used is a Newton scheme with Krylov iteration and a
c     linesearch algorithm.
c
c     The parameters represent
c
c     X         -- Independent variable.
c     Y         -- Solution vector at x.
c     YPRIME    -- Derivative of solution vector.
c     NEQ       -- Number of equations to be integrated.
c     ICOPT     -- Initial condition option chosen (1 or 2).
c     ID        -- Array of dimension NEQ, which must be initialized
c                  if ICOPT = 1.  See SDASIC.
c     RES       -- External user-supplied subroutine
c                  to evaluate the residual.  See RES description
c                  in SDASPK prologue.
c     JACK     --  External user-supplied routine to update
c                  the preconditioner.  (This is optional).
c                  See JAC description for the case
c                  INFO(12) = 1 in the SDASPK prologue.
c     PSOL      -- External user-supplied routine to solve
c                  a linear system using preconditioning.
c                  (This is optional).  See explanation inside SDASPK.
c     H         -- Scaling factor for this initial condition calc.
c     WT        -- Vector of weights for error criterion.
c     JSKIP     -- input flag to signal if initial JAC call is to be
c                  skipped.  1 => skip the call, 0 => do not skip call.
c     RPAR,IPAR -- Real and integer arrays used for communication
c                  between the calling program and external user
c                  routines.  They are not altered within DASPK.
c     SAVR      -- Work vector for SDASIK of length NEQ.
c     DELTA     -- Work vector for SDASIK of length NEQ.
c     R         -- Work vector for SDASIK of length NEQ.
c     YIC,YPIC  -- Work vectors for SDASIK, each of length NEQ.
c     PWK       -- Work vector for SDASIK of length NEQ.
c     WM,IWM    -- Real and integer arrays storing
c                  matrix information for linear system
c                  solvers, and various other information.
c     CJ        -- Matrix parameter = 1/H (ICOPT = 1) or 0 (ICOPT = 2).
c     UROUND    -- Unit roundoff.
c     EPLI      -- convergence test constant.
c                  See SDASPK prologue for more details.
c     SQRTN     -- Square root of NEQ.
c     RSQRTN    -- reciprical of square root of NEQ.
c     EPCON     -- Tolerance to test for convergence of the Newton
c                  iteration.
c     RATEMX    -- Maximum convergence rate for which Newton iteration
c                  is considered converging.
c     JFLG      -- Flag showing whether a Jacobian routine is supplied.
c     ICNFLG    -- Integer scalar.  If nonzero, then constraint
c                  violations in the proposed new approximate solution
c                  will be checked for, and the maximum step length
c                  will be adjusted accordingly.
c     ICNSTR    -- Integer array of length NEQ containing flags for
c                  checking constraints.
c     IERNLS    -- Error flag for nonlinear solver.
c                   0   ==> nonlinear solver converged.
c                   1,2 ==> recoverable error inside nonlinear solver.
c                           1 => retry with current Y, YPRIME
c                           2 => retry with original Y, YPRIME
c                  -1   ==> unrecoverable error in nonlinear solver.
c
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED
c   RES, JACK, SNSIK, SCOPY
c
c***END PROLOGUE  SDASIK
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER LNRE,LNJE,LLOCWP,LLCIWP,LMXNIT,LMXNJ,LWP,IWM,LIWP, MXNIT,
     &   MXNJ,IERNLS,NJ,IRES,IERPJ,IERNEW,JFLG,JSKIP, ICNFLG,IPAR,ICNSTR
     &   ,NEQ,ID,ICOPT
      DIMENSION Y(*),YPRIME(*),ID(*),WT(*),ICNSTR(*)
      DIMENSION SAVR(*),DELTA(*),R(*),YIC(*),YPIC(*),PWK(*)
      DIMENSION WM(*),IWM(*), RPAR(*),IPAR(*)
      EXTERNAL RES, JACK, PSOL
c
      PARAMETER (LNRE=12, LNJE=13, LLOCWP=29, LLCIWP=30)
      PARAMETER (LMXNIT=32, LMXNJ=33)
c
c
c     Perform initializations.
c
      LWP = IWM(LLOCWP)
      LIWP = IWM(LLCIWP)
      MXNIT = IWM(LMXNIT)
      MXNJ = IWM(LMXNJ)
      IERNLS = 0
      NJ = 0
      EPLIN = EPLI*EPCON
c
c     Call RES to initialize DELTA.
c
      IRES = 0
      IWM(LNRE) = IWM(LNRE) + 1
      CALL RES(X,Y,YPRIME,CJ,DELTA,IRES,RPAR,IPAR)
      IF (IRES .LT. 0) GO TO 370
c
c     Looping point for updating the preconditioner.
c
  300 CONTINUE
c
c     Initialize all error flags to zero.
c
      IERPJ = 0
      IRES = 0
      IERNEW = 0
c
c     If a Jacobian routine was supplied, call it.
c
      IF (JFLG .EQ. 1 .AND. JSKIP .EQ. 0) THEN
      NJ = NJ + 1
      IWM(LNJE)=IWM(LNJE)+1
      CALL JACK (RES, IRES, NEQ, X, Y, YPRIME, WT, DELTA, R, H, CJ, WM(
     &   LWP), IWM(LIWP), IERPJ, RPAR, IPAR)
      IF (IRES .LT. 0 .OR. IERPJ .NE. 0) GO TO 370
      ENDIF
      JSKIP = 0
c
c     Call the nonlinear Newton solver for up to MXNIT iterations.
c
      CALL SNSIK(X,Y,YPRIME,NEQ,ICOPT,ID,RES,PSOL,WT,RPAR,IPAR, SAVR,
     &   DELTA,R,YIC,YPIC,PWK,WM,IWM,CJ,SQRTN,RSQRTN, EPLIN,EPCON,RATEMX
     &   ,MXNIT,STPTOL,ICNFLG,ICNSTR,IERNEW)
c
      IF (IERNEW .EQ. 1 .AND. NJ .LT. MXNJ .AND. JFLG .EQ. 1) THEN
c
c       Up to MXNIT iterations were done, the convergence rate is < 1,
c       a Jacobian routine is supplied, and the number of JACK calls
c       is less than MXNJ.
c       Copy the residual SAVR to DELTA, call JACK, and try again.
c
      CALL dcopy_u(NEQ, SAVR, 1, DELTA, 1)
      GO TO 300
      ENDIF
c
      IF (IERNEW .NE. 0) GO TO 380
      RETURN
c
c
c     Unsuccessful exits from nonlinear solver.
c     Set IERNLS accordingly.
c
  370 IERNLS = 2
      IF (IRES .LE. -2) IERNLS = -1
      RETURN
c
  380 IERNLS = MIN(IERNEW,2)
      RETURN
c
  390 IERNLS = 2
      RETURN
c
c----------------------- END OF SUBROUTINE SDASIK-----------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SNSIK(X,Y,YPRIME,NEQ,ICOPT,ID,RES,PSOL,WT,RPAR,IPAR, 
     &   SAVR,DELTA,R,YIC,YPIC,PWK,WM,IWM,CJ,SQRTN,RSQRTN,EPLIN,EPCON, 
     &   RATEMX,MAXIT,STPTOL,ICNFLG,ICNSTR,IERNEW)
c
c***BEGIN PROLOGUE  SNSIK
c***REFER TO  SDASPK
c***DATE WRITTEN   940701   (YYMMDD)
c***REVISION DATE  950714   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SNSIK solves a nonlinear system of algebraic equations of the
c     form G(X,Y,YPRIME) = 0 for the unknown parts of Y and YPRIME in
c     the initial conditions.
c
c     The method used is a Newton scheme combined with a linesearch
c     algorithm, using Krylov iterative linear system methods.
c
c     The parameters represent
c
c     X         -- Independent variable.
c     Y         -- Solution vector.
c     YPRIME    -- Derivative of solution vector.
c     NEQ       -- Number of unknowns.
c     ICOPT     -- Initial condition option chosen (1 or 2).
c     ID        -- Array of dimension NEQ, which must be initialized
c                  if ICOPT = 1.  See SDASIC.
c     RES       -- External user-supplied subroutine
c                  to evaluate the residual.  See RES description
c                  in SDASPK prologue.
c     PSOL      -- External user-supplied routine to solve
c                  a linear system using preconditioning.
c                  See explanation inside SDASPK.
c     WT        -- Vector of weights for error criterion.
c     RPAR,IPAR -- Real and integer arrays used for communication
c                  between the calling program and external user
c                  routines.  They are not altered within DASPK.
c     SAVR      -- Work vector for SNSIK of length NEQ.
c     DELTA     -- Residual vector on entry, and work vector of
c                  length NEQ for SNSIK.
c     R         -- Work vector for SNSIK of length NEQ.
c     YIC,YPIC  -- Work vectors for SNSIK, each of length NEQ.
c     PWK       -- Work vector for SNSIK of length NEQ.
c     WM,IWM    -- Real and integer arrays storing
c                  matrix information such as the matrix
c                  of partial derivatives, permutation
c                  vector, and various other information.
c     CJ        -- Matrix parameter = 1/H (ICOPT = 1) or 0 (ICOPT = 2).
c     SQRTN     -- Square root of NEQ.
c     RSQRTN    -- reciprical of square root of NEQ.
c     EPLIN     -- Tolerance for linear system solver.
c     EPCON     -- Tolerance to test for convergence of the Newton
c                  iteration.
c     RATEMX    -- Maximum convergence rate for which Newton iteration
c                  is considered converging.
c     MAXIT     -- Maximum allowed number of Newton iterations.
c     STPTOL    -- Tolerance used in calculating the minimum lambda
c                  value allowed.
c     ICNFLG    -- Integer scalar.  If nonzero, then constraint
c                  violations in the proposed new approximate solution
c                  will be checked for, and the maximum step length
c                  will be adjusted accordingly.
c     ICNSTR    -- Integer array of length NEQ containing flags for
c                  checking constraints.
c     IERNEW    -- Error flag for Newton iteration.
c                   0  ==> Newton iteration converged.
c                   1  ==> failed to converge, but RATE .lt. 1.
c                   2  ==> failed to converge, RATE .gt. RATEMX.
c                   3  ==> other recoverable error.
c                  -1  ==> unrecoverable error inside Newton iteration.
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED
c   SFNRMK, SSLVK, SDWNRM, SLINSK, SCOPY
c
c***END PROLOGUE  SNSIK
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER LNNI,LNPS,LLOCWP,LLCIWP,LLSOFF,LSTOL,LSOFF,IWM,M, LWP,LIWP
     &   ,IER,IERNEW,IRES,IERSL,IRET,MAXIT,ICNSTR,ID, ICNFLG,ICOPT,IPAR,
     &   NEQ
      DIMENSION Y(*),YPRIME(*),WT(*),ID(*),DELTA(*),R(*),SAVR(*)
      DIMENSION YIC(*),YPIC(*),PWK(*),WM(*),IWM(*), RPAR(*),IPAR(*)
      DIMENSION ICNSTR(*)
      EXTERNAL RES, PSOL
c
      PARAMETER (LNNI=19, LNPS=21, LLOCWP=29, LLCIWP=30)
      PARAMETER (LLSOFF=35, LSTOL=14)
c
c
c     Initializations.  M is the Newton iteration counter.
c
      LSOFF = IWM(LLSOFF)
      M = 0
      RATE = 1.0d0
      LWP = IWM(LLOCWP)
      LIWP = IWM(LLCIWP)
      RLX = 0.4d0
c
c     Save residual in SAVR.
c
      CALL dcopy_u(NEQ, DELTA, 1, SAVR, 1)
c
c     Compute norm of (P-inverse)*(residual).
c
      CALL SFNRMK (NEQ, Y, X, YPRIME, SAVR, R, CJ, WT, SQRTN, RSQRTN, 
     &   RES, IRES, PSOL, 1, IER, FNRM, EPLIN, WM(LWP), IWM(LIWP), PWK, 
     &   RPAR, IPAR)
      IWM(LNPS) = IWM(LNPS) + 1
      IF (IER .NE. 0) THEN
      IERNEW = 3
      RETURN
      ENDIF
c
c     Return now if residual norm is .le. EPCON.
c
      IF (FNRM .LE. EPCON) RETURN
c
c     Newton iteration loop.
c
  300 CONTINUE
      IWM(LNNI) = IWM(LNNI) + 1
c
c     Compute a new step vector DELTA.
c
      CALL SSLVK (NEQ, Y, X, YPRIME, SAVR, DELTA, WT, WM, IWM, RES, IRES
     &   , PSOL, IERSL, CJ, EPLIN, SQRTN, RSQRTN, RHOK, RPAR, IPAR)
      IF (IRES .NE. 0 .OR. IERSL .NE. 0) GO TO 390
c
c     Get norm of DELTA.  Return now if DELTA is zero.
c
      DELNRM = SDWNRM(NEQ,DELTA,WT,RPAR,IPAR)
      IF (DELNRM .EQ. 0.0d0) RETURN
c
c     Call linesearch routine for global strategy and set RATE.
c
      OLDFNM = FNRM
c
      CALL SLINSK (NEQ, Y, X, YPRIME, SAVR, CJ, DELTA, DELNRM, WT, SQRTN
     &   , RSQRTN, LSOFF, STPTOL, IRET, RES, IRES, PSOL, WM, IWM, RHOK, 
     &   FNRM, ICOPT, ID, WM(LWP), IWM(LIWP), R, EPLIN, YIC, YPIC, PWK, 
     &   ICNFLG, ICNSTR, RLX, RPAR, IPAR)
c
      RATE = FNRM/OLDFNM
c
c     Check for error condition from linesearch.
      IF (IRET .NE. 0) GO TO 390
c
c     Test for convergence of the iteration, and return or loop.
c
      IF (FNRM .LE. EPCON) RETURN
c
c     The iteration has not yet converged.  Update M.
c     Test whether the maximum number of iterations have been tried.
c
      M=M+1
      IF(M .GE. MAXIT) GO TO 380
c
c     Copy the residual SAVR to DELTA and loop for another iteration.
c
      CALL dcopy_u(NEQ, SAVR, 1, DELTA, 1)
      GO TO 300
c
c     The maximum number of iterations was done.  Set IERNEW and return.
c
  380 IF (RATE .LE. RATEMX) THEN
      IERNEW = 1
      ELSE
      IERNEW = 2
      ENDIF
      RETURN
c
  390 IF (IRES .LE. -2 .OR. IERSL .LT. 0) THEN
      IERNEW = -1
      ELSE
      IERNEW = 3
      IF (IRES .EQ. 0 .AND. IERSL .EQ. 1 .AND. M .GE. 2 .AND. RATE .LT. 
     &   1.0d0) IERNEW = 1
      ENDIF
      RETURN
c
c
c----------------------- END OF SUBROUTINE SNSIK------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SLINSK (NEQ, Y, T, YPRIME, SAVR, CJ, P, PNRM, WT, SQRTN
     &   , RSQRTN, LSOFF, STPTOL, IRET, RES, IRES, PSOL, WM, IWM, RHOK, 
     &   FNRM, ICOPT, ID, WP, IWP, R, EPLIN, YNEW, YPNEW, PWK, ICNFLG, 
     &   ICNSTR, RLX, RPAR, IPAR)
c
c***BEGIN PROLOGUE  SLINSK
c***REFER TO  SNSIK
c***DATE WRITTEN   940830   (YYMMDD)
c***REVISION DATE  951006   (Arguments SQRTN, RSQRTN added.)
c***REVISION DATE  960401   (Moved RL = ONE line to beginning.)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SLINSK uses a linesearch algorithm to calculate a new (Y,YPRIME)
c     pair (YNEW,YPNEW) such that
c
c     f(YNEW,YPNEW) .le. (1 - 2*ALPHA*RL)*f(Y,YPRIME) +
c                          ALPHA*RL*RHOK*RHOK ,
c
c     where 0 < RL <= 1, and RHOK is the scaled preconditioned norm of
c     the final residual vector in the Krylov iteration.
c     Here, f(y,y') is defined as
c
c      f(y,y') = (1/2)*norm( (P-inverse)*G(t,y,y') )**2 ,
c
c     where norm() is the weighted RMS vector norm, G is the DAE
c     system residual function, and P is the preconditioner used
c     in the Krylov iteration.
c
c     In addition to the parameters defined elsewhere, we have
c
c     SAVR    -- Work array of length NEQ, containing the residual
c                vector G(t,y,y') on return.
c     P       -- Approximate Newton step used in backtracking.
c     PNRM    -- Weighted RMS norm of P.
c     LSOFF   -- Flag showing whether the linesearch algorithm is
c                to be invoked.  0 means do the linesearch,
c                1 means turn off linesearch.
c     STPTOL  -- Tolerance used in calculating the minimum lambda
c                value allowed.
c     ICNFLG  -- Integer scalar.  If nonzero, then constraint violations
c                in the proposed new approximate solution will be
c                checked for, and the maximum step length will be
c                adjusted accordingly.
c     ICNSTR  -- Integer array of length NEQ containing flags for
c                checking constraints.
c     RHOK    -- Weighted norm of preconditioned Krylov residual.
c     RLX     -- Real scalar restricting update size in SCNSTR.
c     YNEW    -- Array of length NEQ used to hold the new Y in
c                performing the linesearch.
c     YPNEW   -- Array of length NEQ used to hold the new YPRIME in
c                performing the linesearch.
c     PWK     -- Work vector of length NEQ for use in PSOL.
c     Y       -- Array of length NEQ containing the new Y (i.e.,=YNEW).
c     YPRIME  -- Array of length NEQ containing the new YPRIME
c                (i.e.,=YPNEW).
c     FNRM    -- Real scalar containing SQRT(2*f(Y,YPRIME)) for the
c                current (Y,YPRIME) on input and output.
c     R       -- Work space length NEQ for residual vector.
c     IRET    -- Return flag.
c                IRET=0 means that a satisfactory (Y,YPRIME) was found.
c                IRET=1 means that the routine failed to find a new
c                       (Y,YPRIME) that was sufficiently distinct from
c                       the current (Y,YPRIME) pair.
c                IRET=2 means a failure in RES or PSOL.
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED
c   SFNRMK, SYYPNW, SCOPY
c
c***END PROLOGUE  SLINSK
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER LNRE,LNPS,LKPRIN,KPRIN,IWM,IVIO,ICNFLG,IRET,I, NEQ,LSOFF,
     &   IRES,IER,ICNSTR,IVAR,ID,ICOPT,IPAR,IWP
      EXTERNAL RES, PSOL
      DIMENSION Y(*), YPRIME(*), P(*), WT(*), SAVR(*), R(*), ID(*)
      DIMENSION WM(*), IWM(*), YNEW(*), YPNEW(*), PWK(*), ICNSTR(*)
      DIMENSION WP(*), IWP(*), RPAR(*), IPAR(*)
      CHARACTER MSG*80
c
      PARAMETER (LNRE=12, LNPS=21, LKPRIN=31)
c
      SAVE ALPHA, ONE, TWO
      DATA ALPHA/1.0d-4/, ONE/1.0d0/, TWO/2.0d0/
c
c-----------------------------------------------------------------------
c  Declarations necessary to kaboom out while running 9/25/95
      character*80 msgjm
      integer nrcv, ierrjm, ijmgetmr, imxer2, imxer3
c------------------------------------------------------------------------

      KPRIN=IWM(LKPRIN)
      F1NRM = (FNRM*FNRM)/TWO
      RATIO = ONE
      RL = ONE
c
      IF (KPRIN .GE. 2) THEN
      MSG = '------ IN ROUTINE SLINSK-- PNRM = (R1) )'
      CALL dxerrwv_u(MSG, 40, 921, 0, 0, 0, 0, 1, PNRM, 0.0d0)
      ENDIF
      TAU = PNRM
      IVIO = 0
c-----------------------------------------------------------------------
c Check for violations of the contraints, if any are imposed.
c If any violations are found, the step vector P is rescaled, and the
c constraint check is repeated, until no violations are found.
c-----------------------------------------------------------------------
      IF (ICNFLG .NE. 0) THEN
   10 CONTINUE
      CALL SYYPNW (NEQ,Y,YPRIME,CJ,RL,P,ICOPT,ID,YNEW,YPNEW)
      CALL SCNSTR (NEQ, Y, YNEW, ICNSTR, TAU, RLX, IRET, IVAR)
      IF (IRET .EQ. 1) THEN
      IVIO = 1
      RATIO1 = TAU/PNRM
      RATIO = RATIO*RATIO1
      DO 20 I = 1,NEQ
   20 P(I) = P(I)*RATIO1
      PNRM = TAU
      IF (KPRIN .GE. 2) THEN
      MSG = '------ CONSTRAINT VIOL., PNRM = (R1), INDEX = (I1)'
      CALL dxerrwv_u(MSG, 50, 922, 0, 1, IVAR, 0, 1, PNRM, 0.0d0)
      ENDIF
      IF (PNRM .LE. STPTOL) THEN
      IRET = 1
      RETURN
      ENDIF
      GO TO 10
      ENDIF
      ENDIF
c
      SLPI = (-TWO*F1NRM + RHOK*RHOK)*RATIO
      RLMIN = STPTOL/PNRM
      IF (LSOFF .EQ. 0 .AND. KPRIN .GE. 2) THEN
      MSG = '------ MIN. LAMBDA = (R1)'
      CALL dxerrwv_u(MSG, 25, 923, 0, 0, 0, 0, 1, RLMIN, 0.0d0)
      ENDIF
c-----------------------------------------------------------------------
c Begin iteration to find RL value satisfying alpha-condition.
c Update YNEW and YPNEW, then compute norm of new scaled residual and
c perform alpha condition test.
c-----------------------------------------------------------------------
  100 CONTINUE
      CALL SYYPNW (NEQ,Y,YPRIME,CJ,RL,P,ICOPT,ID,YNEW,YPNEW)
      CALL SFNRMK (NEQ, YNEW, T, YPNEW, SAVR, R, CJ, WT, SQRTN, RSQRTN, 
     &   RES, IRES, PSOL, 0, IER, FNRMP, EPLIN, WP, IWP, PWK, RPAR, IPAR
     &   )
      IWM(LNRE) = IWM(LNRE) + 1
      IF (IRES .GE. 0) IWM(LNPS) = IWM(LNPS) + 1
      IF (IRES .NE. 0 .OR. IER .NE. 0) THEN
      IRET = 2
      RETURN
      ENDIF
      IF (LSOFF .EQ. 1) GO TO 150
c
      F1NRMP = FNRMP*FNRMP/TWO
      IF (KPRIN .GE. 2) THEN
      MSG = '------ LAMBDA = (R1)'
      CALL dxerrwv_u(MSG, 20, 924, 0, 0, 0, 0, 1, RL, 0.0d0)
      MSG = '------ NORM(F1) = (R1),  NORM(F1NEW) = (R2)'
      CALL dxerrwv_u(MSG, 43, 925, 0, 0, 0, 0, 2, F1NRM, F1NRMP)
      ENDIF
      IF (F1NRMP .GT. F1NRM + ALPHA*SLPI*RL) GO TO 200
c-----------------------------------------------------------------------
c Alpha-condition is satisfied, or linesearch is turned off.
c Copy YNEW,YPNEW to Y,YPRIME and return.
c-----------------------------------------------------------------------
  150 IRET = 0
      CALL dcopy_u(NEQ, YNEW, 1, Y, 1)
      CALL dcopy_u(NEQ, YPNEW, 1, YPRIME, 1)
      FNRM = FNRMP
      IF (KPRIN .GE. 1) THEN
      MSG = '------ LEAVING ROUTINE SLINSK, FNRM = (R1)'
      CALL dxerrwv_u(MSG, 42, 926, 0, 0, 0, 0, 1, FNRM, 0.0d0)
      ENDIF
c--------------------------------------------------------------------------
c     Special error message section to kaboom out: 9/25/95
ccc      ierrjm = ijmgetmr(msgjm,80,1,nrcv)
ccc      if (ierrjm .eq. 0) then
ccc         if(msgjm(1:nrcv).eq.'kaboom' .or. msgjm(1:nrcv).eq.'k') then
ccc            call xerrab("")
ccc         endif
ccc      endif

      RETURN
c-----------------------------------------------------------------------
c Alpha-condition not satisfied.  Perform backtrack to compute new RL
c value.  If RL is less than RLMIN, i.e. no satisfactory YNEW,YPNEW can
c be found sufficiently distinct from Y,YPRIME, then return IRET = 1.
c-----------------------------------------------------------------------
  200 CONTINUE
      IF (RL .LT. RLMIN) THEN
      IRET = 1
      RETURN
      ENDIF
c
      RL = RL/TWO
      GO TO 100
c
c----------------------- END OF SUBROUTINE SLINSK ----------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SFNRMK (NEQ, Y, T, YPRIME, SAVR, R, CJ, WT, SQRTN, 
     &   RSQRTN, RES, IRES, PSOL, IRIN, IER, FNORM, EPLIN, WP, IWP, PWK, 
     &   RPAR, IPAR)
c
c***BEGIN PROLOGUE  SFNRMK
c***REFER TO  SLINSK
c***DATE WRITTEN   940830   (YYMMDD)
c***REVISION DATE  951006   (SQRTN, RSQRTN, and scaling of WT added.)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SFNRMK calculates the scaled preconditioned norm of the nonlinear
c     function used in the nonlinear iteration for obtaining consistent
c     initial conditions.  Specifically, SFNRMK calculates the weighted
c     root-mean-square norm of the vector (P-inverse)*G(T,Y,YPRIME),
c     where P is the preconditioner matrix.
c
c     In addition to the parameters described in the calling program
c     SLINSK, the parameters represent
c
c     IRIN   -- Flag showing whether the current residual vector is
c               input in SAVR.  1 means it is, 0 means it is not.
c     R      -- Array of length NEQ that contains
c               (P-inverse)*G(T,Y,YPRIME) on return.
c     FNORM  -- Scalar containing the weighted norm of R on return.
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED
c   RES, SCOPY, SSCAL, PSOL, SDWNRM
c
c***END PROLOGUE  SFNRMK
c
c
      IMPLICIT doubleprecision (A-H,O-Z)
      INTEGER IRIN,IRES,IER,IWP,IPAR,NEQ
      EXTERNAL RES, PSOL
      DIMENSION Y(*), YPRIME(*), WT(*), SAVR(*), R(*), PWK(*)
      DIMENSION WP(*), IWP(*), RPAR(*), IPAR(*)
c-----------------------------------------------------------------------
c     Call RES routine if IRIN = 0.
c-----------------------------------------------------------------------
      IF (IRIN .EQ. 0) THEN
      IRES = 0
      CALL RES (T, Y, YPRIME, CJ, SAVR, IRES, RPAR, IPAR)
      IF (IRES .LT. 0) RETURN
      ENDIF
c-----------------------------------------------------------------------
c     Apply inverse of left preconditioner to vector R.
c     First scale WT array by 1/sqrt(N), and undo scaling afterward.
c-----------------------------------------------------------------------
      CALL dcopy_u(NEQ, SAVR, 1, R, 1)
      CALL dscal_u(NEQ, RSQRTN, WT, 1)
      IER = 0
      CALL PSOL (NEQ, T, Y, YPRIME, SAVR, PWK, CJ, WT, WP, IWP, R, EPLIN
     &   , IER, RPAR, IPAR)
      CALL dscal_u(NEQ, SQRTN, WT, 1)
      IF (IER .NE. 0) RETURN
c-----------------------------------------------------------------------
c     Calculate norm of R.
c-----------------------------------------------------------------------
      FNORM = SDWNRM (NEQ, R, WT, RPAR, IPAR)
c
      RETURN
c----------------------- END OF SUBROUTINE SFNRMK ----------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SNEDK(X,Y,YPRIME,NEQ,RES,JACK,PSOL, H,WT,JSTART,IDID,
     &   RPAR,IPAR,PHI,GAMMA,SAVR,DELTA,E, WM,IWM,CJ,CJOLD,CJLAST,S,
     &   UROUND,EPLI,SQRTN,RSQRTN, EPCON,JCALC,JFLG,KP1,NONNEG,NTYPE,
     &   IERNLS)
c
c***BEGIN PROLOGUE  SNEDK
c***REFER TO  SDASPK
c***DATE WRITTEN   891219   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***REVISION DATE  940701   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SNEDK solves a nonlinear system of
c     algebraic equations of the form
c     G(X,Y,YPRIME) = 0 for the unknown Y.
c
c     The method used is a matrix-free Newton scheme.
c
c     The parameters represent
c     X         -- Independent variable.
c     Y         -- Solution vector at x.
c     YPRIME    -- Derivative of solution vector
c                  after successful step.
c     NEQ       -- Number of equations to be integrated.
c     RES       -- External user-supplied subroutine
c                  to evaluate the residual.  See RES description
c                  in SDASPK prologue.
c     JACK     --  External user-supplied routine to update
c                  the preconditioner.  (This is optional).
c                  See JAC description for the case
c                  INFO(12) = 1 in the SDASPK prologue.
c     PSOL      -- External user-supplied routine to solve
c                  a linear system using preconditioning.
c                  (This is optional).  See explanation inside SDASPK.
c     H         -- Appropriate step size for this step.
c     WT        -- Vector of weights for error criterion.
c     JSTART    -- Indicates first call to this routine.
c                  If JSTART = 0, then this is the first call,
c                  otherwise it is not.
c     IDID      -- Completion flag, output by SNEDK.
c                  See IDID description in SDASPK prologue.
c     RPAR,IPAR -- Real and integer arrays used for communication
c                  between the calling program and external user
c                  routines.  They are not altered within DASPK.
c     PHI       -- Array of divided differences used by
c                  SNEDK.  The length is NEQ*(K+1), where
c                  K is the maximum order.
c     GAMMA     -- Array used to predict Y and YPRIME.  The length
c                  is K+1, where K is the maximum order.
c     SAVR      -- Work vector for SNEDK of length NEQ.
c     DELTA     -- Work vector for SNEDK of length NEQ.
c     E         -- Error accumulation vector for SNEDK of length NEQ.
c     WM,IWM    -- Real and integer arrays storing
c                  matrix information for linear system
c                  solvers, and various other information.
c     CJ        -- Parameter always proportional to 1/H.
c     CJOLD     -- Saves the value of CJ as of the last call to DITMD.
c                  Accounts for changes in CJ needed to
c                  decide whether to call DITMD.
c     CJLAST    -- Previous value of CJ.
c     S         -- A scalar determined by the approximate rate
c                  of convergence of the Newton iteration and used
c                  in the convergence test for the Newton iteration.
c
c                  If RATE is defined to be an estimate of the
c                  rate of convergence of the Newton iteration,
c                  then S = RATE/(1.E0-RATE).
c
c                  The closer RATE is to 0., the faster the Newton
c                  iteration is converging; the closer RATE is to 1.,
c                  the slower the Newton iteration is converging.
c
c                  On the first Newton iteration with an up-dated
c                  preconditioner S = 100.E0, Thus the initial
c                  RATE of convergence is approximately 1.
c
c                  S is preserved from call to call so that the rate
c                  estimate from a previous step can be applied to
c                  the current step.
c     UROUND    -- Unit roundoff.
c     EPLI      -- convergence test constant.
c                  See SDASPK prologue for more details.
c     SQRTN     -- Square root of NEQ.
c     RSQRTN    -- reciprical of square root of NEQ.
c     EPCON     -- Tolerance to test for convergence of the Newton
c                  iteration.
c     JCALC     -- Flag used to determine when to update
c                  the Jacobian matrix.  In general:
c
c                  JCALC = -1 ==> Call the DITMD routine to update
c                                 the Jacobian matrix.
c                  JCALC =  0 ==> Jacobian matrix is up-to-date.
c                  JCALC =  1 ==> Jacobian matrix is out-dated,
c                                 but DITMD will not be called unless
c                                 JCALC is set to -1.
c     JFLG      -- Flag showing whether a Jacobian routine is supplied.
c     KP1       -- The current order + 1;  updated across calls.
c     NONNEG    -- Flag to determine nonnegativity constraints.
c     NTYPE     -- Identification code for the SNEDK routine.
c                   1 ==> modified Newton; iterative linear solver.
c                   2 ==> modified Newton; user-supplied linear solver.
c     IERNLS    -- Error flag for nonlinear solver.
c                   0 ==> nonlinear solver converged.
c                   1 ==> recoverable error inside non-linear solver.
c                  -1 ==> unrecoverable error inside non-linear solver.
c
c     The following group of variables are passed as arguments to
c     the Newton iteration solver.  They are explained in greater detail
c     in SNSK:
c        TOLNEW, MULDEL, MAXIT, IERNEW
c
c     IERTYP -- Flag which tells whether this subroutine is correct.
c               0 ==> correct subroutine.
c               1 ==> incorrect subroutine.
c
c-----------------------------------------------------------------------
c***ROUTINES CALLED
c   RES, JACK, SDWNRM, SNSK
c
c***END PROLOGUE  SNEDK
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER NEQ,LNRE,LNJE,LLOCWP,LLCIWP,IERTYP,NTYPE,JSTART,JCALC, 
     &   IERNLS,LWP,IWM,LIWP,JFLG,IERPJ,IRES,IERSL,IERNEW,I,J,KP1, 
     &   MULDEL,MAXIT,NONNEG,IDID,IPAR

      DIMENSION Y(*),YPRIME(*),WT(*)
      DIMENSION PHI(NEQ,*),SAVR(*),DELTA(*),E(*)
      DIMENSION WM(*),IWM(*)
      DIMENSION GAMMA(*),RPAR(*),IPAR(*)
      EXTERNAL RES, JACK, PSOL
c
      PARAMETER (LNRE=12, LNJE=13, LLOCWP=29, LLCIWP=30)
c
      SAVE MULDEL, MAXIT, XRATE
      DATA MULDEL/0/, MAXIT/4/, XRATE/0.25d0/
c
c     Verify that this is the correct subroutine.
c
      IERTYP = 0
      IF (NTYPE .NE. 1) THEN
      IERTYP = 1
      GO TO 380
      ENDIF
c
c     If this is the first step, perform initializations.
c
      IF (JSTART .EQ. 0) THEN
      CJOLD = CJ
      JCALC = -1
      S = 100.d0
      ENDIF
c
c     Perform all other initializations.
c
      IERNLS = 0
      LWP = IWM(LLOCWP)
      LIWP = IWM(LLCIWP)
c
c     Decide whether to update the preconditioner.
c
      IF (JFLG .NE. 0) THEN
      TEMP1 = (1.0d0 - XRATE)/(1.0d0 + XRATE)
      TEMP2 = 1.0d0/TEMP1
      IF (CJ/CJOLD .LT. TEMP1 .OR. CJ/CJOLD .GT. TEMP2) JCALC = -1
      IF (CJ .NE. CJLAST) S = 100.d0
      ELSE
      JCALC = 0
      ENDIF
c
c     Looping point for updating preconditioner with current stepsize.
c
  300 CONTINUE
c
c     Initialize all error flags to zero.
c
      IERPJ = 0
      IRES = 0
      IERSL = 0
      IERNEW = 0
c
c     Predict the solution and derivative and compute the tolerance
c     for the Newton iteration.
c
      DO 310 I=1,NEQ
      Y(I)=PHI(I,1)
  310 YPRIME(I)=0.0d0
      DO 330 J=2,KP1
      DO 320 I=1,NEQ
      Y(I)=Y(I)+PHI(I,J)
  320 YPRIME(I)=YPRIME(I)+GAMMA(J)*PHI(I,J)
  330 CONTINUE
      EPLIN = EPLI*EPCON
      TOLNEW = EPLIN
c
c     Call RES to initialize DELTA.
c
      IWM(LNRE)=IWM(LNRE)+1
      CALL RES(X,Y,YPRIME,CJ,DELTA,IRES,RPAR,IPAR)
      IF (IRES .LT. 0) GO TO 380
c
c
c     If indicated, update the preconditioner.
c     Set JCALC to 0 as an indicator that this has been done.
c
      IF(JCALC .EQ. -1)THEN
      IWM(LNJE) = IWM(LNJE) + 1
      JCALC=0
      CALL JACK (RES, IRES, NEQ, X, Y, YPRIME, WT, DELTA, E, H, CJ, WM(
     &   LWP), IWM(LIWP), IERPJ, RPAR, IPAR)
      CJOLD=CJ
      S = 100.d0
      IF (IRES .LT. 0) GO TO 380
      IF (IERPJ .NE. 0) GO TO 380
      ENDIF
c
c     Call the nonlinear Newton solver.
c
      CALL SNSK(X,Y,YPRIME,NEQ,RES,PSOL,WT,RPAR,IPAR,SAVR, DELTA,E,WM,
     &   IWM,CJ,SQRTN,RSQRTN,EPLIN,EPCON, S,TEMP1,TOLNEW,MULDEL,MAXIT,
     &   IRES,IERSL,IERNEW)
c
      IF (IERNEW .GT. 0 .AND. JCALC .NE. 0) THEN
c
c     The Newton iteration had a recoverable failure with an old
c     preconditioner.  Retry the step with a new preconditioner.
c
      JCALC = -1
      GO TO 300
      ENDIF
c
      IF (IERNEW .NE. 0) GO TO 380
c
c     The Newton iteration has converged.  If nonnegativity of
c     solution is required, set the solution nonnegative, if the
c     perturbation to do it is small enough.  If the change is too
c     large, then consider the corrector iteration to have failed.
c
      IF(NONNEG .EQ. 0) GO TO 390
      DO 360 I = 1,NEQ
  360 DELTA(I) = MIN(Y(I),0.0d0)
      DELNRM = SDWNRM(NEQ,DELTA,WT,RPAR,IPAR)
      IF(DELNRM .GT. EPCON) GO TO 380
      DO 370 I = 1,NEQ
  370 E(I) = E(I) - DELTA(I)
      GO TO 390
c
c
c     Exits from nonlinear solver.
c     No convergence with current preconditioner.
c     Compute IERNLS and IDID accordingly.
c
  380 CONTINUE
      IF (IRES .LE. -2 .OR. IERSL .LT. 0 .OR. IERTYP .NE. 0) THEN
      IERNLS = -1
      IF (IRES .LE. -2) IDID = -11
      IF (IERSL .LT. 0) IDID = -13
      IF (IERTYP .NE. 0) IDID = -15
      ELSE
      IERNLS = 1
      IF (IRES .EQ. -1) IDID = -10
      IF (IERPJ .NE. 0) IDID = -5
      IF (IERSL .GT. 0) IDID = -14
      ENDIF
c
c
  390 JCALC = 1
      RETURN
c
c------END OF SUBROUTINE SNEDK------------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SNSK(X,Y,YPRIME,NEQ,RES,PSOL,WT,RPAR,IPAR, SAVR,DELTA,E
     &   ,WM,IWM,CJ,SQRTN,RSQRTN,EPLIN,EPCON, S,CONFAC,TOLNEW,MULDEL,
     &   MAXIT,IRES,IERSL,IERNEW)
c
c***BEGIN PROLOGUE  SNSK
c***REFER TO  SDASPK
c***DATE WRITTEN   891219   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***REVISION DATE  950126   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c     SNSK solves a nonlinear system of
c     algebraic equations of the form
c     G(X,Y,YPRIME) = 0 for the unknown Y.
c
c     The method used is a modified Newton scheme.
c
c     The parameters represent
c
c     X         -- Independent variable.
c     Y         -- Solution vector.
c     YPRIME    -- Derivative of solution vector.
c     NEQ       -- Number of unknowns.
c     RES       -- External user-supplied subroutine
c                  to evaluate the residual.  See RES description
c                  in SDASPK prologue.
c     PSOL      -- External user-supplied routine to solve
c                  a linear system using preconditioning.
c                  See explanation inside SDASPK.
c     WT        -- Vector of weights for error criterion.
c     RPAR,IPAR -- Real and integer arrays used for communication
c                  between the calling program and external user
c                  routines.  They are not altered within DASPK.
c     SAVR      -- Work vector for SNSK of length NEQ.
c     DELTA     -- Work vector for SNSK of length NEQ.
c     E         -- Error accumulation vector for SNSK of length NEQ.
c     WM,IWM    -- Real and integer arrays storing
c                  matrix information such as the matrix
c                  of partial derivatives, permutation
c                  vector, and various other information.
c     CJ        -- Parameter always proportional to 1/H (step size).
c     SQRTN     -- Square root of NEQ.
c     RSQRTN    -- reciprical of square root of NEQ.
c     EPLIN     -- Tolerance for linear system solver.
c     EPCON     -- Tolerance to test for convergence of the Newton
c                  iteration.
c     S         -- Used for error convergence tests.
c                  In the Newton iteration: S = RATE/(1.E0-RATE),
c                  where RATE is the estimated rate of convergence
c                  of the Newton iteration.
c
c                  The closer RATE is to 0., the faster the Newton
c                  iteration is converging; the closer RATE is to 1.,
c                  the slower the Newton iteration is converging.
c
c                  The calling routine sends the initial value
c                  of S to the Newton iteration.
c     CONFAC    -- A residual scale factor to improve convergence.
c     TOLNEW    -- Tolerance on the norm of Newton correction in
c                  alternative Newton convergence test.
c     MULDEL    -- A flag indicating whether or not to multiply
c                  DELTA by CONFAC.
c                  0  ==> do not scale DELTA by CONFAC.
c                  1  ==> scale DELTA by CONFAC.
c     MAXIT     -- Maximum allowed number of Newton iterations.
c     IRES      -- Error flag returned from RES.  See RES description
c                  in SDASPK prologue.  If IRES = -1, then IERNEW
c                  will be set to 1.
c                  If IRES < -1, then IERNEW will be set to -1.
c     IERSL     -- Error flag for linear system solver.
c                  See IERSL description in subroutine SSLVK.
c                  If IERSL = 1, then IERNEW will be set to 1.
c                  If IERSL < 0, then IERNEW will be set to -1.
c     IERNEW    -- Error flag for Newton iteration.
c                   0  ==> Newton iteration converged.
c                   1  ==> recoverable error inside Newton iteration.
c                  -1  ==> unrecoverable error inside Newton iteration.
c-----------------------------------------------------------------------
c
c***ROUTINES CALLED
c   RES, SSLVK, SDWNRM
c
c***END PROLOGUE  SNSK
c
c
      IMPLICIT doubleprecision(A-H,O-Z)
      INTEGER LNNI,LNRE,M,I,NEQ,IWM,MULDEL,IRES,IERSL,MAXIT, IERNEW,IPAR
      DIMENSION Y(*),YPRIME(*),WT(*),DELTA(*),E(*),SAVR(*)
      DIMENSION WM(*),IWM(*), RPAR(*),IPAR(*)
      EXTERNAL RES, PSOL
c
      PARAMETER (LNNI=19, LNRE=12)
c
c     Initialize Newton counter M and accumulation vector E.
c
      M = 0
      DO 100 I=1,NEQ
  100 E(I) = 0.0d0
c
c     Corrector loop.
c
  300 CONTINUE
      IWM(LNNI) = IWM(LNNI) + 1
c
c     If necessary, multiply residual by convergence factor.
c
      IF (MULDEL .EQ. 1) THEN
      DO 320 I = 1,NEQ
  320 DELTA(I) = DELTA(I) * CONFAC
      ENDIF
c
c     Save residual in SAVR.
c
      DO 340 I = 1,NEQ
  340 SAVR(I) = DELTA(I)
c
c     Compute a new iterate.  Store the correction in DELTA.
c
      CALL SSLVK (NEQ, Y, X, YPRIME, SAVR, DELTA, WT, WM, IWM, RES, IRES
     &   , PSOL, IERSL, CJ, EPLIN, SQRTN, RSQRTN, RHOK, RPAR, IPAR)
      IF (IRES .NE. 0 .OR. IERSL .NE. 0) GO TO 380
c
c     Update Y, E, and YPRIME.
c
      DO 360 I=1,NEQ
      Y(I) = Y(I) - DELTA(I)
      E(I) = E(I) - DELTA(I)
  360 YPRIME(I) = YPRIME(I) - CJ*DELTA(I)
c
c     Test for convergence of the iteration.
c
      DELNRM = SDWNRM(NEQ,DELTA,WT,RPAR,IPAR)
      IF (DELNRM .LE. TOLNEW) GO TO 370
      IF (M .EQ. 0) THEN
      OLDNRM = DELNRM
      ELSE
      RATE = (DELNRM/OLDNRM)**(1.0d0/M)
      IF (RATE .GT. 0.9d0) GO TO 380
      S = RATE/(1.0d0 - RATE)
      ENDIF
      IF (S*DELNRM .LE. EPCON) GO TO 370
c
c     The corrector has not yet converged.  Update M and test whether
c     the maximum number of iterations have been tried.
c
      M = M + 1
      IF (M .GE. MAXIT) GO TO 380
c
c     Evaluate the residual, and go back to do another iteration.
c
      IWM(LNRE) = IWM(LNRE) + 1
      CALL RES(X,Y,YPRIME,CJ,DELTA,IRES,RPAR,IPAR)
      IF (IRES .LT. 0) GO TO 380
      GO TO 300
c
c     The iteration has converged.
c
  370 RETURN
c
c     The iteration has not converged.  Set IERNEW appropriately.
c
  380 CONTINUE
      IF (IRES .LE. -2 .OR. IERSL .LT. 0) THEN
      IERNEW = -1
      ELSE
      IERNEW = 1
      ENDIF
      RETURN
c
c
c------END OF SUBROUTINE SNSK-------------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SSLVK (NEQ, Y, TN, YPRIME, SAVR, X, EWT, WM, IWM, RES, 
     &   IRES, PSOL, IERSL, CJ, EPLIN, SQRTN, RSQRTN, RHOK, RPAR, IPAR)
c
c***BEGIN PROLOGUE  SSLVK
c***REFER TO  SDASPK
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***REVISION DATE  940928   Removed MNEWT and added RHOK in call list.
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c SSLVK uses a restart algorithm and interfaces to SSPIGM for
c the solution of the linear system arising from a Newton iteration.
c
c In addition to variables described elsewhere,
c communication with SSLVK uses the following variables..
c WM    = Real work space containing data for the algorithm
c         (Krylov basis vectors, Hessenberg matrix, etc.).
c IWM   = Integer work space containing data for the algorithm.
c X     = The right-hand side vector on input, and the solution vector
c         on output, of length NEQ.
c IRES  = Error flag from RES.
c IERSL = Output flag ..
c         IERSL =  0 means no trouble occurred (or user RES routine
c                    returned IRES < 0)
c         IERSL =  1 means the iterative method failed to converge
c                    (SSPIGM returned IFLAG > 0.)
c         IERSL = -1 means there was a nonrecoverable error in the
c                    iterative solver, and an error exit will occur.
c-----------------------------------------------------------------------
c***ROUTINES CALLED
c   SSCAL, SCOPY, SSPIGM
c
c***END PROLOGUE  SSLVK
c
      INTEGER NEQ, IWM, IRES, IERSL, IPAR
      INTEGER LNRE,LNCFL,LNLI,LNPS,LLOCWP,LLCIWP,LMITER,LMAXL, LKMP,
     &   LNRMAX,LIWP,LWP,I,NRES
      doubleprecision Y, TN, YPRIME, SAVR, X, EWT, WM, CJ, EPLIN, SQRTN, 
     &   RSQRTN, RHOK, RPAR
      DIMENSION Y(*), YPRIME(*), SAVR(*), X(*), EWT(*), WM(*), IWM(*), 
     &   RPAR(*), IPAR(*)
c
      INTEGER IFLAG, IRST, NRSTS, NRMAX, LR, LDL, LHES, LGMR, LQ, LV, 
     &   LWK, LZ, MAXLP1, NPSL
      INTEGER NLI, NPS, NCFL, NRE, MAXL, KMP, MITER
      EXTERNAL RES, PSOL
c
      PARAMETER (LNRE=12, LNCFL=16, LNLI=20, LNPS=21)
      PARAMETER (LLOCWP=29, LLCIWP=30)
      PARAMETER (LMITER=23, LMAXL=24, LKMP=25, LNRMAX=26)
c
c-----------------------------------------------------------------------
c IRST is set to 1, to indicate restarting is in effect.
c NRMAX is the maximum number of restarts.
c-----------------------------------------------------------------------
      DATA IRST/1/
c
      LIWP = IWM(LLCIWP)
      NLI = IWM(LNLI)
      NPS = IWM(LNPS)
      NCFL = IWM(LNCFL)
      NRE = IWM(LNRE)
      LWP = IWM(LLOCWP)
      MAXL = IWM(LMAXL)
      KMP = IWM(LKMP)
      NRMAX = IWM(LNRMAX)
      MITER = IWM(LMITER)
      IERSL = 0
      IRES = 0
c-----------------------------------------------------------------------
c Use a restarting strategy to solve the linear system
c P*X = -F.  Parse the work vector, and perform initializations.
c Note that zero is the initial guess for X.
c-----------------------------------------------------------------------
      MAXLP1 = MAXL + 1
      LV = 1
      LR = LV + NEQ*MAXL
      LHES = LR + NEQ + 1
      LQ = LHES + MAXL*MAXLP1
      LWK = LQ + 2*MAXL
      LDL = LWK + MIN(1,MAXL-KMP)*NEQ
      LZ = LDL + NEQ
      CALL dscal_u(NEQ, RSQRTN, EWT, 1)
      CALL dcopy_u(NEQ, X, 1, WM(LR), 1)
      DO 110 I = 1,NEQ
  110 X(I) = 0.d0
c-----------------------------------------------------------------------
c Top of loop for the restart algorithm.  Initial pass approximates
c X and sets up a transformed system to perform subsequent restarts
c to update X.  NRSTS is initialized to -1, because restarting
c does not occur until after the first pass.
c Update NRSTS; conditionally copy DL to R; call the SSPIGM
c algorithm to solve A*Z = R;  updated counters;  update X with
c the residual solution.
c Note:  if convergence is not achieved after NRMAX restarts,
c then the linear solver is considered to have failed.
c-----------------------------------------------------------------------
      NRSTS = -1
  115 CONTINUE
      NRSTS = NRSTS + 1
      IF (NRSTS .GT. 0) CALL dcopy_u(NEQ, WM(LDL), 1, WM(LR),1)
      CALL SSPIGM (NEQ, TN, Y, YPRIME, SAVR, WM(LR), EWT, MAXL, MAXLP1, 
     &   KMP, EPLIN, CJ, RES, IRES, NRES, PSOL, NPSL, WM(LZ), WM(LV), WM
     &   (LHES), WM(LQ), LGMR, WM(LWP), IWM(LIWP), WM(LWK), WM(LDL), 
     &   RHOK, IFLAG, IRST, NRSTS, RPAR, IPAR)
      NLI = NLI + LGMR
      NPS = NPS + NPSL
      NRE = NRE + NRES
      DO 120 I = 1,NEQ
  120 X(I) = X(I) + WM(LZ+I-1)
      IF ((IFLAG .EQ. 1) .AND. (NRSTS .LT. NRMAX) .AND. (IRES .EQ. 0)) 
     &   GO TO 115
c-----------------------------------------------------------------------
c The restart scheme is finished.  Test IRES and IFLAG to see if
c convergence was not achieved, and set flags accordingly.
c-----------------------------------------------------------------------
      IF (IRES .LT. 0) THEN
      NCFL = NCFL + 1
      ELSE IF (IFLAG .NE. 0) THEN
      NCFL = NCFL + 1
      IF (IFLAG .GT. 0) IERSL = 1
      IF (IFLAG .LT. 0) IERSL = -1
      ENDIF
c-----------------------------------------------------------------------
c Update IWM with counters, rescale EWT, and return.
c-----------------------------------------------------------------------
      IWM(LNLI) = NLI
      IWM(LNPS) = NPS
      IWM(LNCFL) = NCFL
      IWM(LNRE) = NRE
      CALL dscal_u(NEQ, SQRTN, EWT, 1)
      RETURN
c
c------END OF SUBROUTINE SSLVK------------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SSPIGM (NEQ, TN, Y, YPRIME, SAVR, R, WGHT, MAXL, MAXLP1
     &   , KMP, EPLIN, CJ, RES, IRES, NRE, PSOL, NPSL, Z, V, HES, Q, 
     &   LGMR, WP, IWP, WK, DL, RHOK, IFLAG, IRST, NRSTS, RPAR, IPAR)
c
c***BEGIN PROLOGUE  SSPIGM
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c***REVISION DATE  940927   Removed MNEWT and added RHOK in call list.
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c This routine solves the linear system A * Z = R using a scaled
c preconditioned version of the generalized minimum residual method.
c An initial guess of Z = 0 is assumed.
c
c      On entry
c
c          NEQ = Problem size, passed to PSOL.
c
c           TN = Current Value of T.
c
c            Y = Array Containing current dependent variable vector.
c
c       YPRIME = Array Containing current first derivative of Y.
c
c         SAVR = Array containing current value of G(T,Y,YPRIME).
c
c            R = The right hand side of the system A*Z = R.
c                R is also used as work space when computing
c                the final approximation and will therefore be
c                destroyed.
c                (R is the same as V(*,MAXL+1) in the call to SSPIGM.)
c
c         WGHT = The vector of length NEQ containing the nonzero
c                elements of the diagonal scaling matrix.
c
c         MAXL = The maximum allowable order of the matrix H.
c
c       MAXLP1 = MAXL + 1, used for dynamic dimensioning of HES.
c
c          KMP = The number of previous vectors the new vector, VNEW,
c                must be made orthogonal to.  (KMP .LE. MAXL.)
c
c        EPLIN = Tolerance on residuals R-A*Z in weighted rms norm.
c
c           CJ = Scalar proportional to current value of
c                1/(step size H).
c
c           WK = Real work array used by routine SATV and PSOL.
c
c           DL = Real work array used for calculation of the residual
c                norm RHO when the method is incomplete (KMP.LT.MAXL)
c                and/or when using restarting.
c
c           WP = Real work array used by preconditioner PSOL.
c
c          IWP = Integer work array used by preconditioner PSOL.
c
c         IRST = Method flag indicating if restarting is being
c                performed.  IRST .GT. 0 means restarting is active,
c                while IRST = 0 means restarting is not being used.
c
c        NRSTS = Counter for the number of restarts on the current
c                call to SSPIGM.  If NRSTS .GT. 0, then the residual
c                R is already scaled, and so scaling of R is not
c                necessary.
c
c
c      On Return
c
c         Z    = The final computed approximation to the solution
c                of the system A*Z = R.
c
c         LGMR = The number of iterations performed and
c                the current order of the upper Hessenberg
c                matrix HES.
c
c         NRE  = The number of calls to RES (i.e. SATV)
c
c         NPSL = The number of calls to PSOL.
c
c         V    = The neq by (LGMR+1) array containing the LGMR
c                orthogonal vectors V(*,1) to V(*,LGMR).
c
c         HES  = The upper triangular factor of the QR decomposition
c                of the (LGMR+1) by LGMR upper Hessenberg matrix whose
c                entries are the scaled inner-products of A*V(*,I)
c                and V(*,K).
c
c         Q    = Real array of length 2*MAXL containing the components
c                of the givens rotations used in the QR decomposition
c                of HES.  It is loaded in SHEQR and used in SHELS.
c
c         IRES = Error flag from RES.
c
c           DL = Scaled preconditioned residual,
c                (D-inverse)*(P-inverse)*(R-A*Z). Only loaded when
c                performing restarts of the Krylov iteration.
c
c         RHOK = Weighted norm of final preconditioned residual.
c
c        IFLAG = Integer error flag..
c                0 Means convergence in LGMR iterations, LGMR.LE.MAXL.
c                1 Means the convergence test did not pass in MAXL
c                  iterations, but the new residual norm (RHO) is
c                  .LT. the old residual norm (RNRM), and so Z is
c                  computed.
c                2 Means the convergence test did not pass in MAXL
c                  iterations, new residual norm (RHO) .GE. old residual
c                  norm (RNRM), and the initial guess, Z = 0, is
c                  returned.
c                3 Means there was a recoverable error in PSOL
c                  caused by the preconditioner being out of date.
c               -1 Means there was an unrecoverable error in PSOL.
c
c-----------------------------------------------------------------------
c***ROUTINES CALLED
c   PSOL, SNRM2, SSCAL, SATV, SORTH, SHEQR, SCOPY, SHELS, SAXPY
c
c***END PROLOGUE  SSPIGM
c
      INTEGER NEQ,MAXL,MAXLP1,KMP,IRES,NRE,NPSL,LGMR,IWP, IFLAG,IRST,
     &   NRSTS,IPAR,MAXLM1
      doubleprecision TN,Y,YPRIME,SAVR,R,WGHT,EPLIN,CJ,Z,V,HES,Q,WP,WK, 
     &   DL,RHOK,RPAR
      DIMENSION Y(*), YPRIME(*), SAVR(*), R(*), WGHT(*), Z(*), V(NEQ,*), 
     &   HES(MAXLP1,*), Q(*), WP(*), IWP(*), WK(*), DL(*), RPAR(*), IPAR
     &   (*)
      INTEGER I, IER, INFO, IP1, I2, J, K, LL, LLP1
      doubleprecision RNRM,C,DLNRM,PROD,RHO,S,SNORMW,dnrm2_u,TEM
      EXTERNAL RES, PSOL
c
      IER = 0
      IFLAG = 0
      LGMR = 0
      NPSL = 0
      NRE = 0
c-----------------------------------------------------------------------
c The initial guess for Z is 0.  The initial residual is therefore
c the vector R.  Initialize Z to 0.
c-----------------------------------------------------------------------
      DO 10 I = 1,NEQ
   10 Z(I) = 0.0d0
c-----------------------------------------------------------------------
c Apply inverse of left preconditioner to vector R if NRSTS .EQ. 0.
c Form V(*,1), the scaled preconditioned right hand side.
c-----------------------------------------------------------------------
      IF (NRSTS .EQ. 0) THEN
      CALL PSOL (NEQ, TN, Y, YPRIME, SAVR, WK, CJ, WGHT, WP, IWP, R, 
     &   EPLIN, IER, RPAR, IPAR)
      NPSL = 1
      IF (IER .NE. 0) GO TO 300
      DO 30 I = 1,NEQ
   30 V(I,1) = R(I)*WGHT(I)
      ELSE
      DO 35 I = 1,NEQ
   35 V(I,1) = R(I)
      ENDIF
c-----------------------------------------------------------------------
c Calculate norm of scaled vector V(*,1) and normalize it
c If, however, the norm of V(*,1) (i.e. the norm of the preconditioned
c residual) is .le. EPLIN, then return with Z=0.
c-----------------------------------------------------------------------
      RNRM = dnrm2_u(NEQ, V, 1)
      IF (RNRM .LE. EPLIN) THEN
      RHOK = RNRM
      RETURN
      ENDIF
      TEM = 1.0d0/RNRM
      CALL dscal_u(NEQ, TEM, V(1,1), 1)
c-----------------------------------------------------------------------
c Zero out the HES array.
c-----------------------------------------------------------------------
      DO 65 J = 1,MAXL
      DO 60 I = 1,MAXLP1
   60 HES(I,J) = 0.0d0
   65 CONTINUE
c-----------------------------------------------------------------------
c Main loop to compute the vectors V(*,2) to V(*,MAXL).
c The running product PROD is needed for the convergence test.
c-----------------------------------------------------------------------
      PROD = 1.0d0
      DO 90 LL = 1,MAXL
      LGMR = LL
c-----------------------------------------------------------------------
c Call routine SATV to compute VNEW = ABAR*V(LL), where ABAR is
c the matrix A with scaling and inverse preconditioner factors applied.
c Call routine SORTH to orthogonalize the new vector VNEW = V(*,LL+1).
c call routine SHEQR to update the factors of HES.
c-----------------------------------------------------------------------
      CALL SATV (NEQ, Y, TN, YPRIME, SAVR, V(1,LL), WGHT, Z, RES, IRES, 
     &   PSOL, V(1,LL+1), WK, WP, IWP, CJ, EPLIN, IER, NRE, NPSL, RPAR, 
     &   IPAR)
      IF (IRES .LT. 0) RETURN
      IF (IER .NE. 0) GO TO 300
      CALL SORTH (V(1,LL+1), V, HES, NEQ, LL, MAXLP1, KMP, SNORMW)
      HES(LL+1,LL) = SNORMW
      CALL SHEQR (HES, MAXLP1, LL, Q, INFO, LL)
      IF (INFO .EQ. LL) GO TO 120
c-----------------------------------------------------------------------
c Update RHO, the estimate of the norm of the residual R - A*ZL.
c If KMP .LT. MAXL, then the vectors V(*,1),...,V(*,LL+1) are not
c necessarily orthogonal for LL .GT. KMP.  The vector DL must then
c be computed, and its norm used in the calculation of RHO.
c-----------------------------------------------------------------------
      PROD = PROD*Q(2*LL)
      RHO = ABS(PROD*RNRM)
      IF ((LL.GT.KMP) .AND. (KMP.LT.MAXL)) THEN
      IF (LL .EQ. KMP+1) THEN
      CALL dcopy_u(NEQ, V(1,1), 1, DL, 1)
      DO 75 I = 1,KMP
      IP1 = I + 1
      I2 = I*2
      S = Q(I2)
      C = Q(I2-1)
      DO 70 K = 1,NEQ
   70 DL(K) = S*DL(K) + C*V(K,IP1)
   75 CONTINUE
      ENDIF
      S = Q(2*LL)
      C = Q(2*LL-1)/SNORMW
      LLP1 = LL + 1
      DO 80 K = 1,NEQ
   80 DL(K) = S*DL(K) + C*V(K,LLP1)
      DLNRM = dnrm2_u(NEQ, DL, 1)
      RHO = RHO*DLNRM
      ENDIF
c-----------------------------------------------------------------------
c Test for convergence.  If passed, compute approximation ZL.
c If failed and LL .LT. MAXL, then continue iterating.
c-----------------------------------------------------------------------
      IF (RHO .LE. EPLIN) GO TO 200
      IF (LL .EQ. MAXL) GO TO 100
c-----------------------------------------------------------------------
c Rescale so that the norm of V(1,LL+1) is one.
c-----------------------------------------------------------------------
      TEM = 1.0d0/SNORMW
      CALL dscal_u(NEQ, TEM, V(1,LL+1), 1)
   90 CONTINUE
  100 CONTINUE
      IF (RHO .LT. RNRM) GO TO 150
  120 CONTINUE
      IFLAG = 2
      DO 130 I = 1,NEQ
  130 Z(I) = 0.d0
      RETURN
  150 IFLAG = 1
c-----------------------------------------------------------------------
c The tolerance was not met, but the residual norm was reduced.
c If performing restarting (IRST .gt. 0) calculate the residual vector
c RL and store it in the DL array.  If the incomplete version is
c being used (KMP .lt. MAXL) then DL has already been calculated.
c-----------------------------------------------------------------------
      IF (IRST .GT. 0) THEN
      IF (KMP .EQ. MAXL) THEN
c
c           Calculate DL from the V(I)'s.
c
      CALL dcopy_u(NEQ, V(1,1), 1, DL, 1)
      MAXLM1 = MAXL - 1
      DO 175 I = 1,MAXLM1
      IP1 = I + 1
      I2 = I*2
      S = Q(I2)
      C = Q(I2-1)
      DO 170 K = 1,NEQ
  170 DL(K) = S*DL(K) + C*V(K,IP1)
  175 CONTINUE
      S = Q(2*MAXL)
      C = Q(2*MAXL-1)/SNORMW
      DO 180 K = 1,NEQ
  180 DL(K) = S*DL(K) + C*V(K,MAXLP1)
      ENDIF
c
c        Scale DL by RNRM*PROD to obtain the residual RL.
c
      TEM = RNRM*PROD
      CALL dscal_u(NEQ, TEM, DL, 1)
      ENDIF
c-----------------------------------------------------------------------
c Compute the approximation ZL to the solution.
c Since the vector Z was used as work space, and the initial guess
c of the Newton correction is zero, Z must be reset to zero.
c-----------------------------------------------------------------------
  200 CONTINUE
      LL = LGMR
      LLP1 = LL + 1
      DO 210 K = 1,LLP1
  210 R(K) = 0.0d0
      R(1) = RNRM
      CALL SHELS (HES, MAXLP1, LL, Q, R)
      DO 220 K = 1,NEQ
  220 Z(K) = 0.0d0
      DO 230 I = 1,LL
      CALL daxpy_u(NEQ, R(I), V(1,I), 1, Z, 1)
  230 CONTINUE
      DO 240 I = 1,NEQ
  240 Z(I) = Z(I)/WGHT(I)
c Load RHO into RHOK.
      RHOK = RHO
      RETURN
c-----------------------------------------------------------------------
c This block handles error returns forced by routine PSOL.
c-----------------------------------------------------------------------
  300 CONTINUE
      IF (IER .LT. 0) IFLAG = -1
      IF (IER .GT. 0) IFLAG = 3
c
      RETURN
c
c------END OF SUBROUTINE SSPIGM-----------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SATV (NEQ, Y, TN, YPRIME, SAVR, V, WGHT, YPTEM, RES, 
     &   IRES, PSOL, Z, VTEM, WP, IWP, CJ, EPLIN, IER, NRE, NPSL, RPAR,
     &   IPAR)
c
c***BEGIN PROLOGUE  SATV
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c This routine computes the product
c
c   Z = (D-inverse)*(P-inverse)*(dF/dY)*(D*V),
c
c where F(Y) = G(T, Y, CJ*(Y-A)), CJ is a scalar proportional to 1/H,
c and A involves the past history of Y.  The quantity CJ*(Y-A) is
c an approximation to the first derivative of Y and is stored
c in the array YPRIME.  Note that dF/dY = dG/dY + CJ*dG/dYPRIME.
c
c D is a diagonal scaling matrix, and P is the left preconditioning
c matrix.  V is assumed to have L2 norm equal to 1.
c The product is stored in Z and is computed by means of a
c difference quotient, a call to RES, and one call to PSOL.
c
c      On entry
c
c          NEQ = Problem size, passed to RES and PSOL.
c
c            Y = Array containing current dependent variable vector.
c
c       YPRIME = Array containing current first derivative of y.
c
c         SAVR = Array containing current value of G(T,Y,YPRIME).
c
c            V = Real array of length NEQ (can be the same array as Z).
c
c         WGHT = Array of length NEQ containing scale factors.
c                1/WGHT(I) are the diagonal elements of the matrix D.
c
c        YPTEM = Work array of length NEQ.
c
c         VTEM = Work array of length NEQ used to store the
c                unscaled version of V.
c
c         WP = Real work array used by preconditioner PSOL.
c
c         IWP = Integer work array used by preconditioner PSOL.
c
c           CJ = Scalar proportional to current value of
c                1/(step size H).
c
c
c      On return
c
c            Z = Array of length NEQ containing desired scaled
c                matrix-vector product.
c
c         IRES = Error flag from RES.
c
c          IER = Error flag from PSOL.
c
c         NRE  = The number of calls to RES.
c
c         NPSL = The number of calls to PSOL.
c
c-----------------------------------------------------------------------
c***ROUTINES CALLED
c   RES, PSOL
c
c***END PROLOGUE  SATV
c
      INTEGER NEQ, IRES, IWP, IER, NRE, NPSL, IPAR
      doubleprecision Y, TN, YPRIME, SAVR, V, WGHT, YPTEM, Z, VTEM, WP, 
     &   CJ, RPAR
      DIMENSION Y(*), YPRIME(*), SAVR(*), V(*), WGHT(*), YPTEM(*), Z(*), 
     &   VTEM(*), WP(*), IWP(*), RPAR(*), IPAR(*)
      INTEGER I
      doubleprecision EPLIN
      EXTERNAL RES, PSOL
      doubleprecision scaleps
      common /comsatv/ scaleps
c
      IRES = 0
c-----------------------------------------------------------------------
c Set VTEM = D * V.
c-----------------------------------------------------------------------
      DO 10 I = 1,NEQ
   10 VTEM(I) = V(I)/WGHT(I)
      IER = 0
c-----------------------------------------------------------------------
c Store Y in Z and increment Z by VTEM.
c Store YPRIME in YPTEM and increment YPTEM by VTEM*CJ.
c-----------------------------------------------------------------------
      DO 20 I = 1,NEQ
      YPTEM(I) = YPRIME(I) + VTEM(I)*CJ*scaleps
   20 Z(I) = Y(I) + VTEM(I)*scaleps
c-----------------------------------------------------------------------
c Call RES with incremented Y, YPRIME arguments
c stored in Z, YPTEM.  VTEM is overwritten with new residual.
c-----------------------------------------------------------------------
      CONTINUE
      CALL RES(TN,Z,YPTEM,CJ,VTEM,IRES,RPAR,IPAR)
      NRE = NRE + 1
      IF (IRES .LT. 0) RETURN
c-----------------------------------------------------------------------
c Set Z = (dF/dY) * VBAR using difference quotient.
c (VBAR is old value of VTEM before calling RES)
c-----------------------------------------------------------------------
      DO 70 I = 1,NEQ
   70 Z(I) = (VTEM(I) - SAVR(I))/scaleps
c-----------------------------------------------------------------------
c Apply inverse of left preconditioner to Z.
c-----------------------------------------------------------------------
      CALL PSOL (NEQ, TN, Y, YPRIME, SAVR, YPTEM, CJ, WGHT, WP, IWP, Z, 
     &   EPLIN, IER, RPAR, IPAR)
      NPSL = NPSL + 1
      IF (IER .NE. 0) RETURN
c-----------------------------------------------------------------------
c Apply D-inverse to Z and return.
c-----------------------------------------------------------------------
      DO 90 I = 1,NEQ
   90 Z(I) = Z(I)*WGHT(I)
      RETURN
c
c------END OF SUBROUTINE SATV-------------------------------------------
      END
c Work performed under the auspices of the U.S. Department of Energy
c by Lawrence Livermore National Laboratory under contract number
c W-7405-Eng-48.
c
c Copyright 1995 the Regents of the University of California.
c All rights reserved.
c
      SUBROUTINE SORTH (VNEW, V, HES, N, LL, LDHES, KMP, SNORMW)
c
c***BEGIN PROLOGUE  SORTH
c***DATE WRITTEN   890101   (YYMMDD)
c***REVISION DATE  900926   (YYMMDD)
c
c
c-----------------------------------------------------------------------
c***DESCRIPTION
c
c This routine orthogonalizes the vector VNEW against the previous
c KMP vectors in the V array.  It uses a modified Gram-Schmidt
c orthogonalization procedure with conditional reorthogonalization.
c
c      On entry
c
c         VNEW = The vector of length N containing a scaled product
c                OF The Jacobian and the vector V(*,LL).
c
c         V    = The N x LL array containing the previous LL
c                orthogonal vectors V(*,1) to V(*,LL).
c
c         HES  = An LL x LL upper Hessenberg matrix containing,
c                in HES(I,K), K.LT.LL, scaled inner products of
c                A*V(*,K) and V(*,I).
c
c        LDHES = The leading dimension of the HES array.
c
c         N    = The order of the matrix A, and the length of VNEW.
c
c         LL   = The current order of the matrix HES.
c
c          KMP = The number of previous vectors the new vector VNEW
c                must be made orthogonal to (KMP .LE. MAXL).
c
c
c      On return
c
c         VNEW = The new vector orthogonal to V(*,I0),
c                where I0 = MAX(1, LL-KMP+1).
c
c         HES  = Upper Hessenberg matrix with column LL filled in with
c                scaled inner products of A*V(*,LL) and V(*,I).
c
c       SNORMW = L-2 norm of VNEW.
c
c-----------------------------------------------------------------------
c***ROUTINES CALLED
c   SDOT, SNRM2, SAXPY
c
c***END PROLOGUE  SORTH
c
      INTEGER N, LL, LDHES, KMP
      doubleprecision VNEW, V, HES, SNORMW
      DIMENSION VNEW(*), V(N,*), HES(LDHES,*)
      INTEGER I, I0
      doubleprecision ARG, ddot_u, dnrm2_u, SUMDSQ, TEM, VNRM
c
c-----------------------------------------------------------------------
c Get norm of unaltered VNEW for later use.
c-----------------------------------------------------------------------
      VNRM = dnrm2_u(N, VNEW, 1)
c-----------------------------------------------------------------------
c Do Modified Gram-Schmidt on VNEW = A*V(LL).
c Scaled inner products give new column of HES.
c Projections of earlier vectors are subtracted from VNEW.
c-----------------------------------------------------------------------
      I0 = MAX(1,LL-KMP+1)
      DO 10 I = I0,LL
      HES(I,LL) = ddot_u(N, V(1,I), 1, VNEW, 1)
      TEM = -HES(I,LL)
      CALL daxpy_u(N, TEM, V(1,I), 1, VNEW, 1)
   10 CONTINUE
c-----------------------------------------------------------------------
c Compute SNORMW = norm of VNEW.
c If VNEW is small compared to its input value (in norm), then
c Reorthogonalize VNEW to V(*,1) through V(*,LL).
c Correct if relative correction exceeds 1000*(unit roundoff).
c Finally, correct SNORMW using the dot products involved.
c-----------------------------------------------------------------------
      SNORMW = dnrm2_u(N, VNEW, 1)
      IF (VNRM + 0.001d0*SNORMW .NE. VNRM) RETURN
      SUMDSQ = 0.0d0
      DO 30 I = I0,LL
      TEM = -ddot_u(N, V(1,I), 1, VNEW, 1)
      IF (HES(I,LL) + 0.001d0*TEM .EQ. HES(I,LL)) GO TO 30
      HES(I,LL) = HES(I,LL) - TEM
      CALL daxpy_u(N, TEM, V(1,I), 1, VNEW, 1)
      SUMDSQ = SUMDSQ + TEM**2
   30 CONTINUE
      IF (SUMDSQ .EQ. 0.0d0) RETURN
      ARG = MAX(0.0d0,SNORMW**2 - SUMDSQ)
      SNORMW = SQRT(ARG)
      RETURN
c
c------END OF SUBROUTINE SORTH------------------------------------------
      END
c
c ... subroutines SHEQR and SHELS are now in file svrut3.m
c
      doubleprecision FUNCTION R1MACH8 (IDUM)
      INTEGER IDUM
c-----------------------------------------------------------------------
c THIS ROUTINE COMPUTES THE UNIT ROUNDOFF OF THE MACHINE IN SINGLE
c PRECISION.  THIS IS DEFINED AS THE SMALLEST POSITIVE MACHINE NUMBER
c U SUCH THAT  1.0E0 + U .NE. 1.0E0 (IN SINGLE PRECISION).
c-----------------------------------------------------------------------
      doubleprecision U, COMP
      U = 1.0d0
   10 U = U*0.5d0
      COMP = 1.0d0 + U
      IF (COMP .NE. 1.0d0) GO TO 10
      R1MACH8 = U*2.0d0
      RETURN
c----------------------- END OF FUNCTION R1MACH8 -----------------------
      END
